Package: metaMS
Type: Package
Title: MS-based metabolomics annotation pipeline
Version: 1.48.0
Authors@R: c(person("Ron", "Wehrens", role = "aut", comment =
        c("author of GC-MS part", "Initial Maintainer"), email = "ron.wehrens@gmail.com"),
        person("Pietro", "Franceschi", role = "aut", comment = "author
        of LC-MS part"), person("Nir", "Shahaf", role = "ctb"),
        person("Matthias", "Scholz", role = "ctb"), person("Georg",
        "Weingart", role = "ctb", comment = "development of GC-MS
        approach"), person("Elisabete", "Carvalho", role = "ctb",
        comment = "testing and feedback of GC-MS pipeline"), person("Yann", "Guitton", role=c("ctb","cre"), email="yann.guitton@gmail.com", comment=c(ORCID = "0000-0002-4479-0636")), person("Julien", "Saint-Vanne", role="ctb"))
Depends: R (>= 4.0), methods, CAMERA, xcms (>= 1.35)
Imports: Matrix, tools, robustbase, BiocGenerics, graphics, stats,
        utils
Suggests: metaMSdata, RUnit
Description: MS-based metabolomics data processing and compound
        annotation pipeline.
URL: https://github.com/yguitton/metaMS
License: GPL (>= 2)
biocViews: ImmunoOncology, MassSpectrometry, Metabolomics
Encoding: UTF-8
RoxygenNote: 7.1.0
git_url: https://git.bioconductor.org/packages/metaMS
git_branch: RELEASE_3_23
git_last_commit: 82c42f6
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:08:59 UTC; biocbuild
Author: Ron Wehrens [aut] (author of GC-MS part, Initial Maintainer),
  Pietro Franceschi [aut] (author of LC-MS part),
  Nir Shahaf [ctb],
  Matthias Scholz [ctb],
  Georg Weingart [ctb] (development of GC-MS approach),
  Elisabete Carvalho [ctb] (testing and feedback of GC-MS pipeline),
  Yann Guitton [ctb, cre] (ORCID:
    <https://orcid.org/0000-0002-4479-0636>),
  Julien Saint-Vanne [ctb]
Maintainer: Yann Guitton <yann.guitton@gmail.com>

# MetaMS

**MetaMS** is a workflow for metabolomics data processing and annotation

## Current Version

### `1.0.0`

### Data input formats

- ANDI NetCDF for GC-MS (.cdf)
- CoreMS self-containing Hierarchical Data Format (.hdf5)
- ChemStation Agilent (Ongoing)

### Data output formats

- Pandas data frame (can be saved using pickle, h5, etc)
- Text Files (.csv, tab separated .txt, etc)
- Microsoft Excel (xlsx)
- JSON for workflow metadata
- Self-containing Hierarchical Data Format (.hdf5) including raw data and ime-series data-point for processed data-sets with all associated metadata stored as json attributes

### Data structure types

- GC-MS

## Available features

### Signal Processing

- Baseline detection, subtraction, smoothing 
- Manual and automatic noise threshold calculation
- First and second derivatives peak picking methods
- Peak Area Calculation
- EIC Chromatogram deconvolution(TODO)

### Calibration

- Retention Index Linear XXX method 

### Compound Identification

- Automatic local (SQLite) or external (MongoDB or PostgreSQL) database check, generation, and search
- Automatic molecular match algorithm with all spectral similarity methods 

## MetaMS Installation

- PyPi:     
```bash
pip3 install metams
```

- From source:
 ```bash
pip3 install --editable .
```

To be able to open chemstation files a installation of pythonnet is needed:
- Windows: 
    ```bash
    pip3 install pythonnet
    ```

- Mac and Linux:
    ```bash
    brew install mono
    pip3 install pythonnet   
    ```

## Usage

```bash
metaMS dump_json_template MetamsFile.json
```
```bash
metaMS dump_corems_json_template CoremsFile.json
```

 Modify the MetamsFile.json and CoremsFile.json accordingly to your dataset and workflow parameters
make sure to include CoremsFile.json path inside the MetamsFile.json: "corems_json_path": "path_to_CoremsFile.json" 

```bash
metaMS run-gcms-workflow path_to_MetamsFile.json
```

## MetaMS Docker 

A docker image containing the MetaMS command line as the entry point

If you don't have docker installed, the easiest way is to [install docker for desktop](https://hub.docker.com/?overlay=onboarding)

- Pull from Docker Registry:

    ```bash
    docker pull corilo/metams:latest
    
    ```

- Build the image from source:

    ```bash
    docker build -t metams:latest .
    ```
- Run Workflow from Container:

    $(data_dir) = dir_containing the gcms data, MetamsFile.json and CoremsFile.json
    
    ```bash
    docker run -v $(data_dir):/metaB/data corilo/metams:latest run-gcms-workflow /metaB/data/MetamsFile.json    
    ```

- Getting the parameters templates:
    
    ```bash
    docker run -v $(data_dir):/metaB/data corilo/metams:latest dump_json_template /metaB/data/MetamsFile.json    
    ```
    
    ```bash
    docker run -v $(data_dir):/metaB/data corilo/metams:latest dump_corems_json_template /metaB/data/CoremsFile.json
    ```
    

## scripts to generate the intermediate GC data from the CDF files of
## metaMSdata. Can be used to re-generate results in case of changes
## to either package.

library(metaMS)
library(metaMSdata)

## ########################################################################
## Creation of the database for annotation
data(threeStdsInfo)
all.files <- list.files(system.file("extdata", package = "metaMSdata"),
                        pattern = "_GC_", full.names = TRUE)
stdInfo[,"stdFile"] <- rep(all.files[3], 3)
data(FEMsettings)    ## provides a.o. TSQXLS.GC, the GC settings file
data(threeStdsNIST)  ## provides object smallDB, excerpt from NIST DB

## Go!
DB <- createSTDdbGC(stdInfo, TSQXLS.GC, extDB = smallDB, nSlaves = 2)
## saved in "threeStdsDB.RData" in the data directory of the metaMS
## package


## ########################################################################
## Creation of GCresults object
data(threeStdsDB) 
data(FEMsettings)

cdfdir <- system.file("extdata", package = "metaMSdata")
cdffiles <- list.files(cdfdir, pattern = "_GC_",
                       full.names = TRUE, ignore.case = TRUE)
GCresults <- runGC(files = cdffiles, settings = TSQXLS.GC, DB = DB,
                   returnXset = TRUE, nSlaves = 2)

## RIstandards is a two-column matrix, column 1 containing the RI, column 2 the corresponding retention time. Only if RI is
## not already there.
addRI <- function(mspobj, RIstandards, isMSP = TRUE) {
    if (isMSP) {
        lapply(mspobj, function(obj) {
            if (is.null(obj$RI)) 
                obj$RI <- round(approx(RIstandards[, "rt"], RIstandards[, "RI"], obj$rt)$y)
            obj
        })
    } else {
        lapply(mspobj, function(obj) {
            cbind(obj, RI = round(approx(RIstandards[, "rt"], RIstandards[, "RI"], obj[, "rt"])$y))
        })
    }
}

## New version, working for both LC and GC, and reading cdf as well as mzxml files

## 1) compare filenames from input file with files in standards dir 2) process all input files in parallel 3) split xset
## object, and loop over all elements separately to keep only retention times close to the manually defined times 4) return
## result

processStandards <- function(stdInfo, settings, polarity = NULL, nSlaves) {
    
    chrom <- metaSetting(settings, "chrom")
    if (chrom == "LC") {
        if (!polarity %in% c("positive", "negative")) {
            stop("For LC data, 'polarity' should either be 'positive' or 'negative'")
        }
    }
    
    stdNames <- sort(unique(stdInfo[, "stdFile"]))
    xset.l <- peakDetection(stdNames, metaSetting(settings, "PeakPicking"), convert2list = TRUE, nSlaves = nSlaves)
    fn <- names(xset.l)
    
    xset.l.small <- lapply(1:length(fn), function(i) {
        standard.hits <- which(stdInfo$stdFile == stdNames[i])
        if (length(standard.hits) == 0) {
            warning("No standard compound from table in file ", fn[i], "...skipping\n")
            
            NULL
        } else {
            standard.info <- stdInfo[standard.hits, ]
            
            rts <- stdInfo[standard.hits, "RTman"]
            rttol <- metaSetting(settings, "DBconstruction")$rttol
            rt.ranges <- cbind(rts - rttol, rts + rttol) * 60
            
            idx <- which(apply(sapply(1:nrow(rt.ranges), function(ii) xset.l[[i]]@peaks[, "rt"] > rt.ranges[ii, 1] & xset.l[[i]]@peaks[, 
                "rt"] < rt.ranges[ii, 2]), 1, any))
            if (length(idx) <= metaSetting(settings, "DBconstruction")$minfeat) {
                warning("No peaks with the right retention time found in file ", fn[i], "...skipping\n")
                
                NULL
            } else {
                xset.l[[i]]@peaks <- xset.l[[i]]@peaks[idx, ]
                
                list(info = standard.info, xset = xset.l[[i]])
            }
        }
    })
    
    ## remove empty elements from xset.l.small
    empty.idx <- which(sapply(xset.l.small, function(x) length(x[[1]])) == 0)
    if (length(empty.idx) > 0) 
        xset.l.small <- xset.l.small[-empty.idx]
    
    lapply(xset.l.small, function(xx) list(info = xx$info, xset = runCAMERA(xx$xset, chrom = chrom, settings = metaSetting(settings, 
        "CAMERA"), polarity = polarity, quick = FALSE)))
}

## Function changes a list of xset objects from injections of (combinations of) standards into spectra for individual
## standards.
generateStdDBGC <- function(totalXset, settings, extDB = NULL, manualDB = NULL, RIstandards = NULL) {
    if (!is.null(manualDB)) {
        for (i in 1:length(manualDB)) if (is.null(manualDB[[i]]$Class)) 
            manualDB[[i]]$Class <- "Manual"
    }
    
    if (!is.null(totalXset)) {
        if (!is.null(extDB)) {
            DBobj <- match2ExtDB(totalXset, extDB, settings)
        } else {
            if (!is.null(totalXset)) {
                DBobj <- xset2msp(totalXset, settings)
            }
        }
        for (i in 1:length(DBobj)) DBobj[[i]]$Class <- "Standard"
        
        ## also works when manualDB == NULL :-D
        DBobj <- c(DBobj, manualDB)
        
        ## Here we set the name of the intensity value for all entries in the DB to the appropriate value
        for (i in 1:length(DBobj)) colnames(DBobj[[i]]$pspectrum)[2] <- settings$intensityMeasure
        
        ## for those entries in the DB that do not have a date field: add it
        nodate <- which(sapply(DBobj, function(x) is.null(x$date)))
        for (i in nodate) DBobj[[i]]$date <- format(Sys.time(), "%b %d %Y")
    } else {
        DBobj <- manualDB
    }
    
    if (!is.null(RIstandards)) {
        DBobj <- addRI(DBobj, RIstandards)
        ## rename all 'RI' fields to 'std.RI'
        DBobj <- lapply(DBobj, function(x) {
            x$std.RI <- x$RI
            x$RI <- NULL
            
            x
        })
    }
    
    ## rename all 'rt' and 'rt.std' fields to 'std.rt' and 'std.rt.sd'
    lapply(DBobj, function(x) {
        x$std.rt <- x$rt
        x$std.rt.sd <- x$rt.sd
        x$rt <- x$rt.sd <- NULL
        
        x
    })
}


match2ExtDB <- function(xsetList, extDB, settings) {
    DBobj <- vector(0, mode = "list")
    
    for (f.idx in 1:length(xsetList)) {
        ## loop over injections
        injection <- xsetList[[f.idx]]
        
        cnames <- injection$info[, 1]
        
        for (c.idx in 1:length(cnames)) {
            ## loop over standards if an extDB entry is found we check whether MW agrees with the monoMW given by Georg, and obtain the
            ## molecular formula.
            cas.idx <- which(sapply(extDB, function(x, y) x$CASNO == y, injection$info[c.idx, "CAS"]))
            
            if (length(cas.idx) == 0) {
                ## This should not happen!!
                printWarning("No matching CAS number found for", injection$info[c.idx, "Name"], "\nPlease check and perhaps update table.")
            } else {
                MWs <- sapply(extDB[cas.idx], function(x) x$MW)
                MW <- unique(MWs)
                if (length(MW) > 1) {
                  printWarning("More than one MW value for ", injection$info[c.idx, "Name"], ", CAS ", injection$info[c.idx, 
                    "CAS"], "\n\tcomparing value in table with the most common one.")
                  MW <- which.max(tabulate(MWs))
                }
                if (length(MW) == 0) {
                  printWarning("No MW value in external DB for CAS", injection$info[c.idx, "CAS"])
                }
                
                if (MW != round(injection$info[c.idx, "monoMW"])) {
                  printWarning("Ext DB MW (", MW, ") does not agree with MW from table (", round(injection$info[c.idx, "monoMW"]), 
                    ") for ", injection$info[c.idx, "Name"], ", CAS ", injection$info[c.idx, "CAS"])
                }
                
            }
            
            ## In the following, we use the table value from Georg
            MW <- injection$info[c.idx, "monoMW"]
            
            psp2 <- to.msp(injection$xset, file = NULL, settings = settings)
            psp2 <- lapply(psp2, function(x) x[order(x[, "mz"]), , drop = FALSE])
            
            ## remove features higher than the molecular mass plus 3 (to allow for isotopes)
            psp2 <- lapply(psp2, function(x) x[x[, "mz"] < MW + 4, , drop = FALSE])
            psp2 <- psp2[sapply(psp2, nrow) >= settings$minfeat]
            psp2 <- lapply(psp2, function(x) cbind(x[, 1:2], rt = round(x[, 3], 2)))
            
            rtrange <- injection$info$RT[c.idx] + c(-settings$rttol, settings$rttol)
            rts <- sapply(psp2, function(x) mean(x[, 3]))
            idx <- which(rts < max(rtrange) & rts > min(rtrange))
            psp2 <- psp2[idx]
            
            ## now calculate matches with extDB - only retain those spectra having a match higher than the threshold
            if (length(idx) > 0) {
                if (length(cas.idx) > 0) {
                  psp2 <- lapply(psp2, function(x) cbind(round(x[, 1]), x[, -1]))
                  match.results <- sapply(psp2, matchExpSpec, extDB[cas.idx], plotIt = FALSE, DB.treated = TRUE)
                  
                  if (is.matrix(match.results)) {
                    best.match <- round(apply(match.results, 2, max), 4)
                  } else {
                    if (length(idx) > 1) {
                      ## only one entry in ext DB!
                      best.match <- round(match.results, 4)
                    } else {
                      ## only one pattern found in the experimental data
                      best.match <- round(max(match.results), 4)
                    }
                  }
                }
            }
            
            if (length(psp2) > 0) {
                ## rt given is the one from Georg (in minutes); individual retention times are available in the third column of pspectrum,
                ## again in minutes
                output.info <- injection$info[c.idx, ]
                output.df <- as.data.frame(output.info, stringsAsFactors = FALSE)
                output.df <- cbind(output.df[rep(1, length(psp2)), ], bestDBmatch = best.match)
                msp.obj <- construct.msp(psp2, output.df)
                ## Filtering this object is not necessary since it has aready been done at the psp2 level
                
                DBobj <- c(DBobj, msp.obj[best.match > settings$DBthreshold])
            } else {
                printWarning("No pattern found matching all criteria for", injection$info[c.idx, "Name"], "- CAS number", injection$info[c.idx, 
                  "CAS"])
            }
        }
    }
    
    DBobj
}



## conversion function, to get from a list of xset objects and corresponding meta-information to an msp object containing all
## relevant bits.

xset2msp <- function(xsetList, settings) {
    DBobj <- NULL
    
    for (f.idx in 1:length(xsetList)) {
        ## loop over injections
        injection <- xsetList[[f.idx]]
        
        cnames <- injection$info[, 1]
        
        for (c.idx in 1:length(cnames)) {
            ## loop over standards
            MW <- injection$info[c.idx, "monoMW"]
            psp2 <- to.msp(xsetList[[f.idx]]$xset, file = NULL, settings = settings)
            psp2 <- lapply(psp2, function(x) x[order(x[, "mz"]), , drop = FALSE])
            ## remove features higher than the molecular mass plus 3 (to allow for isotopes)
            psp2 <- lapply(psp2, function(x) x[x[, "mz"] < MW + 4, , drop = FALSE])
            psp2 <- psp2[sapply(psp2, nrow) >= settings$minfeat]
            psp2 <- lapply(psp2, function(x) cbind(x[, 1:2], rt = round(x[, 3], 2)))
            
            rtrange <- injection$info$RT[c.idx] + c(-settings$rttol, settings$rttol)
            rts <- sapply(psp2, function(x) mean(x[, 3]))
            idx <- which(rts < max(rtrange) & rts > min(rtrange))
            psp2 <- psp2[idx]
            if (length(psp2) > 0) {
                ## rt given is the one from Georg (in minutes); individual retention times are available in the third column of pspectrum,
                ## again in minutes
                output.info <- injection$info[c.idx, ]
                output.df <- as.data.frame(output.info, stringsAsFactors = FALSE)
                msp.obj <- construct.msp(psp2, output.df)
                ## Filtering this object is not necessary since it has aready been done at the psp2 level
                
                DBobj <- c(DBobj, msp.obj)
            }
        }
    }
    
    DBobj
}

## Auxiliary function for plotting a particular pseudospectrum. M/z values are in the first column of the matrix, and an
## intensity measure (either maxo, into or something else) in the second. The third column is disregarded, usually contains
## retention time information
plotPseudoSpectrum <- function(psspc, ...) {
    plot(psspc[, 1:2], type = "h", col = 4, xlab = "m/z", ylab = "I", ...)
}

## Function getAnnotationMat obtains relative intensities for features in individual samples. A robust linear regression is
## performed when the number of common features is five or larger; for 2-4 peaks a weighted linear regression is used, and if
## only one peak is in common the intensity ratio for this peak is used. As a reference either the stdDB patterns are used, or
## the first file in which a particular unknown is found.

## New version, Aug 13, now working with the new annotation object

getAnnotationMat <- function(exp.msp, pspectra, allMatches) {
    allAnnotations <- sort(unique(unlist(sapply(allMatches$annotations, function(x) x[, "annotation"]))))
    allAnnotations <- c(allAnnotations[allAnnotations > 0], rev(allAnnotations[allAnnotations < 0]))
    result <- matrix(0, length(allAnnotations), length(exp.msp))
    colnames(result) <- names(exp.msp)
    
    pspec.names <- sapply(pspectra, function(x) x$Name)
    
    ## for warnings from relInt...
    oldWarn <- options("warn")$warn
    options(warn = 2)
    
    for (j in seq(along = allAnnotations)) {
        ## a list, containing for every injection the spectra that match this particular annotation
        hits <- lapply(allMatches$annotations, function(x) x[x[, "annotation"] == allAnnotations[j], "pattern"])
        hit.idx <- which(sapply(hits, length) > 0)
        refpat <- pspectra[[j]]$pspectrum
        
        for (k in hit.idx) {
            ## if two different patterns are assigned to the same DB entry, only the larger intensity is kept
            intensities <- sapply(hits[[k]], function(idx) {
                pat <- exp.msp[[k]][[idx]]
                relInt(pat, refpat)
            })
            ## if result[j, k] already contains a number from another pattern, the largest of the intensities is kept
            result[j, k] <- max(result[j, k], intensities)
        }
    }
    
    options(warn = oldWarn)
    
    result
}

## Since in our GC data m/z values are rounded to whole numbers, in some cases an m/z value may occur multiple times - in that
## case the mean of the intensities is kept (and the retention times are averaged).  removeDoubleMasses takes a list of
## spectra in the form of a three-column matrix, (mz, I, rt), summing the intensities and averaging the retention times for
## multiple identical masses

## Aug 1, 2013: adapt to handle both 2- and 3-column spectra (retention time is optional)
removeDoubleMasses <- function(spclist) {
    lapply(spclist, function(pspc) {
        if (max(table(pspc[, 1])) > 1) {
            if (ncol(pspc) == 3) {
                huhn <- cbind(aggregate(pspc[, 2], list(pspc[, 1]), FUN = sum), aggregate(pspc[, 3], list(pspc[, 1]), FUN = mean)$x)
            } else {
                huhn <- cbind(aggregate(pspc[, 2], list(pspc[, 1]), FUN = sum))
            }
            colnames(huhn) <- colnames(pspc)
            
            huhn
        } else {
            pspc
        }
    })
}



## match of preprocessed pseudospectra
mzmatch <- function(spec1, spec2) {
    common.masses1 <- which(spec1[, 1] %in% spec2[, 1])
    common.masses2 <- which(spec2[, 1] %in% spec1[, 1])
    
    if (length(common.masses1) > 0) {
        sum(spec1[common.masses1, 2, drop = FALSE] * spec2[common.masses2, 2, drop = FALSE])
    } else {
        0
    }
}


## This function transforms the 'raw' data in an external DB object into preprocessed data. Even if no scale and no
## mass.weight is applied, the intensities are still changed: scaled to unit length. If isMSP is FALSE, the DB contains a list
## of matrices, the first column being mz and the second being the intensity measure.
treat.DB <- function(DB, scale.p = c("sqrt", "none"), mass.weight = TRUE, isMSP = TRUE) {
    scale.p = match.arg(scale.p)
    if (scale.p == "sqrt") {
        if (isMSP) {
            for (i in 1:length(DB)) {
                DB[[i]]$pspectrum[, 2] <- sqrt(DB[[i]]$pspectrum[, 2])
            }
        } else {
            for (i in 1:length(DB)) {
                DB[[i]][, 2] <- sqrt(DB[[i]][, 2])
            }
        }
    }
    
    if (mass.weight) {
        if (isMSP) {
            for (i in 1:length(DB)) {
                huhn <- sqrt(DB[[i]]$pspectrum[, 1]) * DB[[i]]$pspectrum[, 2]
                DB[[i]]$pspectrum[, 2] <- huhn/sqrt(sum(huhn^2))
            }
        } else {
            for (i in 1:length(DB)) {
                huhn <- sqrt(DB[[i]][, 1]) * DB[[i]][, 2]
                DB[[i]][, 2] <- huhn/sqrt(sum(huhn^2))
            }
        }
    } else {
        if (isMSP) {
            for (i in 1:length(DB)) {
                DB[[i]]$pspectrum[, 2] <- DB[[i]]$pspectrum[, 2]/sqrt(sum(DB[[i]]$pspectrum[, 2]^2))
            }
        } else {
            for (i in 1:length(DB)) {
                DB[[i]][, 2] <- DB[[i]][, 2]/sqrt(sum(DB[[i]][, 2]^2))
            }
        }
    }
    
    DB
}

## convenience function for comparing different match functions March 14: added an argument DB.treated. Much of the matching
## time needed is to preprocess the DB entries, which could better be done once and saved under a different name. To maintain
## compatibility the default is to assume no treatment. Note that treatment is not idempotent, so that doing it twice will
## lead to different results!!  Also implemented is a convenience function treat.DB

## Jan 21, 2013: now no double masses are allowed anymore in pspec

matchExpSpec <- function(pspec, DB, DB.treated, plotIt = FALSE, scale.p = c("sqrt", "none"), mass.weight = TRUE, ...) {
    if (DB.treated) {
        mass.weight <- TRUE
        scale.p <- "sqrt"
    }
    
    scale.p = match.arg(scale.p)
    if (scale.p == "sqrt") {
        pspec[, 2] <- sqrt(pspec[, 2])
        
        if (!DB.treated) {
            for (i in 1:length(DB)) {
                DB[[i]]$pspectrum[, 2] <- sqrt(DB[[i]]$pspectrum[, 2])
            }
        }
    }
    
    if (mass.weight) {
        if (!DB.treated) {
            for (i in 1:length(DB)) {
                huhn <- sqrt(DB[[i]]$pspectrum[, 1]) * DB[[i]]$pspectrum[, 2]
                DB[[i]]$pspectrum[, 2] <- huhn/sqrt(sum(huhn^2))
            }
        }
        
        huhn <- sqrt(pspec[, 1]) * pspec[, 2]
    } else {
        huhn <- pspec[, 2]  ## no weight
    }
    pspec[, 2] <- huhn/sqrt(sum(huhn^2))  ## normalize
    
    if (!DB.treated) {
        for (i in 1:length(DB)) {
            DB[[i]]$pspectrum[, 2] <- DB[[i]]$pspectrum[, 2]/sqrt(sum(DB[[i]]$pspectrum[, 2]^2))
            
        }
    }
    
    huhn <- sapply(DB, function(x) mzmatch(x$pspectrum, pspec))
    
    if (plotIt) {
        best.match <- which.max(huhn)
        plot(pspec[, 1], 1000 * pspec[, 2]/max(pspec[, 2]), ylim = c(0, 1000), type = "h", col = 2, lwd = 3, xlab = "mz", ylab = "I", 
            sub = paste("Match factor:", round(max(huhn), 3)), ...)
        lines(DB[[best.match]]$pspectrum[, 1], 1000 * DB[[best.match]]$pspectrum[, 2]/max(DB[[best.match]]$pspectrum[, 2]), col = 4, 
            lwd = 1, type = "h")
        legend("topright", legend = c("Compound", "DB best match"), col = c(2, 4), lwd = c(4, 2), lty = 1)
    }
    
    huhn
}

## Main function to prepare the LC db

createSTDdbLC <- function(stdInfo, settings, polarity, Ithr = 10, nSlaves = 0) {
    ## Read the reference table produced by the experimentalists
    
    printString("Processing the manually curated reference table")
    printString("Polarity:", polarity)
    
    
    ## Perform the peakpicking and the CAMERA analysis
    stdxsets <- processStandards(stdInfo, settings, polarity, nSlaves = nSlaves)
    
    ## match with the reference table
    db <- generateStdDBLC(stdxsets, metaSetting(settings, "DBconstruction"), Ithr)
    
    ## prepare an output object with some infos
    printString("Done !")
    list(Reftable = stdInfo, Info = list(Modified = date(), settings = settings), DB = db)
}

## scripts to generate the intermediate GC data from the CDF files of
## metaMSdata. Can be used to re-generate results in case of changes
## to either package.

library(metaMS)
library(metaMSdata)

## ########################################################################
## Creation of the database for annotation
data(FEMsettings)    ## provides a.o. Synapt.RP, the LC settings file
data(exptable)
cdfpath <- system.file("CDF_LC", package = "metaMSdata")

## files 
files <- list.files(cdfpath, "_RP_", full.names=TRUE)
exptable$stdFile <-
    sapply(exptable$stdFile,
           function(x)
           files[grep(x,files)])
  
## Go!
metaSetting(Synapt.RP, "DBconstruction")$minfeat  <- 2
LCDBtest <- createSTDdbLC(stdInfo=exptable, 
                          settings = Synapt.RP,
                          polarity = "positive",
                          Ithr = 20, nSlaves = 2)
## saved in "LCDBtest.RData" in the data directory of the metaMS
## package


## ########################################################################
## Creation of LCresults object
data(FEMsettings)
data(LCDBtest)

cdfpath <- system.file("extdata", package = "metaMSdata")
files <- list.files(cdfpath, "_RP_", full.names = TRUE)

LCresults <- runLC(files, settings = Synapt.RP, 
                   DB = LCDBtest$DB, returnXset = TRUE, nSlaves = 2)
## saved in "LCresults.RData") in the data directory of the metaMS
## package

## convert a nested annotation list to a simple-to-read table.  both annlist and matches are for one injection only. Also
## works when there are no single hits, or no double hits
annotations2tab <- function(annlist, matches) {
    single.hits <- which(sapply(annlist, length) == 1)
    single.result <- makeAnnotation(length(single.hits))
    single.result[, "pattern"] <- single.hits
    single.result[, "annotation"] <- unlist(annlist[single.hits])
    
    hits <- which(sapply(annlist, length) > 1)
    nhits <- length(hits)
    if (nhits == 0) {
        single.result
    } else {
        double.result <- makeAnnotation(nhits)
        
        for (i in 1:nhits) {
            ann <- annlist[[hits[i]]]
            matchfactors <- matches[ann, hits[i]]
            bestone <- which.max(matchfactors)
            double.result[i, 1:2] <- c(hits[i], ann[bestone])
            double.result[i, 3] <- paste(ann[-bestone], collapse = ",")
        }
        
        rbind(single.result, double.result)
    }
}


makeAnnotation <- function(n) {
    data.frame(pattern = rep(0, n), annotation = rep(0, n), alternatives = rep("", n), stringsAsFactors = FALSE)
}

createSTDdbGC <- function(stdInfo, settings, extDB = NULL, manualDB = NULL, RIstandards = NULL, nSlaves = 0) {
    if (is.null(stdInfo)) {
        if (is.null(manualDB)) {
            stop("At least one of stdInfo and manualDB must be non-null!")
        } else {
            ## only manualDB will be returned
            totalXset <- NULL
        }
    } else {
        if (is.null(extDB) & !is.null(manualDB)) 
            printWarning("Watch out:\n", "combining unvalidated experimental data with a ", "manually curated database!\n", "If this is not what you intended, cancel now.")
        
        printString("Processing", length(unique(stdInfo[, "stdFile"])), "input files for", nrow(stdInfo), "standards")
        printString("Running XCMS and CAMERA")
        
        totalXset <- processStandards(stdInfo, settings, nSlaves = nSlaves)
    }
    
    generateStdDBGC(totalXset, settings = metaSetting(settings, "DBconstruction"), extDB = extDB, manualDB = manualDB, RIstandards = RIstandards)
}

runGC <- function(files, xset, settings, rtrange = NULL, DB = NULL, removeArtefacts = TRUE, findUnknowns = nexp >= mcs, returnXset = FALSE, 
    RIstandards = NULL, nSlaves = 0) {
    ## ################################################################### some preliminary sanity checks
    if (!missing(files)) {
        nexp <- length(files)
    } else {
        if (missing(xset)) 
            stop("Either 'files' or 'xset' should be given")
        
        if (is(xset)[1] == "xcmsSet") 
            stop("xset should be a list of CAMERA-grouped xcmsSet objects, see man page")
        
        xset.l <- xset
        nexp <- length(xset.l)
    }
    
    ## same criterion as in matchSamples2Samples
    mcs <- max(2, min(metaSetting(settings, "betweenSamples.min.class.size"), metaSetting(settings, "betweenSamples.min.class.fraction") * 
        nexp))
    ## check for unrealistic expectations: findUnknowns can only be relevant if enough samples are present.
    if (findUnknowns & nexp < mcs) {
        stop("Number of samples too small to define unknowns - either provide more samples or change the settings.")
    }
    
    if (is.null(DB) & !findUnknowns) 
        stop("Nothing to do. Provide a DB or set 'findUnknowns' to TRUE...")
    
    if (findUnknowns & !is.null(DB) & metaSetting(settings, "betweenSamples.timeComparison") != metaSetting(settings, "match2DB.timeComparison")) 
        stop("Settings error: choose one value for timeComparison only...")
    
    if (is.null(RIstandards) & ((metaSetting(settings, "betweenSamples.timeComparison") == "RI" & findUnknowns) | (metaSetting(settings, 
        "match2DB.timeComparison") == "RI" & !is.null(DB)))) 
        stop("Argument RIstandards is mandatory when using RI for matching")
    
    if (!is.null(RIstandards) & metaSetting(settings, "betweenSamples.timeComparison") == "rt" & metaSetting(settings, "match2DB.timeComparison") == 
        "rt") 
        printWarning("Warning: argument RIstandards provided, but using retention times for matching")
    
    printString(paste("Experiment of", nexp, "samples"))
    printString(paste("Instrument:", metaSetting(settings, "protocolName")))
    if (length(rtrange) == 2) 
        printString(paste("Retention time range:", rtrange[1], "to", rtrange[2], "minutes"))
    
    if (!is.null(DB)) {
        DB.orig <- DB
        DB <- treat.DB(DB.orig)
        
        printString(paste("Annotation using database of", length(DB), "spectra"))
    } else {
        printString("No annotation performed")
        DB.orig <- NULL
    }
    
    ## ################################################################### Peak picking and CAMERA
    if (!missing(files)) {
        printString("Performing peak picking and CAMERA")
        xset.l <- peakDetection(files, metaSetting(settings, "PeakPicking"), rtrange = rtrange, convert2list = TRUE, nSlaves = nSlaves)
        
        allSamples <- lapply(xset.l, runCAMERA, chrom = metaSetting(settings, "chrom"), settings = metaSetting(settings, "CAMERA"))
    } else {
        printString("Using xcmsSet object - only doing annotation")
        allSamples <- xset.l
    }
    
    
    ## ################################################################### convert into msp format (a nested list)
    allSamples.msp <- lapply(allSamples, to.msp, file = NULL, settings = metaSetting(settings, "DBconstruction"))
    names(allSamples.msp) <- sapply(allSamples, function(x) sampnames(x@xcmsSet))
    if (!is.null(RIstandards)) 
        allSamples.msp <- lapply(allSamples.msp, addRI, RIstandards, isMSP = FALSE)
    
    ## check: files without any features - should not happen very often...
    nofeats <- which(sapply(allSamples.msp, length) == 0)
    if ((nnof <- length(nofeats)) > 0) {
        printWarning("Removing", nnof, "injections without any features:\n\t", paste(names(allSamples)[nofeats], collapse = "\n\t "))
        allSamples.msp <- allSamples.msp[-nofeats]
    }
    ## now scale the rest...
    allSamples.msp.scaled <- lapply(allSamples.msp, treat.DB, isMSP = FALSE)
    
    ## remove Artefacts
    if (!is.null(DB)) {
        if (removeArtefacts) {
            printString(paste("Removing artefacts (", paste(metaSetting(settings, "matchIrrelevants.irrelevantClasses"), collapse = ", "), 
                ")", sep = ""))
            irrel.idx <- which(sapply(DB, function(x) x$Class) %in% metaSetting(settings, "matchIrrelevants.irrelevantClasses"))
            if (length(irrel.idx) > 0) {
                subDB <- DB[irrel.idx]
                junkPatterns <- lapply(matchSamples2DB(allSamples.msp.scaled, subDB, metaSetting(settings, "matchIrrelevants"), 
                  quick = TRUE)$annotations, function(x) x[, "pattern"])
                
                allSamples.msp <- mapply(function(x, y) if (length(y) > 0) {
                  x[-y]
                } else {
                  x
                }, allSamples.msp, junkPatterns)
                allSamples.msp.scaled <- mapply(function(x, y) if (length(y) > 0) {
                  x[-y]
                } else {
                  x
                }, allSamples.msp.scaled, junkPatterns)
                
                ## check: files without any features
                nofeats <- which(sapply(allSamples.msp, length) == 0)
                if ((nnof <- length(nofeats)) > 0) {
                  printWarning("Removing", nnof, "injections containing only artefacts:\n\t", paste(names(allSamples)[nofeats], 
                    collapse = "\n\t "))
                  allSamples <- allSamples[-nofeats]
                }
                
                DB <- DB[-irrel.idx]
                DB.orig <- DB.orig[-irrel.idx]
            }
        }
        
        printString("Matching with database of standards")
        allSam.matches <- matchSamples2DB(allSamples.msp, DB = DB, settings = metaSetting(settings, "match2DB"), quick = FALSE)
    } else {
        allSam.matches <- NULL
    }
    
    if (findUnknowns) {
        printString("Matching unknowns across samples")
        allSam.matches <- matchSamples2Samples(allSamples.msp.scaled, allSamples.msp, annotations = allSam.matches$annotations, 
            settings = metaSetting(settings, "betweenSamples"))
    }
    
    # Add this if because when you obtain no result, there was an error during 'sweep' function for ann.df2
    # if(sum(sapply(allSam.matches$annotations,nrow)) > 0){
    
    printString("Formatting results")
    
    ## First obtain the pseudospectra
    PseudoSpectra <- constructExpPseudoSpectra(allMatches = allSam.matches, standardsDB = DB.orig)
    ## and replace the DB indices of the identified standards with the indices in the pseudospec DB - they are simply ordered. The
    ## alternatives should also be there!  Then export the quantitations. The first part is a data.frame describing the features
    features.df <- getFeatureInfo(stdDB = DB.orig, allMatches = allSam.matches, sampleList = allSamples.msp)
    
    ## Second data.frame contains the actual annotations, for the moment as relative intensities
    ann.df <- getAnnotationMat(exp.msp = allSamples.msp, pspectra = PseudoSpectra, allMatches = allSam.matches)
    
    ## To get to intensities comparable to the ones identified by xcms, use largest peak in PseudoSpectra as the common intensity
    ## measure
    ann.df2 <- sweep(ann.df, 1, sapply(PseudoSpectra, function(x) max(x$pspectrum[, 2])), FUN = "*")
    
    printString("Done!")
    
    if (returnXset) {
        list(PeakTable = cbind(data.frame(features.df), data.frame(round(ann.df2))), PseudoSpectra = PseudoSpectra, settings = settings, 
            xset = allSamples, annotation = allSam.matches$annotation, samples.msp = allSamples.msp, SessionInfo = sessionInfo())
    } else {
        list(PeakTable = cbind(data.frame(features.df), data.frame(round(ann.df2))), PseudoSpectra = PseudoSpectra, settings = settings, 
            SessionInfo = sessionInfo())
    }
    # }else{ peaktable <- data.frame(Name = 1, Class = 1, rt.sd = 1, rt = 1)[FALSE,] result <- matrix(0, 0,
    # length(allSamples.msp)) colnames(result) <- names(allSamples.msp) if (returnXset) { list(PeakTable =
    # cbind(data.frame(peaktable), data.frame(result)), PseudoSpectra = NULL, settings = settings, xset = allSamples, annotation
    # = allSam.matches$annotation, samples.msp = allSamples.msp, SessionInfo = sessionInfo()) } else { list(PeakTable =
    # cbind(data.frame(peaktable), data.frame(result)), PseudoSpectra = NULL, settings = settings, SessionInfo = sessionInfo()) }
    # }
}

test_GC <- function() {
  data(FEMsettings)   ## settings
  data(threeStdsDB)   ## annotation database
  data(GCresults)     ## pre-computed results
  
  ## Peak picking in xcms returns different numbers of features in
  ## different versions. We are not interested in
  ## testing this behaviour, but want to test our own code. So we
  ## present the xcmsSet object rather than the file names.
  result.live <- runGC(xset = GCresults$xset, settings = TSQXLS.GC,
                       DB = DB, nSlaves = 2)
  
  checkEquals(nrow(GCresults$PeakTable), nrow(result.live$PeakTable))
  checkEquals(ncol(GCresults$PeakTable), ncol(result.live$PeakTable))
  checkEquals(GCresults$PeakTable[,"Name"], result.live$PeakTable[,"Name"])
}
          

printString <- function(..., screenwidth = 72) {
    prstring <- paste(..., collapse = " ")
    prntString <- paste("< --------", prstring, paste(rep("-", screenwidth - nchar(prstring) - 12), collapse = ""), ">")
    
    message(prntString)
}


## different aesthetics ...  In this and the next function we use '...' to allow for multiple pieces of text. This means we do
## not have to use paste in the function calling printInfo or printWarning.
printInfo <- function(...) {
    prstring <- paste(..., collapse = " ")
    prntString <- paste("\t", prstring)
    
    message(prntString)
}

## for the warnings

printWarning <- function(...) {
    prstring <- paste(..., collapse = " ")
    prntString <- paste("!!\n", prstring, "\n!!")
    
    message(prntString)
}

## RW added DBname as an argument
getAnnotationLC <- function(xs, settings, DB, errf) {
    
    # ------- Peak table with maxo --------------------------------- >
    PkT4ann <- getPeakTable(xs, intval = "maxo")
    
    ## check the number of samples
    if (length(sampnames(xs@xcmsSet)) == 1) {
        dataMatrix <- PkT4ann[, "maxo", drop = FALSE]
        I <- dataMatrix
    } else {
        dataMatrix <- PkT4ann[, make.names(sampnames(xs@xcmsSet)), drop = FALSE]
        I <- apply(dataMatrix, 1, median)  ## use the median intensity in DM for annotation
    }
    
    ## -------- Table to be annotate --------------------------------- >
    tobeannotated <- cbind(mz = PkT4ann$mz, rt = PkT4ann$rt, I = unlist(I))
    
    ## complete annotation information
    out.raw <- AnnotateTable(tobeannotated, errf = errf, DB = DB, settings = settings)
    
    ## subset of the annotation output to be used in the metaMS output
    ann.ID <- rep("", dim(tobeannotated)[1])
    ann.compound <- rep("", dim(tobeannotated)[1])
    annotated.features <- unique(out.raw$annotation.table$feature)
    for (id in annotated.features) {
        ann.ID[id] <- paste(out.raw$annotation.table$ChemSpiderID[out.raw$annotation.table$feature == id], collapse = " ")
        ann.compound[id] <- paste(out.raw$annotation.table$compound[out.raw$annotation.table$feature == id], collapse = " ")
    }
    
    
    ## ------ Format the output -------------------------------------- >
    
    list(raw = out.raw, for_table = data.frame(ChemSpiderID = ann.ID, compound = ann.compound, stringsAsFactors = FALSE))
    
}

runLC <- function(files, xset, settings, rtrange = NULL, mzrange = NULL, DB = NULL, polarity = "positive", errf = NULL, returnXset = FALSE, 
    intensity = "into", nSlaves = 0) {
    ## initial check on the inputs.
    if (!missing(files)) {
        nexp <- length(files)
    } else {
        if (missing(xset)) 
            stop("Either 'files' or 'xset' should be given")
        if (is(xset)[1] != "xsAnnotate") 
            stop("xset should be of class 'xsAnnotate'")
        nexp <- length(sampnames(xset@xcmsSet))
    }
    ## Ok let's start the analysis
    printString(paste("Experiment of", nexp, "samples"))
    printString(paste("Instrument:", metaSetting(settings, "protocolName"), " - polarity:", polarity))
    
    ## limit the retention time
    if (length(rtrange) == 2) {
        printString(paste("Retention time range:", rtrange[1], "to", rtrange[2], "minutes"))
    }
    ## a short echo on the size of the DB
    if (!is.null(DB)) {
        printString("Database of", length(unique(DB$ChemSpiderID)), "compounds")
    }
    ## if there are samples ...
    if (!missing(files)) {
        
        #------------------------- Peak picking  ------------------------------ >
        printString("Performing peak picking")
        xset <- peakDetection(files, metaSetting(settings, "PeakPicking"), rtrange = rtrange, mzrange = mzrange, nSlaves = nSlaves)
        
        #------------------------- Grouping and alignment  -------------------- >
        printString("Grouping and retention time alignment")
        xset <- alignmentLC(xset, metaSetting(settings, "Alignment"))
        
        #------------------------- CAMERA ---------------- -------------------- >
        printString("Performing CAMERA grouping")
        xset <- runCAMERA(xset, chrom = "LC", metaSetting(settings, "CAMERA"), polarity)
    } else {
        ## If I provide already the CAMERA
        printString("Using xcmsSet object - only doing annotation")
    }
    
    #------------------------- Get The Peak Table---------------------------- >
    peakTable <- getPeakTable(xset, intval = intensity)
    
    #------------------------- Annotation ----------------------------------- >
    
    if (!is.null(DB)) {
        ## if an annotation DB is provided
        printString("Performing annotation")  # --------------------------- >
        annotation <- getAnnotationLC(xset, metaSetting(settings, "match2DB"), DB, errf)
        
        ## To run the annotation we need: table mz,rt,I, errf and DB.  With the additional functions AnnotateFeaturesAnnotateTable on
        ## the configurations I need the rt tol, the rt4validation, mass tolerance if no surface.  else return an empty annotation
        ## object
    } else {
        annotation <- list(raw = data.frame(), for_table = data.frame())
    }
    
    ## If the annotation is required add the output ---------------
    if (!is.null(DB)) {
        peakTable <- cbind(annotation$for_table, peakTable)
    }
    
    
    ## ----------------- Prepare the outputs ------------------------------ >
    printString("Done !")
    if (returnXset) {
        list(PeakTable = peakTable, xset = xset, Annotation = annotation$raw, Settings = settings, SessionInfo = sessionInfo())
    } else {
        list(PeakTable = peakTable, Annotation = annotation$raw, Settings = settings, SessionInfo = sessionInfo())
    }
}

test_LC <- function() {
  data(FEMsettings)  ## The settings
  data(LCDBtest)     ## The database
  data(LCresults)    ## The reference output
  
  ## Peak picking in xcms returns different numbers of features in
  ## different versions. We are not interested in
  ## testing this behaviour, but want to test our own code. So we
  ## present the xcmsSet object rather than the file names.
  LC <- runLC(xset = LCresults$xset, settings = Synapt.RP,
              DB = LCDBtest$DB, nSlaves = 2)

  checkEquals(nrow(LC$PeakTable), nrow(LCresults$PeakTable))
  checkEquals(ncol(LC$PeakTable), ncol(LCresults$PeakTable))
  checkEquals(LC$Annotation$ann.features, LCresults$Annotation$ann.features)
}
  

alignmentLC <- function(xset, settings) {
    ## if only one sample do not retcor ....
    if (length(sampnames(xset)) == 1) {
        return(xset)
    }
    ## The workflow is different depending on the type of retcor approach: for types linear and loess one needs the missing and
    ## extra and two runs of grouping are performed (before and after retcor). for obiwarp only one grouping is needed after the
    ## retcor
    
    ## calculate minsamp. The parameter used for grouping ...
    myminsamp <- min(c(settings$min.class.size, ceiling(length(sampnames(xset)) * settings$min.class.fraction)))
    printString("minsamp:", myminsamp)
    ## Test the type of retcor ... -------------------------------------------- >
    if (settings$Retcor$method %in% c("loess", "linear")) {
        printString("Density-based retcor")
        ## Perform the first Grouping
        xset <- do.call(group, c(list(object = xset, bw = settings$bws[1], minsamp = myminsamp, minfrac = 0), settings["mzwid"]))
        ## calculate missing and extra ....
        missing <- ceiling((settings$missingratio) * length(xset@filepaths))
        extra <- ceiling((settings$extraratio) * length(xset@filepaths))
        printString("missing:", missing)
        printString("extra:", extra)
        ## Perform the retention time correction
        retcorlist <- c(list(object = xset, missing = missing, extra = extra), settings$Retcor)
        xset <- do.call(retcor, retcorlist)
        ## Perform the second run of grouping
        xset <- do.call(group, c(list(object = xset, bw = settings$bws[2], minsamp = myminsamp, minfrac = 0), settings["mzwid"]))
        ## If Obiwarp ...... ---------------------------------------------------- >
    } else if (settings$Retcor$method == "obiwarp") {
        printString("Obiwarp retcor")
        ## Perform the retention time correction
        retcorlist <- c(list(object = xset), settings$Retcor)
        xset <- do.call(retcor, retcorlist)
        ## Perform the second run of grouping
        xset <- do.call(group, c(list(object = xset, bw = settings$bws[1], minsamp = myminsamp, minfrac = 0), settings["mzwid"]))
        ## If the method is not specified --------------------------------------- >
    } else {
        printString("Default Density-based retcor")
        myminsamp <- min(c(settings$min.class.size, ceiling(length(sampnames(xset)) * settings$min.class.fraction)))
        printString("minsamp:", myminsamp)
        ## First Grouping
        xset <- do.call(group, c(list(object = xset, bw = settings$bws[1], minsamp = myminsamp, minfrac = 0), settings["mzwid"]))
        ## calculate missing and extra ....
        missing <- ceiling((settings$missingratio) * length(xset@filepaths))
        extra <- ceiling((settings$extraratio) * length(xset@filepaths))
        printString("missing:", missing)
        printString("extra:", extra)
        retcorlist <- c(list(object = xset, missing = missing, extra = extra), settings$Retcor)
        ## Retcor
        xset <- do.call(retcor, retcorlist)
        ## Second Grouping
        xset <- do.call(group, c(list(object = xset, bw = settings$bws[2], minsamp = myminsamp, minfrac = 0), settings["mzwid"]))
    }
    ## optional fill missing peaks -------------------------------------------- >
    if (settings$fillPeaks) {
        printString("Filling missing peaks")
        xset <- fillPeaks(xset)
    }
    return(xset)
}

getPeakTable <- function(xs, intval = "into") {
    ## get peak table from XCMS object -----------------------------------------
    if (class(xs)[1] == "xcmsSet") {
        if (length(sampnames(xs)) == 1) {
            sortorder <- order(xs@peaks[, "rt"])  ## order by retention time  
            peakTable <- data.frame(mz = xs@peaks[sortorder, "mz"], rt = xs@peaks[sortorder, "rt"]/60, intensity = xs@peaks[sortorder, 
                intval], row.names = NULL, stringsAsFactors = FALSE)
            ## put the right title to the intensity column
            colnames(peakTable)[colnames(peakTable) == "intensity"] <- intval
            return(peakTable)
        }
        ## if Xset object and more than one sample
        sortorder <- order(xs@groups[, "rtmed"])  ## rt ordering
        dataMatrix <- groupval(xs, value = intval)  ## extract the intensities
        peakTable <- data.frame(mz = xs@groups[sortorder, "mzmed"], rt = xs@groups[sortorder, "rtmed"]/60, dataMatrix[sortorder, 
            ], row.names = NULL, stringsAsFactors = FALSE)
        return(peakTable)
        
    } else {
        ## get peak table from CAMERA object ----------------------------
        pt <- getPeaklist(xs, intval = intval)  ## function of CAMERA package
        sortorder <- order(pt[, "rt"])  ## rt ordering
        pt <- pt[sortorder, ]
        ## also here one sample ....
        if (length(sampnames(xs@xcmsSet)) == 1) 
            {
                peakTable <- data.frame(pcgroup = as.numeric(pt$pcgroup), adduct = pt$adduct, isotopes = pt$isotopes, mz = pt$mz, 
                  rt = pt$rt/60, intensity = pt[, intval], row.names = NULL, stringsAsFactors = FALSE)
                ## put the right title to the intensity column
                colnames(peakTable)[colnames(peakTable) == "intensity"] <- intval
                return(peakTable)
            }  ## more samples
        dataMatrix <- pt[, make.names(sampnames(xs@xcmsSet))]  ## get only the columns with the intensities works also for banes with special characters
        peakTable <- data.frame(pcgroup = as.numeric(pt$pcgroup), adduct = pt$adduct, isotopes = pt$isotopes, mz = pt$mz, rt = pt$rt/60, 
            dataMatrix, row.names = NULL, stringsAsFactors = FALSE)
        return(peakTable)
    }
}

peakDetection <- function(files, settings, rtrange = NULL, mzrange = NULL, convert2list = FALSE, nSlaves = 0) {
    ## Rmpi tends to give many warnings that are not relevant to end users: this is an attempt to suppress this output
    owarn <- options("warn")
    on.exit(options(warn = owarn$warn))
    options(warn = -1)
    
    ## if an rtrange is given, we first find out which scans correspond to this and then use the scanRange argument of xcmsSet
    if (!is.null(rtrange)) {
        if (length(rtrange) != 2) 
            stop("Improper rtrange given!")
        
        rtrange <- rtrange * 60  ## convert from minutes to seconds
        
        xr <- xcmsRaw(files[1])
        scanRange <- c(max(1, which(xr@scantime > rtrange[1])[1], na.rm = TRUE), min(length(xr@scantime), which(xr@scantime > 
            rtrange[2])[1] - 1, na.rm = TRUE))
        
        allSettings <- c(list(files = files, scanrange = scanRange, nSlaves = nSlaves), settings)
    } else {
        allSettings <- c(list(files = files, nSlaves = nSlaves), settings)
    }
    
    xset <- do.call(xcmsSet, allSettings)
    
    if (!is.null(mzrange)) {
        idx <- (xset@peaks[, "mz"] > mzrange[1]) & (xset@peaks[, "mz"] < mzrange[2])
        xset@peaks <- xset@peaks[idx, ]
    }
    
    
    if (convert2list) {
        ## for GC, for example explicit definition of levels keeps the original order of the samples
        split(xset, factor(sampnames(xset), levels = sampnames(xset)))
    } else {
        xset
    }
}

generateStdDBLC <- function(stdxsets, settings, Ithr) {
    ## Get out the Peak lists
    pklists <- lapply(stdxsets, function(xx) {
        list(info = xx$info, pkt = getPeakTable(xx$xset, intval = "maxo"))
    })
    
    
    ## Matching with the tables to get the DB
    pseudospectra <- lapply(pklists, function(x) {
        feat.match <- lapply(1:nrow(x$info), function(rw) {
            id <- (abs(x$pkt$mz - x$info[rw, "mz.observed"]) < settings$mztol) & (abs(x$pkt$rt - x$info[rw, "RTman"]) < settings$rttol)
            pcgrpid <- x$pkt$pcgroup[id]
            if (sum(id) == 0) {
                printInfo("No match for", x$info[rw, "compound"])
                return(data.frame())
            } else {
                printInfo("Processing", x$info[rw, "compound"])
                mytable <- x$pkt[x$pkt$pcgroup == pcgrpid, ]
                sortid <- order(mytable$mz)  ## sort as a function of the mass
                mytable <- mytable[sortid, ]
                mytable <- mytable[mytable$maxo > Ithr, ]  ## Threshold the ion intensity
                if (nrow(mytable) < settings$minfeat) {
                  return(data.frame())
                }
                out <- data.frame(ChemSpiderID = rep(x$info[rw, "ChemSpiderID"], times = nrow(mytable)), compound = rep(x$info[rw, 
                  "compound"], times = nrow(mytable)), mytable[, -(colnames(mytable) == "pcgroup")], validated = rep("automatic", 
                  times = nrow(mytable)))
            }
        })
        
        feat.match <- do.call(rbind, feat.match)
    })
    
    ## join the tables to have a DB
    db <- do.call(rbind, pseudospectra)
    rownames(db) <- NULL
    db
}

## pat and refpat are two-column matrices (if a third column exists it is ignored).
relInt <- function(pat, refpat) {
    common.masses <- pat[pat[, 1] %in% refpat[, 1], 1]
    expI <- pat[pat[, 1] %in% refpat[, 1], 2]
    DBI <- refpat[refpat[, 1] %in% pat[, 1], 2]
    
    if (length(expI) == 0) {
        ## can happen when comparing unknowns...
        return(0)
    }
    
    if (length(expI) == 1) {
        ## only one mass in common, should not happen very often
        expI/DBI
    } else {
        if (length(expI) < 5) {
            ## here we should use weighted regression! Agreement in high masses is much more important than agreement in low masses.
            ## Unweighted regression usually works fine but in some isolated cases negative coefficients can occur. We should not have
            ## that...  relI <- coef(lm(expI ~ DBI))[2]
            relI <- coef(lm(expI ~ DBI, weights = sqrt(common.masses)))[2]
        } else {
            ## if the robust estimator breaks down, we use the regular one... this sometimes happens when the two vectors are really very
            ## similar
            relI <- try(coef(lmrob(expI ~ DBI))[2], silent = TRUE)
            if (is(relI)[1] == "try-error") 
                relI <- coef(lm(expI ~ DBI, weights = sqrt(common.masses)))[2]
            ## relI <- coef(rlm(expI ~ DBI, weights = sqrt(common.masses), method = 'MM', acc = 1))[2] ## high breakdown point...
        }
        
        if (relI < 0) {
            # warning('Found negative relative I; returning 0') # <<<<<<<<<<
            return(0)
        }
        
        relI
    }
}

runCAMERA <- function(xset, chrom = c("LC", "GC"), settings, polarity, quick = TRUE) {
    chrom <- match.arg(chrom)
    
    switch(chrom, LC = {
        capture.output(z <- do.call(annotate, c(list(object = xset, polarity = polarity, quick = quick), settings)))
        
        z
    }, GC = {
        y <- xsAnnotate(xset, sample = 1)
        capture.output(z <- do.call(groupFWHM, c(list(object = y), settings)))
        
        z
    })
    
}

readStdInfo <- function(stdInfo, InputDir, sep = "", dec = ".", ...) {
    ## ################################################################## Read stdInfo file
    ## ##################################################################
    info <- read.table(stdInfo, header = TRUE, as.is = TRUE, sep = sep, dec = dec, ...)
    info[, "RTman"] <- as.numeric(info[, "RTman"])
    info[, "monoMW"] <- as.numeric(info[, "monoMW"])
    
    ## remove columns that only contain NA values
    NAcols <- which(apply(info, 2, function(x) all(is.na(x))))
    if (length(NAcols) > 0) 
        info <- info[, -NAcols]
    
    ## ################################################################## compare and check input files. Case sensitive!
    ## ##################################################################
    extensions <- file_ext(info[, "stdFile"])
    
    fnames <- list_files_with_exts(InputDir, exts = extensions, full.names = FALSE)
    fpaths <- list_files_with_exts(InputDir, exts = extensions, full.names = TRUE)
    fn <- file_path_sans_ext(fnames)
    
    ## check 1: are all input files present that are needed? (if not: error)
    presenceCheck <- info[, "stdFile"] %in% fnames
    if (!all(presenceCheck)) 
        stop("Not all required data files present in ", InputDir, ":\n", paste(info[!presenceCheck, "stdFile"], collapse = "\n\t"))
    
    ## check 2: are all data files that are present actually used?  (if not: warning)
    presenceCheck <- fnames %in% info[, "stdFile"]
    if (!all(presenceCheck)) 
        printWarning(paste(paste("The following data files in", InputDir, "are not used:\n\t"), paste(fn[!presenceCheck], collapse = "\n\t"), 
            sep = ""))
    
    ## ################################################################## replace file names in table with complete filename
    ## ##################################################################
    info[, "stdFile"] <- fpaths[match(info[, "stdFile"], fn)]
    
    info
}

## two patterns from different xset.msp that have the same annotation
## will be the same variable. However, for patterns without annotation
## similar relations can exist. We seek patterns in different files,
## eluting within a given time window with a given spectral
## similarity. 

## This function returns a list of two things: the first element is a
## msp object containing the pseudospectra that are found in multiple
## samples, and the second is an object like the one returned by
## matchSamples2DB, a nested list containing for each pattern in each
## sample either nothing or the index of the spectrum as it is found
## in the DB. 

## For larger data sets, the corresponding yes-no matrix will be way
## too large (the 2007 grape metabolome leads to a 36734x36734
## matrix), but it is very sparse. If argument annotations equals
## NULL, this function will only return the spectra that are found in
## several patterns and not the annotations.

## Note that from July 30 2013 on, xset.work.orig contains SCALED spectra,
## and xset.msp unscaled spectra!

## Aug 13: new structure of annotations, now a three-column data.frame

## Dec 19: addition of RI check, as an alternative to rt check
matchSamples2Samples <- function(xset.msp.scaled,
                                 xset.msp,
                                 annotations,
                                 settings)
{
  if (is.null(annotations)) {
    annotations <- lapply(xset.msp.scaled,
                          function(x) makeAnnotation(0))
    noannot.idx <- lapply(xset.msp, function(x) 1:length(x))
    xset.work <- xset.msp.scaled
  } else {
    ## throw out those patterns that already have an annotation
    noannot.idx <- mapply(function(x, y)
      which(!(1:length(x)) %in% y[,"pattern"] ),
      xset.msp.scaled,
      annotations)

    #ADD this due to an issue where col with same length output a matrix... and that was a problem for next things
    if(is(noannot.idx)[1] == "matrix"){
      noannot.idx <- as.list(as.data.frame(noannot.idx))
    }
    xset.work <- mapply(function(x, y) x[y], xset.msp.scaled, noannot.idx)

    #ADD this due to an issue where col with same length output a matrix... and that was a problem for next things
    if(is(xset.work)[1] == "matrix"){
      xset.work <- as.list(as.data.frame(xset.work))
    }
    #To correct issue when 1 unkn only in noannot.idx (make a list and not a list of list)
    if(unique(lengths(noannot.idx[1])) == 1){
      xset.work <- lapply(xset.work[1], function(x) list(x))
    }
  }
  
  ## do the matching: a simple double loop over all unassigned patterns
  npatterns <- sum(sapply(xset.work, length))
  cumpatterns <- c(0, cumsum(sapply(xset.work, length)))
  names(cumpatterns) <-  NULL
  
  pattern.match.result <- Matrix::Matrix(0, npatterns, npatterns, sparse = TRUE)
  for (i in 1:(length(xset.work) - 1)) {
    for (j in (i+1):length(xset.work)) {
      matchmat <- match.unannot.patterns(xset.work[[i]],
                                         xset.work[[j]],
                                         settings = settings)
      if (length(matchmat) > 0) {
        for (k in 1:nrow(matchmat)) {
          id1 <- cumpatterns[i] + matchmat[k, "ID1"]  
          id2 <- cumpatterns[j] + matchmat[k, "ID2"]  
          pattern.match.result[id1, id2] <- 1         
          pattern.match.result[id2, id1] <- 1
        }        
      }
    }
  }
  
  ## simply take the first unclustered pattern and add all non-zeros
  ## un the corresponding row of the data matrix as the initial
  ## cluster - add all other non-clustered numbers in the new cluster
  ## members to the list until there is no more growth
  
  grow.clust <- function(seed, pmr) 
    unique(c(unlist(apply(pmr[seed,,drop = FALSE],
                          1,
                          function(x) which(x > 0)))))
  ## we start with a list of zeros, which means: unchecked. Every
  ## unchecked pattern will be used as a seed - if it is part of a
  ## cluster, the whole cluster will receive the same cluster number,
  ## if it is a singleton, it will get label -1.
  pmr.classes <- rep(0, npatterns)
  current.cl <- 1
  while (length(seed <- which(pmr.classes == 0)) > 0) {
    seed <- min(seed)
    clstr <- c(seed, grow.clust(seed, pattern.match.result))
    nel <- length(clstr)
    if (nel == 1) {
      pmr.classes[seed] <- -1
    } else {
      while(length(clstr <- grow.clust(clstr, pattern.match.result))>nel)
        nel <- length(clstr)
      
      pmr.classes[clstr] <- current.cl
      current.cl <- current.cl + 1
    }
  }
  
  ## check for minimal cluster size - for a meaningful value should be
  ## at least 2...
  minsize <- max(2,
                 min(settings$min.class.size,
                     settings$min.class.fraction * length(xset.msp)))
  bigClusters <- which(table(pmr.classes[pmr.classes > 0]) >= minsize)
  if (length(bigClusters) == 0) { ## nothing found
    return(list(annotations = annotations, unknowns = NULL))
  } else {
    pmr.classes[!(pmr.classes %in% bigClusters)] <- -1
    ## get rid of unused cluster numbers
    pmr.classes[pmr.classes > 0] <-
      as.integer(factor(pmr.classes[pmr.classes > 0]))
    clusters <- 1:max(pmr.classes)
    nclus <- length(clusters)
    
    ## every cluster now leads to one pattern in a msp-like structure,
    ## that is found in several samples. As the example pseudospectrum
    ## we take the one that is in the middle of the cluster.
    ## Even though we know the total number of new components to be
    ## added, we do not know in which sample they will be found. So we
    ## will allocate the maximum number of new annotations for each
    ## pattern and will remove the empty ones at the end.
    pspc.DB <- vector(nclus, mode = "list")
    new.annotations <- lapply(xset.work,
                              function(x)
                                makeAnnotation(nclus))
    
    for (cl in 1:nclus) {
      p.idx <- which(pmr.classes == cl)
      ## for these ids we need to find the samples as well as the
      ## patterns involved
      sample.idx <- apply(outer(p.idx, cumpatterns[-1], "<="),
                          1,
                          function(x) which(x)[1])
      spec.idx <- p.idx - cumpatterns[sample.idx]
      
      ## the first one with the most matches is taken as the typical pattern
      central.idx <-
        which.max(Matrix::rowSums(pattern.match.result[p.idx, p.idx]))
      fullspec.idx <- noannot.idx[[ sample.idx[central.idx] ]][[ spec.idx[central.idx] ]]
      pspc.DB[[ cl ]] <-              ## store this pseudospectrum!
        xset.msp[[ sample.idx[central.idx] ]][[ fullspec.idx ]]
      
      ## flag the patterns that match this known unknown in the
      ## annotation object. We need to take care to use the numbers for
      ## ALL patterns, not just for the ones without annotations...
      ## We use negative numbers for the annotation
      ## of the known unknowns, to distinguish them from the annotations
      ## from the real DB
      
      for (ii in seq(along = sample.idx)) {
        fullspec.idx <- noannot.idx[[ sample.idx[ii] ]][[ spec.idx[ii] ]]
        new.annotations[[ sample.idx[ii] ]][cl, "pattern"] <- fullspec.idx
        new.annotations[[ sample.idx[ii] ]][cl, "annotation"] <- -cl
      }
    }
  }
  
  ## now clean the new annotations and return the combined lists
  new.annotations <- lapply(new.annotations,
                            function(x)
                              x[!x[,"pattern"] == 0,])
  
  #I probably have to switch new.annotatoins and annotations
  #Because I obtain an error when the first file has no annotation...
  list(annotations = mapply(rbind, new.annotations, annotations,
                            SIMPLIFY = FALSE),
       unknowns = pspc.DB)
}

## Function match.unannot.patterns takes two lists of unannotated
## patterns and returns a matrix with IDs and RTs of matching
## patterns, as well as the match factor
match.unannot.patterns <- function(msp1, msp2, settings) {
  maxdiff <- ifelse(settings$timeComparison == "rt",
                    settings$rtdiff,
                    settings$RIdiff)
  
  rt1 <- sapply(msp1, function(x) mean(x[,settings$timeComparison]))
  rt2 <- sapply(msp2, function(x) mean(x[,settings$timeComparison]))
  
  msp.rtdiffs <- abs(outer(rt1, rt2, "-"))
  close.idx <- which(msp.rtdiffs < maxdiff, arr.ind = TRUE)
  if (length(close.idx) > 0) {
    X1 <- msp1[close.idx[,1]]
    X2 <- msp2[close.idx[,2]]
    
    matchfactors <- mapply(mzmatch, X1, X2)
    if (any(good.idx <- matchfactors > settings$simthresh)) {
      cbind(ID1 = close.idx[good.idx,1],
            RT1 = rt1[close.idx[good.idx,1]],
            ID2 = close.idx[good.idx,2],
            RT2 = rt2[close.idx[good.idx,2]],
            Match = matchfactors[good.idx])
    } else {
      NULL
    }
  } else {
    NULL
  }
}

## Matching grouped data with the database of standards Input: msp data object containing the samples, a msp data object
## containing the preprocessed DB, and some settings in the form of a list.  Output: a list of two elements, both nested
## lists: the first indicates which pseudospectrum in which sample is associated to which standard, the second contains the
## spectral match factors.

## New implementation, only doing spectral matching for those cases where the rt differences are below the threshold. Much
## faster!

matchSamples2DB <- function(xset.msp, DB, settings, quick) {
    if (settings$timeComparison == "RI") {
        standard.rts <- sapply(DB, function(x) x$std.RI)
        ## rt.matches is a list of two-column matrices, one for each xset.msp element. The first column gives the DB entry that
        ## matches with the sample entry in the second column. This is very fast to calculate.
        rt.matches <- lapply(1:length(xset.msp), function(ii) {
            group.rts <- sapply(xset.msp[[ii]], function(x) mean(x[, "RI"]))
            which(abs(outer(standard.rts, group.rts, FUN = "-")) < settings$RIdiff, arr.ind = TRUE)
        })
    } else {
        standard.rts <- sapply(DB, function(x) x$std.rt)
        
        rt.matches <- lapply(1:length(xset.msp), function(ii) {
            group.rts <- sapply(xset.msp[[ii]], function(x) mean(x[, "rt"]))
            which(abs(outer(standard.rts, group.rts, FUN = "-")) < settings$rtdiff, arr.ind = TRUE)
        })
    }
    
    if (quick) {
        ## xset.msp has already been scaled
        match.results <- lapply(1:length(xset.msp), function(ii) {
            if (nrow(rt.matches[[ii]] > 0)) {
                result <- matrix(0, length(DB), length(xset.msp[[ii]]))
                for (i in 1:nrow(rt.matches[[ii]])) {
                  DB.idx <- rt.matches[[ii]][i, 1]
                  sample.idx <- rt.matches[[ii]][i, 2]
                  result[DB.idx, sample.idx] <- mzmatch(DB[[DB.idx]]$pspectrum, xset.msp[[ii]][[sample.idx]])
                }
            }
            result
        })
    } else {
        ## scaling is done for each comparison separately, since high mz values may be removed depending on MonoMW of the standard
        ## compound. Slower, obviously.
        match.results <- lapply(1:length(xset.msp), function(ii) {
            result <- matrix(0, length(DB), length(xset.msp[[ii]]))
            if (nrow(rt.matches[[ii]] > 0)) {
                for (i in 1:nrow(rt.matches[[ii]])) {
                  DB.idx <- rt.matches[[ii]][i, 1]
                  sample.idx <- rt.matches[[ii]][i, 2]
                  exp.pat <- xset.msp[[ii]][[sample.idx]]
                  
                  MWlimit <- DB[[DB.idx]]$monoMW + 4
                  ## sometimes, with manually added spectra, monoMW is not present... then we use everything up until the highest mass present.
                  if (length(MWlimit) == 0) 
                    MWlimit <- max(DB[[DB.idx]]$pspectrum[, 1])
                  
                  ok.mz <- which(exp.pat[, "mz"] <= MWlimit)
                  if (length(ok.mz) > settings$minfeat) {
                    exp.pat <- treat.DB(list(exp.pat[ok.mz, ]), isMSP = FALSE)
                    result[DB.idx, sample.idx] <- mzmatch(DB[[DB.idx]]$pspectrum, exp.pat[[1]])
                  }
                }
            }
            result
        })
    }
    names(match.results) <- names(xset.msp)
    
    annotations <- lapply(match.results, function(xx) {
        sapply(1:ncol(xx), function(ii) which(xx[, ii] > settings$simthresh))
    })
    
    list(annotations = mapply(annotations2tab, annotations, match.results, SIMPLIFY = FALSE))
}

## This function is designed to be called only inside the
## annotate Table
AnnotateFeature <- function(input,   
                            DB,
                            settings,
                            errf)                            
{               
  
  ## Check weather the intensity is 0 or NA ------------------------- #
  if (is.na(input["I"])) 
      return(which(TRUE & FALSE))   ## Return nothing
  
  if (input["I"] < 1E-5)
      return(which(TRUE & FALSE))
  
  ## If the intensity is good match  --------------------------------- #
  ## calculate the mass tolerance for the feature under analysis
  if (is.null(errf)){
    mztol <-  settings$mzdiff
  } else {
    mztolppm <- predict(errf,
                        data.frame(M = input["mz"],
                                   logI = log10(input["I"])))
    if (mztolppm < settings$ppm) {mztolppm <- settings$ppm}
    mztol <- (mztolppm*1e-6)*input["mz"]
  }
  ## calculate the differences -------------------------------------- #
  deltam <- abs(DB[,"mz"] - input["mz"])
  deltart <- abs(DB[,"rt"] - input["rt"])
  ## combine the tolerances ----------------------------------------- #
  ## Squared sum 
  idm <- deltam < sqrt((DB[,"mz.err"])^2 + (mztol)^2)
  idt <- deltart < settings$rtdiff
  
  which(idm & idt)
}

#############################################################################

AnnotateTable <- function(peaktable,
                          errf,
                          DB,
                          settings) {
  
 
 
 
  ## calculate the tolerance and append a column to the table  
  ## naming the column mz.err
  
  if (is.null(errf)) {
    DB$mz.err <- settings$mzdiff
    printInfo("Fixed mass tolerance", settings$mzdiff)
  } else
  { 
    printInfo("Adaptive mass tolerance")
    ppmtol <- predict(errf,
                      data.frame(M = DB$mz,
                                 logI = log10(DB$maxo)))
    ppmtol[ppmtol < settings$ppm] <- settings$ppm
    DB$mz.err  <- (ppmtol*1e-6)*DB$mz 
  }
 
  ## annotate the full peaklist  -------------------------------------
  ## each peak in the peaktable is associated to
  ## one (or more) entries present in the DB. feat.to.db is a list
  printInfo("Feature-wise Annotation ...")
  feat.to.db <-
    lapply(1:nrow(peaktable),
             function(r) AnnotateFeature(peaktable[r,],
                                         DB = DB,
                                         settings = settings,
                                         errf = errf))
  
  printString("Formatting the output")
  ## -------------------------------------------------------------------
  ## some controls on the results of the annotation                        
  ## 1) no output, return an empty list
  if (length(unlist(feat.to.db)) == 0)
    return (list("annotation.table" = NULL,
                 "compounds" = NULL,
                 "ChemSpiderIDs" = NULL,
                 "multiple.annotations" = NULL,
                 "ann.features" = NULL
                 
    ))  

  ## else go through the list and create a series of tables which
  ## associate features and db entries
  mytable <- lapply(1:length(feat.to.db),
                    function(i) {
                      if (length(feat.to.db[[i]]) == 0) {
                        NA
                      } else {
                        cbind("feature" = i,"db_position" = feat.to.db[[i]])
                      }
                    })
  
  ## mytable <- list()
  ## for (i in seq(along = feat.to.db)){
  ##   ## here I tell what to do if there is no annotation for a feature  
  ##   if(length(feat.to.db[[i]]) == 0) {
  ##     mytable[[i]] <- NA}
  ##   ## otherwise create a table with the features and the associated DB entries
  ##   else {
  ##     mytable[[i]] <- cbind("feature" = i,"db_position" = feat.to.db[[i]])
  ##   }  
  ## }

  ## join everithing in a big table which associates features and db entries

    
  mytable <- do.call(rbind, mytable)
  
  mytable <- mytable[!is.na(mytable[,1]),, drop = FALSE] # remove NAs
  mytable <- as.data.frame(mytable)        # create a data frame
    
  ## add the ChemSpiderID
  mytable[,"ChemSpiderID"] <- DB[mytable[,"db_position"], "ChemSpiderID"]

  ## ------------------------------------------------------------------
  ## At this point I have a table which associates the annotated
  ## features to DB entries namely db_postion and ChemSpiderID
    
    
  ## ------------------------------------------------------------------
  ## To check the quality of the annotation i s necessary to associate each ChemSpiderID 
  ## to the experimental features it is assigned to 
    
  femids <- unique(mytable[, "ChemSpiderID"]) # all the found ChemSpiderID

  ## Create a list of "pseudospectra"
  ## with the experimental features associated
  ## to a specific ChemSpiderID
  ## each elment of the list is a dataframe with the complete
  ## association
    
    
  femid.to.pseudospectrum <- lapply(femids, function(id){
    myid <- mytable[,"ChemSpiderID"] == id
    ## add to the pseudospectrum the info about the db
    output <- mytable[myid,]  
    ## add the  Mass Retention Time and Intensity of the features
    output[,c("mz","rt","I")] <- peaktable[mytable[myid,"feature"],] 
    ## add the mass, retention time and intensity in the DB
    ## to be updated depending on the format of the DB
    output[,c("compound","db_mz","db_rt","db_I","db_ann","mz.err")] <-
        DB[output[,"db_position"],
                 c("compound","mz","rt","maxo","validated", "mz.err")]
    output
  })
  
  
  ## ------------------------------------------------------------------
  ## Each pseudospectrum have to be cleaned and validated
    
    
  ## 1) Erase from the annotations IDs with only one member for
  ## pseudospectrum 
  single.pseudospectra <- sapply(femid.to.pseudospectrum, function(x) dim(x)[1])
  single.no <- single.pseudospectra > 1
  ## update the pseudospectra
  femid.to.pseudospectrum <- femid.to.pseudospectrum[single.no]
    
  if(length(femid.to.pseudospectrum) == 0) {
    return (list("annotation.table" = NULL,
                 "compounds" = NULL,
                 "ChemSpiderIDs" = NULL,
                 "multiple.annotations" = NULL,
                 "ann.features" = NULL))    
  }
  
  ## 2) I need more features with an rt difference < rtval
  femid.to.pseudospectrum.cl <-
      lapply(femid.to.pseudospectrum,
             function(x){
               one <- hclust(dist(x[,"rt"]), method = "complete")
               clid <- cutree(one, h = settings$rtval)
               x[,"clid"] <- clid
               x
             })
  
  ## keep only rows belonging to clusters with enough members
  femid.to.pseudospectrum.final <-
      lapply(femid.to.pseudospectrum.cl,
             function(x) {
               clSize <- table(x[,"clid"])
               bigCl <- as.numeric(names(clSize[clSize >= settings$minfeat]))
               x[x[,"clid"] %in% bigCl,]
             })
  
  ## ## remove the annotation if the number of clid equals the number
  ## ## of elements in the pseudospectrum
  ## which.single.id <-
  ##     sapply(femid.to.pseudospectrum.cl,
  ##            function(x){
  ##              nclass <- length(unique(x[,"clid"]))
  ##              if (nclass == dim(x)[1])
  ##                  {out <- FALSE}
  ##              else (out <- TRUE)
  ##              out
  ##            })
  ## ## update the list of pseudospectra 
  ##   femid.to.pseudospectrum.cl <- femid.to.pseudospectrum.cl[which.single.id]
  
  ## ## 3) clean the pseudospectra from "insulate" features    
  ## femid.to.pseudospectrum.final <-
  ##     lapply(femid.to.pseudospectrum.cl,
  ##            function(x){
  ##              id.in <- which(table(x[,"clid"]) > 1)  ## clusters id with more than one entry
  ##              out <- x[x[,"clid"] %in% id.in,]
  ##              out
  ##            })
    
  if (max(sapply(femid.to.pseudospectrum.final, length)) == 0){
    return (list("annotation.table" = NULL,
                 "compounds" = NULL,
                 "ChemSpiderIDs" = NULL,
                 "multiple.annotations" = NULL,
                 "ann.features" = NULL
                 ))    
  }
  
  ## ----------------------------------------------------------------
  ## Format the output
  format.output <- do.call(rbind, femid.to.pseudospectrum.final)
  ann.table <- table(format.output$feature)
  rownames(format.output) <- NULL
  list("annotation.table" = format.output,
       "compounds" = unique(as.character(format.output[,"compound"])),
       "ChemSpiderIDs" = unique(format.output[,"ChemSpiderID"]),
       "multiple.annotations" = as.numeric(names(ann.table)[ann.table > 1]),
       "ann.features" = unique(format.output[,"feature"])) 
}

## Functions for manipulating, creating, reading and writing msp
## objects, i.e. lists of compounds containing both pseudospectra and
## meta-information.

## Creates an msp object from a list of two-column matrices, supplemented by
## meta-information such as Name, rt, etc. In case three-column
## matrices are given, this will be used for rt and will override any
## rt or rt.sd present in extra.info.

## For consistency: only two-column spectra will be written in the msp
## file, so any retention time information is summarized in the rt and
## rt.sd slots. (Aug 1, 2013)

## bug in construct.msp: current function works only for data.frames
## and not for nested lists, as is promised in the documentation.
construct.msp <- function(spectra, extra.info) {
  if (!(all(sapply(extra.info, length) == length(spectra))))
    stop("Unequal lengths in arguments")

  if (all(sapply(spectra, ncol) == 3)) {
    extra.info$rt <- round(sapply(spectra, function(x) mean(x[,3])), 3)
    extra.info$rt.sd <- round(sapply(spectra, function(x) sd(x[,3])), 4)
  }

  lapply(seq_len(length(spectra)),
         function(ii) 
           c(lapply(extra.info, "[", ii),
             list(pspectrum = spectra[[ii]][,1:2])))
}

## write.msp writes an existing and complete msp object to a
## file. Empty elements are not written. If Name is present, it will
## be used as the first field.
write.msp <- function(msp, file, newFile = TRUE) {
  if (newFile) {
    system(paste("rm -f", file))
    cat("", file = file)
  }
  
  for (i in seq(along = msp)) {
    fields <- names(msp[[i]])
    fields <- fields[fields != "pspectrum"]

    if ("Name" %in% fields)
      fields <- c("Name", fields[fields != "Name"])
    
    for (j in fields) 
      if (length(msp[[i]][[j]]) > 0)
        cat(j, ": ", msp[[i]][[j]], "\n",
            sep = "", file = file, append = TRUE) 

    pspec <- msp[[i]]$pspectrum
    nI <- nrow(pspec)
    cat("Num Peaks:", nI, file = file, append = TRUE)
    for (j in seq_len(nI)) {
      if ((j-1) %% 5 == 0) cat("\n", file = file, append = TRUE)
      cat(" ", pspec[j,1], " ", pspec[j,2], ";",
          sep = "", file = file, append = TRUE)
    }

    cat("\n\n", file = file, append = TRUE)
  }
}

## function to select pseudospectra from an msp object: filtering can
## be done on the basis of rt, mz, relative intensity and number of
## features. Defaults amount to no filtering.
filter.msp <- function(msp, rtrange = NULL, mzrange = NULL,
                       minintens = 0, minPeaks = 0) {
  if (!is.null(rtrange)) {
    rts <- sapply(msp, function(x) x$rt)
    msp <- msp[which(rts < max(rtrange) & rts > min(rtrange))]
  }
  if (length(msp) == 0) return(msp)

  if (!is.null(mzrange)) {
    msp <- lapply(msp,
                      function(x) {
                        mz.idx <- x$pspectrum[,1] > min(mzrange) &
                          x$pspectrum[,1] < max(mzrange)
                        x$pspectrum <- x$pspectrum[mz.idx,]

                        x
                      })
  }

  if (minintens > 0) {
    msp <- lapply(msp,
                      function(x) {
                        I.idx <- (x$pspectrum[,2] / max(x$pspectrum)) > minintens
                        x$pspectrum <- x$pspectrum[I.idx,]
                        
                        x
                      })
  }

  if (minPeaks > 0) {
    npks <- sapply(msp, function(x) nrow(x$pspectrum))
    msp <- msp[npks > minPeaks]
  }

  msp
}

## Function reads an msp file, and returns one list of
## compounds. Argument only.org allow to exclude all molecular
## formulas with non-organic elements. What exactly are organic
## elements can be defined with the optional argument org.set. A
## second optional argument indicates which fields should never be
## converted into numbers, even if possible.
read.msp <- function(file, only.org = FALSE,
                     org.set = c("C", "H", "D", "N", "O", "P", "S"),
                     noNumbers = NULL) {
  ## first define three auxiliary functions, not used outside this function

  ## return the value of the given field in string x. If the field is
  ## not present, either stop with an error or return NULL (e.g. if it
  ## is not a required field)
  get.text.value <- function(x, field, do.err = TRUE) {
    woppa <- strsplit(x, field)
    woppa.lengths <- sapply(woppa, length)
    if (all(woppa.lengths == 2)) {  ## remove leading white space
      sapply(woppa, function(y) gsub("^ +", "", y[2]))
    } else {
      if (do.err) {
        stop(paste("Invalid field", field, "in", x[woppa.lengths != 2]))
      } else {
        NULL
      }
    }
  }

  ## see if only organic elements are present. Strategy: replace these
  ## by "" and convert to numbers. If not possible, then return FALSE.
  ## Jan 26, 2012: add deuterium as an organic element - sometimes
  ## deuterated standards are used
  is.org <- function(strs, org.set)
      { 
        formulas <- get.text.value(strs, "Formula:")
        org.string <- paste("[", paste(org.set, collapse=""), "]",
                            collapse = "")
        suppressWarnings(which(!is.na(as.numeric(gsub(org.string, "",
                                                      formulas)))))
      }
  
  ## read ALL fields in a set of strings from an msp file and return as
  ## an msp object. All elements that can be converted into numbers are
  ## converted, unless explicitly stated in the exception list. Element
  ## "Num Peaks" is treated separately.
  read.compound <- function(strs, noNumbers) {
    if (is.null(noNumbers))
        noNumbers <-  c("Name", "CAS", "stdFile",
                        "date", "validated", "ChemspiderID",
                        "SMILES", "InChI", "Class", "comment",
                        "csLinks")
    
    fields.idx <- grep(":", strs)
    fields <- sapply(strsplit(strs[fields.idx], ":"), "[[", 1)
    
    pk.idx <- which(fields == "Num Peaks")
    if (length(pk.idx) == 0) ## should not happen
        stop("No spectrum found")
    
    ## read all normal fields
    cmpnd <- lapply(fields.idx[-pk.idx],
                    function(x)
                    get.text.value(strs[x],
                                   paste(fields[x], ":", sep = "")))
    names(cmpnd) <- fields[-pk.idx]
    ## convert numeric ones
    cnvrt.idx <- which(!(names(cmpnd) %in% noNumbers))
    cmpnd[cnvrt.idx] <- lapply(cmpnd[cnvrt.idx],
                               function(x) {
                                 if (is.na((y <- as.numeric(x)))) {
                                   x
                                 } else {
                                   y
                                 }
                               })
    
    ## now add pseudospectrum
    nlines <- length(strs)
    npeaks <- as.numeric(get.text.value(strs[pk.idx], "Num Peaks:"))
    peaks.idx <- (pk.idx+1):nlines
    pks <- gsub("^ +", "", unlist(strsplit(strs[peaks.idx], ";")))
    pks <- pks[pks != ""]
    if (length(pks) != npeaks)
        stop("Not the right number of peaks in compound", cmpnd$Name)
    pklst <- strsplit(pks, " ")
    pklst <- lapply(pklst, function(x) x[x != ""])
    cmz <- as.numeric(sapply(pklst, "[[", 1))
    cintens <- as.numeric(sapply(pklst, "[[", 2))
    ##  intens.OK <- cintens >= minintens
    
    finaltab <- matrix(c(cmz, cintens), ncol = 2)
    if (any(table(cmz) > 1)) {
      warning("Duplicate mass in compound ", cmpnd$Name,
              " (CAS ", cmpnd$CAS, ")... summing up intensities")
      finaltab <- aggregate(finaltab[,2],
                            by = list(finaltab[,1]),
                            FUN = sum)
    } 
    colnames(finaltab) <- c("mz", "intensity")
    
    c(cmpnd, list(pspectrum = finaltab))
  }
  

  ## Go!

  huhn <- scan(file, what = "", sep = "\n", quiet = TRUE)
  
  starts <- which(regexpr("Name: ", huhn) == 1)
  ends <- c(starts[-1] - 1, length(huhn))
  
  if (only.org) { ## filter out those compounds with non-organic elements
    formulas <- which(regexpr("Formula:", huhn) == 1)

    if (length(formulas) > 0) {
      orgs <- is.org(huhn[formulas], org.set)
      starts <- starts[orgs]
      ends <- ends[orgs]
    }
  }
  
  
  lapply(seq_len(length(starts)),
         function(i)
         read.compound(huhn[starts[i]:ends[i]], noNumbers = noNumbers))
}


## to.msp is a function to export features (mz / I combinations) to a
## text file so that it can be used for searching the extDB (in our case NIST)
## library. In general, several groups will be written. If the first
## argument is an annotation object, CAMERA groups will be used; if it
## is a peak table, the retention time will be used to create groups
## (retention times should be exactly equal!). Nothing will be written
## if file equals NULL, but an object will be returned, now also
## containing retention time information.
## Addition Jan 31: the xsAnnotate object can contain data from more
## than one file.
## Bug, corrected May 15: ndigit was only used for rounding when
## writing to a file...
## bug: minintens not used in the proper way (addressed March 25,
## 2013) - should be a fraction of the most intense signal
## March 25: removed default values for minfeat and minintens. These
## should always come from the pipeline settings
## July 23: added an additional settings argument which summarizes
## individual arguments (and has precedence over these, too).

to.msp <- function(object, file = NULL,
                   settings = NULL, ndigit = 0, minfeat, minintens,
                   intensity = c("maxo", "into"), secs2mins = TRUE) {
  if (!is.null(settings)) {
    intensity <- settings$intensityMeasure
    minfeat <- settings$minfeat
    minintens <- settings$minintens
  } else {
    intensity <- match.arg(intensity)
  }
  
  if (is(object)[1] == "xsAnnotate") { ## CAMERA annotation object
    allpks <- object@groupInfo
    minI <- minintens * max(allpks[, intensity])
    tooSmall <- which(allpks[, intensity] < minI)
    
    pspectra <- lapply(object@pspectra,
                       function(x) x[!x %in% tooSmall])
  } else { ## a peak table
    minI <- minintens * max(object[, intensity])
    allpks <- object[object[, intensity] >= minI,]
    pspectra <- split(seq_len(nrow(allpks)), allpks[,"rt"])
  }
  
  ## remove all spectra with less than minfeat peaks
  npeaks <- sapply(pspectra, length)
  pspectra <- pspectra[npeaks >= minfeat]

  if (!is.null(file)) {
    if (length(pspectra) > 0) {
      for (i in seq_len(length(pspectra))) {
        ## maximum of 1000 features per file
        ofile <- paste(file, "_", ceiling(i / 1000), ".txt", sep = "")
        newfile <- (i %% 1000) == 1
        
        idx <- pspectra[[i]]
        pks <- allpks[idx,,drop = FALSE]
        pks <- pks[order(pks[,"mz"]),,drop = FALSE]
        pks[,intensity] <- 1000*pks[,intensity]/max(pks[,intensity])
        
        cat("Name: grp ", i, " (rt: ", mean(pks[,"rt"]), ")", sep = "",
            file = ofile, append = !newfile)
        cat("\nNum Peaks:", nrow(pks), file = ofile, append = TRUE)
        for (ii in seq_len(nrow(pks))) 
          cat("\n(",
              round(pks[ii, "mz"], ndigit), "\t",
              round(pks[ii, intensity], ndigit), ")",
              file = ofile, append = TRUE, sep = "")
        
        cat("\n\n", file = ofile, append = TRUE)
      }
    }
  }
  
  result <-
    removeDoubleMasses(lapply(pspectra,
                              function(x)
                              cbind(mz = round(allpks[x,"mz"], digits = ndigit),
                                    allpks[x, c(intensity, "rt")])))

  if (secs2mins) {
    invisible(lapply(result,
                     function(x) cbind(x[,c("mz", intensity)],
                                       rt = x[,"rt"] / 60)))
  } else {
    invisible(result)
  }
}

## SearchNIST is a function added to assist user accessing their own copy of NIST database
## starting from a MSP file created by to.msp function
## The fucntion will help creating the connection between R and NIST mass spectral library search tool on Windows OS
## Require NIST MS (Mass Spectral) Search Program Version 2.0 or higher AND Windows OS
## Please remove AUTOIMP.MSD file from C:\NISTMS\MSSEARCH before first launch
# GUITTON Yann - 2015 Laberca

SearchNIST<-function(mspfile=NULL, savepath=NULL){
  
  
  #create a local output directory
  if (is.null(savepath)){
    savepath<-choose.dir(default=getwd(), caption="Please, select your Saving directory")
  }
  
  setwd(savepath)
  st<-strsplit(date(), " ")[[1]]
  stBis<-strsplit(st[4], ":")[[1]]
  Hour<-paste(stBis[1], stBis[2], stBis[3], sep="-")
  Date<-paste(st[1], st[2], st[3], Hour, sep="_")
  Mypath<-paste("output_SearchNIST", "_", "result", Date, sep="")
  dir.create(Mypath)
  
  if (is.null(mspfile)==TRUE) {
    rm(mspfile)
  }
  
  #System Check 
  if ((Sys.info()["sysname"])!="Windows"){
    cat("Sorry, this function only works on Windows. Your OS is not Windows.\n")
    
  }
  else
  {
    #Search for MSSEARCH location should be c:/nist/mssearch
    if (file.exists(file.path("C:", "Windows","win.ini"))==TRUE){
      nistpath<-readLines(file.path("C:", "Windows","win.ini"))[pmatch("Path32", readLines(file.path("C:", "Windows","win.ini")))]
      if(is.na(nistpath)!=TRUE){
        nistpath<-file.path(unlist(strsplit(nistpath, split="="))[2])
        
      }
      if(is.na(nistpath)){
        nistpath<-readLines(file.path("C:", "Windows","win.ini"))[pmatch("Path16", readLines(file.path("C:", "Windows","win.ini")))]
        print("Your NIST MS program version is <2.0 or impossible to detect NIST")
        if(is.na(nistpath)){
          nistpath<-choose.dir(default=getwd(), caption="Please, select the MS SEARCH directory, should be c:/nist/mssearch/")
          print(nistpath)
        }
      }
      
      
    }
    if (file.exists(file.path("C:", "Windows","win.ini"))==FALSE){
      nistpath<-choose.dir(default=getwd(), caption="Please, select the MS SEARCH directory, should be c:/nist/mssearch/")
    }
    if(file.exists(file.path(nistpath,"AUTOIMP.MSD"))==TRUE){
      firstlocatorpath<-file.path(nistpath,"AUTOIMP.MSD")
      secondlocatorpath<-file.path(readLines(file.path(firstlocatorpath)))
    }
    if(file.exists(file.path(nistpath,"AUTOIMP.MSD"))==FALSE){
      #create AUTIMP.MSD file
      secondlocatorpath<-"FILESPEC.FIL"
      zz<-file(file.path(nistpath,"AUTOIMP.MSD"))
      cat(secondlocatorpath, file = zz, sep = "\n")
      close(zz)
      firstlocatorpath<-file.path(nistpath,"AUTOIMP.MSD")
    }
    if(file.exists(file.path(nistpath,"SRCREADY.TXT"))==TRUE){
      unlink(file.path(nistpath,"SRCREADY.TXT"))
    }
    
    #create FILSPEC.FIL
    if(exists("mspfile")==FALSE){
      mspfile<-choose.files(default=paste(getwd(),"/*.msp",sep=""),caption="Please, select the MSP file", multi=FALSE, filters=matrix(c("your msp file","*.msp"),ncol=2))
      zz<-file("FILESPEC.FIL", "w")
      cat(paste(file.path(mspfile),"Overwrite",sep=" "), file = zz, sep = "\n")
      cat(paste(23,62789), file = zz, sep = "\n")
      close(zz)
    }
    if(exists("mspfile")==TRUE){
      
      #zz<-file(paste(nistpath,"FILESPEC.FIL", sep=""), "w")
      zz<-file("FILESPEC.FIL", "w")
      cat(paste(file.path(mspfile),"Overwrite",sep=" "), file = zz, sep = "\n")
      cat(paste(23,62789), file = zz, sep = "\n")
      close(zz)
    }
    code<-paste(file.path(nistpath,"nistms$.exe"), " /Instrument /par=2", sep="")
    #system("c:/nist05/mssearch/nistms$.exe /Instrument /par=2")
    system(code)
    stopflag=FALSE
    print("Please wait...")
    Sys.sleep(3)
    
    while(stopflag==FALSE){
      
      if(file.exists(file.path(nistpath,"SRCREADY.TXT"))==TRUE){
        stopflag=TRUE
        print("Done")
        
      }
      
      
      
    }
    file.copy(file.path(nistpath,"SRCRESLT.TXT"),file.path(Mypath,"ResultsFromNIST.txt"))
    print(paste("A file called ResultsFromNIST.txt has been generated in ", Mypath, sep=" "))
    #a parser for that file is needed
    #clean unused files from directories needed
  }#end else system check
  
}#end function

## Function getFeatureInfo yields a data.frame with meta-information on all features detected in the samples. Features are
## rows; information is in the columns. The last column of the meta-info is always 'rt'.

getFeatureInfo <- function(stdDB, allMatches, sampleList) {
    signif.rt <- 3
    signif.rt.sd <- 4
    signif.RI <- 0
    
    allAnnotations <- sort(unique(unlist(sapply(allMatches$annotations, function(x) x[, "annotation"]))))
    allAnnotations <- c(allAnnotations[allAnnotations > 0], rev(allAnnotations[allAnnotations < 0]))
    
    ## add rt and rt.sd information, and possibly RI info
    patRTs <- lapply(sampleList, function(x) sapply(x, function(xx) mean(xx[, "rt"])))
    if ("RI" %in% colnames(sampleList[[1]][[1]])) {
        RIpresent <- TRUE
        patRIs <- lapply(sampleList, function(x) sapply(x, function(xx) mean(xx[, "RI"])))
    } else {
        RIpresent <- FALSE
    }
    
    pSpectra <- lapply(allAnnotations[allAnnotations > 0], function(x) {
        hits <- lapply(allMatches$annotations, function(xx) xx[xx[, "annotation"] == x, "pattern"])
        rts <- mapply(function(x, y) ifelse(length(y) > 0, x[y], NA), patRTs, hits)
        
        if (RIpresent) {
            RIs <- mapply(function(x, y) ifelse(length(y) > 0, x[y], NA), patRIs, hits)
            c(stdDB[[x]], list(rt = round(mean(rts, na.rm = TRUE), signif.rt), rt.sd = round(sd(rts, na.rm = TRUE), signif.rt.sd), 
                RI = round(mean(RIs, na.rm = TRUE), signif.RI)))
        } else {
            c(stdDB[[x]], list(rt = round(mean(rts, na.rm = TRUE), signif.rt), rt.sd = round(sd(rts, na.rm = TRUE), signif.rt.sd)))
        }
    })
    
    if (length(pSpectra) > 0) {
        ## in the meta information we include all fields present in the stdDB, except for the pspectrum, std.rt.sd, and bestDBmatch.
        ## 'Name' is always the first entry, 'rt' always the last, and the other rt-related fields directly in front of 'rt'.
        fields <- unique(unlist(lapply(pSpectra, names)))
        if (RIpresent) {
            rtfields <- c("std.RI", "std.rt", "RI", "rt.sd", "rt")
        } else {
            rtfields <- c("std.rt", "rt.sd", "rt")
        }
        fields <- c("Name", fields[!(fields %in% c("Name", "pspectrum", "bestDBmatch", "std.rt.sd", rtfields))], rtfields)
        
        meta.info <- lapply(pSpectra, function(x) {
            notPresent <- which(is.na(match(fields, names(x))))
            if (length(notPresent) > 0) {
                newlst <- lapply(notPresent, function(nm) NA)
                names(newlst) <- fields[notPresent]
                c(newlst, x[fields[-notPresent]])
            } else {
                x[fields]
            }
        })
        ## Next two instructions as suggested by Martin Morgan at
        ## http://stackoverflow.com/questions/4512465/what-is-the-most-efficient-way-to-cast-a-list-as-a-data-frame?rq=1
        f <- function(x) function(i) unlist(lapply(x, `[[`, i), use.names = FALSE)
        meta.info.df <- as.data.frame(Map(f(meta.info), fields), stringsAsFactors = FALSE)
    } else {
        ## no DB, or no hits from DB
        meta.info.df <- data.frame(Name = 1, Class = 1, rt.sd = 1, rt = 1)[FALSE, ]
    }
    
    ## Since the labels are negative, label -1 corresponds to the last unknown spectrum. This convention is also used in
    ## allAnnotations and in function constructExpPseudoSpectra
    nstd <- nrow(meta.info.df)
    nunkn <- sum(allAnnotations < 0)
    
    if (nunkn > 0) {
        meta.info.df <- rbind(meta.info.df, meta.info.df[rep(1, nunkn), ])
        row.names(meta.info.df) <- 1:nrow(meta.info.df)
        meta.info.df[(nstd + 1):nrow(meta.info.df), ] <- NA
        
        meta.info.df[(nstd + 1):(nstd + nunkn), "Name"] <- paste("Unknown", 1:nunkn)
        meta.info.df[(nstd + 1):(nstd + nunkn), "Class"] <- "Unknown"
        meta.info.df[(nstd + 1):(nstd + nunkn), "rt"] <- round(sapply(allMatches$unknowns, function(x) mean(x[, "rt"])), signif.rt)
        meta.info.df[(nstd + 1):(nstd + nunkn), "rt.sd"] <- round(sapply(allMatches$unknowns, function(x) sd(x[, "rt"])), signif.rt.sd)
        
        if (RIpresent) 
            meta.info.df[(nstd + 1):(nstd + nunkn), "RI"] <- round(sapply(allMatches$unknowns, function(x) mean(x[, "RI"])), 
                signif.RI)
    }
    
    meta.info.df
}

## Function constructExpPseudoSpectra creates an msp object containing all the patterns referenced to in the annotation. The
## first argument is the output of function matchSamples2Samples and contains the full annotation matrix and the pseudospectra
## of the known unknowns; the second is the msp object containing the standards that are actually found

constructExpPseudoSpectra <- function(allMatches, standardsDB) {
    allAnnotations <- sort(unique(unlist(sapply(allMatches$annotations, function(x) x[, "annotation"]))))
    
    stdDB <- lapply(allAnnotations[allAnnotations > 0], function(x) c(standardsDB[[x]], list(DB.idx = x)))
    
    if (min(allAnnotations) < 0) {
        ## write known unknowns
        unknDB <- allMatches$unknowns
        
        if ("RI" %in% colnames(unknDB[[1]])) {
            extra.info <- data.frame(Name = paste("Unknown", 1:length(unknDB)), DB.idx = sort(allAnnotations[allAnnotations < 
                0], decreasing = TRUE), rt = sapply(unknDB, function(x) round(mean(x[, "rt"]), 2)), RI = sapply(unknDB, function(x) round(mean(x[, 
                "RI"]), 0)), Class = "Unknown", stringsAsFactors = FALSE)
        } else {
            extra.info <- data.frame(Name = paste("Unknown", 1:length(unknDB)), DB.idx = sort(allAnnotations[allAnnotations < 
                0], decreasing = TRUE), rt = sapply(unknDB, function(x) round(mean(x[, "rt"]), 2)), Class = "Unknown", stringsAsFactors = FALSE)
        }
        unkn.msp <- construct.msp(spectra = unknDB, extra.info)
        
        c(stdDB, unkn.msp)
    } else {
        stdDB
    }
}

metaMSsettings <-
    setClass("metaMSsettings", 
             slots = c(protocolName = "character",
                 chrom = "character",
                 PeakPicking = "list",
                 Alignment = "list", 
                 CAMERA = "list",
                 ## match2DB is used both for GC and for LC -
                 ## which elements must be present depends on the
                 ## chromatography
                 match2DB = representation(
                     rtdiff = "numeric",                      # both
                     minfeat = "numeric",                     # both
                     rtval = "numeric",                       # LC
                     mzdiff = "numeric",                      # LC
                     ppm = "numeric",                         # LC
                     simthresh = "numeric",                   # GC
                     timeComparison = "character",            # GC
                     RIdiff = "numeric"                       # GC
                     ),
                 ## DBconstruction is used both for GC and for LC -
                 ## which elements must be present depends on the
                 ## chromatography
                 DBconstruction = representation(
                     minfeat = "numeric",                     # both
                     rttol = "numeric",                       # LC
                     mztol = "numeric",                       # LC
                     minintens = "numeric",                   # LC
                     intensityMeasure = "character",          # GC
                     DBthreshold = "numeric"),                # GC
                 matchIrrelevants = representation(
                     irrelevantClasses = "character",
                     simthresh = "numeric",
                     timeComparison = "character",
                     RIdiff = "numeric",    
                     rtdiff = "numeric"),
                 betweenSamples = representation(
                     min.class.fraction = "numeric",
                     min.class.size = "numeric",
                     timeComparison = "character",
                     rtdiff = "numeric",
                     RIdiff = "numeric",    
                     simthresh = "numeric")
                 ))

setMethod("show", "metaMSsettings",
          function(object) {
            cat("Object of class '", class(object), "'\n", sep = "")
            cat("Instrument:", object@protocolName, "\n")
            cat("Chromatography:", object@chrom, "\n")
          })

setGeneric("metaSetting",
           function(object, field){standardGeneric("metaSetting")})

setGeneric("metaSetting<-",
           function(object, field, value){standardGeneric("metaSetting<-")})

setMethod("metaSetting", "metaMSsettings",
          function(object, field) {
            if (field %in% slotNames(object)) {
              return(slot(object, field))
            } else {
              chromatography <- object@chrom
              if (chromatography == "GC") {
                multiFields <- c('match2DB', 'DBconstruction',
                                 'matchIrrelevants', 'betweenSamples')
              } else {
                multiFields <- c('match2DB', 'DBconstruction')
              }
              if (field %in% multiFields) {
                allnames <- slotNames(object)
                allnames <- allnames[grep(field, allnames)]
                lnames.lst <- strsplit(allnames, field)
                lnames <- sapply(lnames.lst, function(x) substr(x[2],
                                                                2, 100))
                result <- lapply(allnames, function(x) slot(object, x))
                names(result) <- lnames
                
                result[sapply(result, length) > 0]
              } else {
                stop(paste("For ", chromatography,
                           ", 'field' should be a valid slot name, or one of ",
                           paste(multiFields, collapse = ", "),
                           sep = "")) 
              }
            }})

setReplaceMethod(
    f = "metaSetting",
    signature = "metaMSsettings",
    definition = function(object, field , value) {
      if (field %in% slotNames(object)) {
        slot(object, field) <- value
        return(object)
      } else {
        chromatography <- object@chrom
        if (chromatography == "GC") {
          multiFields <- c('match2DB', 'DBconstruction',
                           'matchIrrelevants', 'betweenSamples')
        } else {
          multiFields <- c('match2DB', 'DBconstruction')
        }
        if (field %in% multiFields) {
          for (i in seq(along = value)) {
            slname <- names(value)[i]
            slot(object, paste(field, slname, sep = "."),
                 check = TRUE) <- value[[i]]
          }
          
          return(object)
        } else {
          stop(paste("For ", chromatography,
                     ", 'field' should be a valid slot name, or one of ",
                     paste(multiFields, collapse = ", "),
                     sep = "")) 
        }
      }})

\documentclass[a4paper]{article}
%\VignetteIndexEntry{runLC}

\usepackage{geometry}
\usepackage{layout}

\geometry{
  includeheadfoot,
  margin=2.54cm
}

\newcommand{\pkg}[1]{{\normalfont\fontseries{b}\selectfont #1}}
\newcommand{\proglang}[1]{{\sffamily #1}}
\newcommand{\code}[1]{{\ttfamily #1}}
\newcommand{\R}{\proglang{R}}

\newcommand{\bC}{\mbox{\boldmath{$C$}}}
\newcommand{\bE}{\mbox{\boldmath{$E$}}}
\newcommand{\bS}{\mbox{\boldmath{$S$}}}
\newcommand{\bX}{\mbox{\boldmath{$X$}}}

\newcommand{\compresslist}{%
  \setlength{\itemsep}{1pt}%
  \setlength{\parskip}{0pt}%
  \setlength{\parsep}{0pt}%
}

\renewcommand{\textfraction}{0}

\title{Annotation of LC-MS metabolomics datasets by the ``metaMS'' package}
\author{Pietro Franceschi}

\begin{document}
%%%\SweaveOpts{concordance=TRUE}

\maketitle

\section{Introduction}
\pkg{metaMS} is designed to perform the analysis of LC-MS and
GC-MSbased metabolomics assays. For LC-MS data, its major function
\code{runLC()} is a wrapper around the functions and classes of {\bf
  xcms} and {\bf CAMERA} and it is designed to process a series of
data files producing a peak table with the intensity of each feature -
an mz,rt couple -  in each one of the samples. The functions and
classes of \pkg{xcms} and \pkg{CAMERA} are used to perform the peak
picking, grouping and retention correction, peak filling, and CAMERA
annotation. The parameters required at each step are collected into a
settings object which is passed as an argument to \code{runLC}. Three
examples, fine-tuned for instruments in our own laboratory, are included:
<<>>=
library(metaMS)
data(FEMsettings)
Synapt.RP
@ 
Consult the manual pages for more details. Package
\pkg{metaMS} implements a strategy to generate an annotation database
by processing the injections of a list chemical standards, which have
been analyzed under the same chromatographic conditions as the
samples. The injections of the standards are processed by \pkg{xcms}
and \pkg{CAMERA} and the peak lists are matched against a manually
validated reference table to identify the set of features associated
to each compound. These features are then organized in the database
used for the annotation which is included in the output of
\code{runLC()}. In the following, database generation and feature
annotation are described in details, while for the discussion of
\pkg{xcms} and \pkg{CAMERA} the reader should refer to their specific
documentation. 

\section{Example Data}
A part of the data used to illustrate database creation and feature
annotation is included in \code{metaMS}, while the more heavy
experimental data have been included in the \pkg{metaMSdata}
package. For LC-MS  \pkg{metaMSdata} contains four CDF files referring
to the analysis of a mixture of chemical standards. These files have
been converted to the open source CDF format by using proprietary
vendor software (Waters, Databridge). The system specific position of
the example files can be determined as follows: 
<<>>=
library(metaMSdata)
cdfpath <- system.file("extdata", package = "metaMSdata")
files <- list.files(cdfpath, "_RP_", full.names=TRUE)
files
@

The construction of the database is performed on the basis of a
manually validated reference table which contains the key analytical
information for each standard. The example table is part of
\pkg{metaMS}:
<<>>=
library(metaMS)
data(exptable)
@
The content of the table can be visualized as follows:
<<>>=
head(exptable)
@

\begin{itemize}
\item \code{ChemSpiderID}: an unique numeric identifier for a chemical
  standard from the freeware ChemSpider database
  (http://www.chemspider.com). 
\item \code{compound}: a string with the human readable name of the
  standard. This name is used to produce the output of the
  annotation. 
\item \code{formula}: the chemical formula of the compound. This field
  is included in view of future developments. 
\item \code{M.ref}: the theoretical mass for the observed ion. This
  field is included in view of future developments. 
\item \code{mz.observed}: the manually validated {\it m/z} value which
  identifies the ``main" ion for this specific compound. In the
  majority of cases, one would choose the most most intense ion of
  each compound. To avoid wrong assignments the best practice should
  be to ask to the analyst to ``identify" the nature of the ion
  (protonated/deprotonated, adduct, dimer, common fragment, ...).   
\item \code{RTman}: the manually validated retention time for the
  standard (in minutes). 
\item \code{stdFile}: the complete path which points to the raw file
  of the injection of the standard. 
\end{itemize}



\section{Database Construction}
In order to create the database, the \code{stdFile} column in
\code{exptable} has to be updated with the complete path pointing to
the correct CDF file: 
<<>>=
exptable$stdFile <- sapply(exptable$stdFile, grep, files, value = TRUE)
exptable$stdFile
@
The annotation database is constructed on the basis of \code{exptable}
with the following workflow: 
\begin{enumerate}
\item {\sc Peak picking}. The injections of the standards are
  processed to produce a feature list by using the parameters
  specified in the \code{PeakPicking} slot of the \code{settings}
  list. For each feature, the maximum value of the signal on the
  chromatographic peak (\code{maxo}) is extracted. For a detailed
  description of the single settings refer to the package
  documentation. 
<<>>=
metaSetting(Synapt.RP, "PeakPicking")
@
\item {\sc Feature grouping}. \code{CAMERA} with its default settings
  is used to group the features in pseudospectra and annotate them
  looking for isotopes and common adducts. These pseudospectra can be
  therefore considered as mass spectrometric fingerprints of compounds
  eluting at a specific retention time. It is important to remember
  that co-eluting compounds are likely to be grouped together, in
  particular where chromatographic separation is not optimal (e.g. at
  the extreme ends of a chromatographic run).  
\item {\sc Ref. Table Matching}. The full list of feature is matched
  with \code{exptable} looking for features compatible with
  \code{M.ref} and \code{RTman}. The {\it m/z} and retention time
  tolerances are fixed and specified in the \code{DBconstruction}
  element of the \code{settings} list.  
<<>>=
metaSetting(Synapt.RP, "DBconstruction")
@
The retention time tolerance is specified in minutes, the {\it m/z}
one in dalton. The \code{minfeat} parameter is used to prevent the
inclusion in the database of standards with a very low number of
associated features. This unfortunate situation can happen, for
example, when the signal is too low either because a chemical is not
efficiently ionized or because it has been injected with low
concentration. The absence of a good matching for a specific compound
is notified on the output on the screen. 
\item {\sc Database Creation} The features assigned to each standard
  are collected into a dataframe which can be used for annotation. At
  this stage an additional filter on the feature intensities is
  applied: only the ones with an intensity bigger than \code{Ithr} are
  kept. This is done to avoid inserting in the DB low intensity
  features coming from the noise. 
\end{enumerate}

Consider as an example the construction of the database included in
the \code{metaMS} package. It contains four chemical standards: 
<<>>=
exptable$compound
@
The reference table has been already described. The data can be loaded
as follows:
<<>>=
library(metaMSdata)
cdfpath <- system.file("extdata", package = "metaMSdata")
files <- list.files(cdfpath, "_RP_", full.names=TRUE)
exptable$stdFile <- sapply(exptable$stdFile,
                           function(x)
                           files[grep(x,files)])
@

For this example the \code{minfeat} parameter is set to 2:
<<>>=
metaSetting(Synapt.RP, "DBconstruction.minfeat")  <- 2
@

The database is constructed by using the\code{createSTDdbLC} function:
<<eval = FALSE, echo = TRUE>>=
LCDBtest <- createSTDdbLC(stdInfo=exptable, 
                          settings = Synapt.RP,
                          polarity = "positive",
                          Ithr = 20)
@
The messages on the screen can be used to monitor the progress of the analysis.
In practice, the \code{createSTDdbLC} function is all that users need to
use. 

The example DB is also available as data object \code{LCDBtest} and
can be loaded with
<<>>=
data(LCDBtest)
@
The example database is a list of three elements:
<<>>=
names(LCDBtest)
@
The first contains the reference table:
<<>>=
head(LCDBtest$Reftable)
@
The second contains the settings and the date of creation of the DB:
<<>>=
names(LCDBtest$Info)
@
The third is the true database:
<<>>=
head(LCDBtest$DB)
@
Each line of this \code{data.frame} is a feature detected at \code{mz}
and \code{rt} with an intensity \code{maxo}. The output of
\pkg{CAMERA} annotation are presented in the \code{adduct} and
\code{isotopes} fields. \code{ChemSpiderID} and \code{compound}
identify the compound which a feature is associated to. The
\code{validate} column is set to \code{automatic} to indicate that the
feature has been assigned to the neutral by using an automatic
algorithm, without performing any manual validation of the results.

It is interesting to see how many features are included in the DB and
their association to the four chemical standards included in the
reference table:
<<>>=
table(LCDBtest$DB$compound)
@


\section{Annotation}
In the previous section, we have illustrated how to create a database
from a series of injections of standards. This DB can then be used to
annotate the results of the analysis of a complete metabolomic
experiment by passing it to the main \code{runLC} function. It is
important to remember that this type of annotation relies very much on
the retention time, so it gives its best results when the standards
and the samples have been analyzed under the same chromatographic and
mass-spectrometric conditions.  

Considering that in LC-MS experiments co-elution of different
compounds is the rule rather than the exception, the annotation is
performed feature-wise (each feature is independently matched with the
DB) and a subsequent validation step is performed. The idea is to
retain annotations only if more than one feature associated to a
specific compound is found in the peak list. How many ``validation"
features are requested is an adjustable parameter included in the
(\code{minfeat} slot of the settings object). For matching
and validation it is necessary to specify mass and {\it m/z}
tolerances, accounting for mass and retention time shifts. For
retention time the tolerance is fixed and it is specified in the
settings. For {\it m/z}, the package implements either a {\it fixed
  tolerance} or an {\it adaptive tolerance}. The use of an {\it
  adaptive tolerance} to optimize the results of the annotation for
Q-TOF spectrometers has been proposed by the authors in
\cite{Shahaf2013}. With this approach, the optimal {\it m/z} tolerance
is calculated taking into account the {\it m/z} value for a specific
ion and its intensity: these two parameters are indeed affecting the
accuracy of this specific class of analyzers. A more detailed
description of the approach can be found in the manual pages of the
package and in the specific reference.     

The implemented annotation strategy can be broken down in the following steps:
\begin{enumerate}
\item {\sc Feature wise Annotation} Each feature detected by
  \code{runLC} is matched against the database. If the mass error
  function is provided, the appropriate {\it m/z} tolerance is
  calculated, otherwise a fixed tolerance is used
  (\code{mzdiff}). The retention time tolerance is fixed and should
  be selected on the bases of the characteristics of each
  chromatographic method (\code{rtdiff}). Multiple annotations -
  i.e. features which are associated to more than one compound - are
  possible. This outcome does not indicate a problem {\it per se}, but
  is an inherent drawback of co-elution. 
\item {\sc Annotation Validation} The annotated features are organized
  in ``pseudospectra" collecting all the experimental features which
  are assigned to a specific compound. A specific annotation is
  confirmed only if more than \code{minfeat} features which differ in
  retention time less than \code{rtval} are present in a
  pseudospectrum. As a  general rule \code{rtval} should be narrower
  than \code{rtdiff}. The latter, indeed, accounts for shifts in
  retention time between the injection of the standards and the
  metabolomics experiment under investigation. This time can be rather
  long, considering that the standards are not commonly re-analyzed
  each time. On the other hand,\code{rtval} represents the shift
  between the ions of the same compound within the same batch of
  injections and therefore it has only to account for the smaller
  shifts occurring during peak picking and alignment. 
\end{enumerate}

To illustrate the procedure consider the results of the annotation of
the example data included in \code{metaMSdata} with the
\code{LCDBtest} db. Here we set a fixed mass tolerance and we use the
settings for a Reverse Phase chromatography.
<<eval = FALSE, echo = TRUE>>=
LC <- runLC(files, settings = Synapt.RP, DB = LCDBtest$DB)
@
The progress of the analysis can be followed from the messages on the
screen. As before, the results from this vignette are available 
in data object \code{LCresults} -- this is used here to demonstrate
the structure of the output without having to create it on the 
fly, which simply takes too much time.
<<>>=
data(LCresults)
@

A summary of the results of the annotation can be found in the
\code{Annotation} element of \code{LCresults}: 
<<>>=
head(LCresults$Annotation$annotation.table)
@
This dataframe contains the complete results of the annotation. 
\begin{itemize}
\item \code{feature}: the index of the annotated feature in the peak table.
\item \code{ChemSpiderID}: the Chem Spider ID of the neutral the
  feature is associated to. 
\item \code{dbposition}: the position inside the DB of the matching entry.
\item \code{mz, rt, I}: mass, retention time and intensity of the feature.
\item \code{compound}: the (human) readable name of the standard.
\item \code{db\_mz, db\_rt, db\_I, db\_ann}: information relative to
  the corresponding DB entry. 
\item \code{mz.err}: the {\it m/z} error used in the matching.
\item \code{clid}: the results of a hierarchical clustering of the
  retention times of the annotated features. This can be used to
  identify the presence of sub groupings of the features which are
  assigned to the same standard, thus suggesting the presence of
  co-eluting isomers/compounds. The HC tree is cut at a hight of
  \code{rtval}.
\end{itemize}

<<>>=
LCresults$Annotation$compounds
LCresults$Annotation$ChemSpiderIDs
@
These are the list of standards found in the peaklist.

<<>>=
LCresults$Annotation$multiple.annotations
@
This is the list of features which show multiple annotations

<<>>=
LCresults$Annotation$ann.features
@
The list of the features with annotation.

Inside the results,the outputs of the annotation are also included in
a more compact form as part of the peak table in the
\code{ChemSpiderID} and \code{compound} columns: 
<<>>=
head(LCresults$PeakTable)
@



\clearpage

\bibliographystyle{unsrt}
\bibliography{LC} 

\end{document}

\documentclass[a4paper]{article}
%\VignetteIndexEntry{runGC}

\usepackage{geometry}
\usepackage{layout}

\geometry{
  includeheadfoot,
  margin=2.54cm
}

\newcommand{\pkg}[1]{{\normalfont\fontseries{b}\selectfont #1}}
\newcommand{\proglang}[1]{{\sffamily #1}}
\newcommand{\code}[1]{{\ttfamily #1}}
\newcommand{\R}{\proglang{R}}

\newcommand{\bC}{\mbox{\boldmath{$C$}}}
\newcommand{\bE}{\mbox{\boldmath{$E$}}}
\newcommand{\bS}{\mbox{\boldmath{$S$}}}
\newcommand{\bX}{\mbox{\boldmath{$X$}}}

\newcommand{\compresslist}{%
  \setlength{\itemsep}{1pt}%
  \setlength{\parskip}{0pt}%
  \setlength{\parsep}{0pt}%
}

\renewcommand{\textfraction}{0}

\title{Analysis of GC-MS metabolomics data with metaMS}
\author{Ron Wehrens}

\begin{document}

\maketitle

\section{Introduction}
Many packages are available for the analysis of data from GC-MS and
LC-MS experiments -- typically, hardware vendors provide software that
is optimized for the instrument and allow for a direct interaction of
the lab scientist with the data. For high-throughput applications,
however, more automatic pipelines are needed. Open-source alternatives
such as \pkg{xcms}~\cite{Smith2006} not only are able to handle data
from several different types of spectrometers, but can also be
integrated easily in web interfaces~\cite{Tautenhahn2012}, allowing
large numbers of files to be processed simultaneously.

Because of the generality of packages like \pkg{xcms}, several other
packages have been written to tweak the functionality of \pkg{xcms}
for optimal performance in a particular context. Package \pkg{metaMS}
does so for the field of untargeted metabolomics; this vignette
focuses on the analysis of GC-MS data. In comparison with the usual
\pkg{xcms} pipeline several changes have been implemented, the most
important of which are:
\begin{itemize}
  \item the package collects all user-changeable settings in one list,
    with elements for the individual stages of the data processing
    pipeline. This improves consistency and maintainability;
  \item rather than a feature-based analysis, as is the case with
    \pkg{xcms}, \pkg{metaMS} performs a pseudospectrum-based analysis,
    where the basic entity is a collection of (mz, I) pairs at
    specific retention times. This avoids the alignment step, which
    can be extremely difficult for GC-MS data;
  \item support has been added for the creation of in-house databases of
    standards; these in-house databases can then be used for
    annotation purposes;
  \item comparison with databases of standard spectra is made on the
    bases of the pseudospectra, using a tried and tested similarity
    function that is fast enough to also search databases of hundreds
    of thousands of compounds.
\end{itemize}
One of the goals of setting up \pkg{metaMS} was to set up a simple
system with few user-settable parameters, capable of handling the vast
majority of untargeted metabolomics experiments. Users not proficient
in \R\ can be accomodated by setting up web interfaces, e.g. using
RWui~\cite{Newton2007} -- in our institute, the only pieces of
information the users have to provide in such a web interface are the
location of the data, and the protocol used (e.g. GC
triple-quad). This will automatically link the appropriate database
for annotation and use the optimized settings. Results are returned
both in the form of spreadsheets and R objects.

\section{Example data}
Because experimental data are quite big in general, this part has been
split off in a separate package called \pkg{metaMSdata}; since the
data are unlikely to see many updates, the user of \pkg{metaMS} can
download future versions without having to download the example data again.
Package \pkg{metaMSdata} provides a small number of example data
files that illustrate the functionality of \pkg{metaMS}. For the GC-MS
part, they consist of four injections of mixtures of
chemical standards~\cite{Wehrens2014}. One of these injections will be
used to create a database for three of the compounds present:
Linalool, Methyl salicylate and Ethyl hexanoate. Once the database of
standards has been created, it can be used for annotation
purposes. Intermediate results are typically orders of magnitude
smaller than the raw data files, and \pkg{metaMS} itself contains a
number of these to illustrate the concepts and to speed up the
examples in the manual pages.

\section{GC-MS data processing in \pkg{metaMS}}
In untargeted metabolomics, the application of MS/MS and related
techniques is usually restricted to follow-up experiments, where
identification of potentially interesting features is the goal. In
initial experiments most often simple LC-MS and GC-MS experiments are
done, where annotation is based on reliable data of chemical
standards, often measured in very similar conditions. Package
\pkg{metaMS} supports building these databases, using exactly the same
data processing pipeline as is used for real samples. The settings are
gathered in an object of class \code{metaMSsettings}:
<<>>=
library(metaMS)
data(FEMsettings)
TSQXLS.GC
metaSetting(TSQXLS.GC, "PeakPicking")
@ 
The settings used for this particular set of samples are fine-tuned
for a Thermo Scientific TSQXLS triple-quad GC. The \code{PeakPicking}
field in the settings contains all elements that are passed to the
\code{xcmsSet} function from \pkg{xcms}.

\subsection{Analysis of samples}
The standard workflow of \pkg{metaMS} for GC-MS data is the following:
\begin{enumerate} \compresslist
\item peak picking;
\item definition of pseudospectra;
\item identification and elimination of artefacts;
\item annotation by comparison to a database of standards;
\item definition of unknowns;
\item output.
\end{enumerate}
This has been implemeted in function \code{runGC}, which takes a
vector of file names, corresponding to the samples, and a settings
list as mandatory arguments. In addition, some extra arguments can be
provided. In particular, a database of standards, as discussed in the
previous section, can be provided for annotation purposes. The call
therefore can be as simple as:
<<echo = FALSE>>=
data(threeStdsDB)
@ 
<<eval = FALSE, echo = TRUE>>=
library(metaMSdata)
data(threeStdsDB)        ## provides DB

cdfdir <- system.file("extdata", package = "metaMSdata")
cdffiles <- list.files(cdfdir, pattern = "_GC_",
                       full.names = TRUE, ignore.case = TRUE)
result <- runGC(files = cdffiles, settings = TSQXLS.GC, DB = DB,
                nSlaves = 2)
@ 
Alternatively, if the peak picking by \pkg{xcms} is already done, one
can provide the \code{xcmsSet} object:
<<eval = FALSE, echo = TRUE>>=
result <- runGC(xset = GCset, settings = TSQXLS.GC, DB = DB)
@ 
In both cases, the result is a list containing a set of patterns
corresponding with the compounds that have been found, either
annotated or unknown, the relative intensities of these patterns in
the individual annotations, and possibly the \code{xcmsSet} object for
further inspection.
In practice, the \code{runGC} function is all that users need to
use. However, to give more details, each of the steps in the workflow
will be discussed briefly below. 

All results and intermediate results from this vignette are available
in data object \code{GCresults} -- this is used here to demonstrate
the structure of the data objects without having to create them on the
fly, which simply takes too much time:
<<>>=
data("GCresults")
@
<<eval=TRUE,echo=FALSE>>=
allSamples.msp <- GCresults$samples.msp
@ 

\subsubsection{Peak picking}
The peak picking is performed by the usual \pkg{xcms} functions. A
wrapper function, \code{peakDetection}, has been written in
\pkg{metaMS} to allow the 
individual parameters to be passed to the function as a settings
list. The result is that the whole of the \pkg{xcms} functionality is
available, simply by changing the values of some settings, or by
adding fields. In the \code{runGC} function, this step is performed by
<<eval = FALSE, echo = TRUE>>=
GCset <- peakDetection(cdffiles, 
                       settings = metaSetting(TSQXLS.GC, "PeakPicking"), 
                       convert2list = TRUE, nSlaves = 2)
@ 
Since this part can take quite some time, it is operated in parallel
wherever possible (using \pkg{Rmpi} or \pkg{snow}, and shows some
feedback to the user. The last 
argument of the function determines whether the results are to be
presented for all samples together (the format of \pkg{xcms}), or
should be split into a list with one entry for each individual
file. The latter case is useful here, in the analysis of GC data, but
also when setting up a database of standards.

\subsubsection{Definition of pseudospectra}
Rather than individual peaks, the basic data structure in the GC-MS
part of \pkg{metaMS} is a pseudospectrum, i.e. a set of \emph{m/z}
values showing a chromatographic peak at the same retention time. This
choice is motivated by several 
considerations. First of all, in GC the amount of overlap is much less
than in LC: peaks are much narrower. This means that even a one- or
two-second difference in retention time can be enough to separate the
corresponding mass spectra. Secondly, fragmentation patterns for many
compounds are 
available in extensive libraries like the NIST
library (see {\tt http://www.nist.gov/srd/nist1a.cfm}). In addition,
the spectra are somewhat 
easier to interpret since adducts, such as found in LC, are not
present. The main advantage of pseudospectra, however, is that their
use allows the results to be interpreted directly as relative
concentrations of chemical compounds: a fingerprint in terms of
chemical composition is obtained, rather than a fingerprint in terms
of hard-to-interpret features.

The pseudospectra are obtained by simply clustering on retention time,
using the \code{runCAMERA} wrapper function, which for GC data calls
\code{groupFWHM}:
<<eval = FALSE, echo = TRUE>>=
allSamples <- lapply(GCset, runCAMERA, chrom = "GC", 
                     settings = metaSetting(TSQXLS.GC, "CAMERA"))
@ 
Again, all the usual parameters for the \code{groupFWHM} function can
be included in the \code{CAMERA} slot of the settings object. The most
important parameter is \code{perfwhm}, which determines the maximal
retention time difference of features in one pseudospectrum.

The final step is to convert the CAMERA objects into easily handled
lists, which are basically the \R\ equivalent of the often-used
\code{msp} format from the AMDIS software~\cite{Stein1999}. In
\code{runGC}, this step is implemented as:
<<eval = FALSE, echo = TRUE>>=
allSamples.msp <- lapply(allSamples, to.msp, file = NULL, 
                         settings = metaSetting(TSQXLS.GC, "DBconstruction"))
@ 
<<>>=
sapply(allSamples.msp, length)
allSamples.msp[[1]][[26]]
@ 
Object \code{allsamples.msp} is a nested list, with one entry for each
sample, and each sample represented by a number of fields. In this
case, more than 300 pseudospectra are found in each sample (even
though the samples are mixtures of only fourteen chemical
standards). The pseudospectra are three-column matrices, containing
\emph{m/z}, intensity and retention time information, respectively.
One can plot the individual spectra for visual inspection using the
function \code{plotPseudoSpectrum} -- an example is shown in
Figure~\ref{fig:pspectrum}. 
\begin{figure}[tb]
  \centering
<<fig=TRUE,height=4.5,width=10>>=
plotPseudoSpectrum(allSamples.msp[[1]][[26]])
@ 
\caption{A pseudospectrum from one of the samples.}
\label{fig:pspectrum}
\end{figure}

\subsubsection{Annotation}
Once we have identified our pseudospectra, we can start the annotation
process. This is done by comparing every pseudospectrum to a database
of spectra. As a similarity measure, we use the weighted dot
product as it is fast, simple, and gives good
results~\cite{Stein1994a}. The first step in the comparison is based on
retention, since a comparison of either retention time or retention
index is much faster than a spectral comparison. The corresponding
function is \code{matchSamples2DB}. Since the weighted dot product
uses scaled mass spectra, the scaling of the database is done once,
and then used in all comparisons:
<<>>=
DB.treated <- treat.DB(DB)
allSam.matches <- 
    matchSamples2DB(allSamples.msp, DB = DB.treated, 
                    settings = metaSetting(TSQXLS.GC, "match2DB"), 
                    quick = FALSE)
allSam.matches
@ 
This returns a table where all patterns that have a match with a DB
entry are shown in the first column, and the DB entry itself in the
second column. If for a particular experimental pattern more than one
match is found, the alternatives (with a lower match factor) are shown
in the last column. In this case, all three patterns in the database
match with exactly one pattern in each of the experimental samples.

To see the match for a particular pattern, one can
use the function \code{matchExpSpec}, returning match factors (numbers
between 0 and 1, where the latter means a perfect match) for all
entries in the database. If the \code{plotIt} argument is \code{TRUE},
the best match is shown -- see Figure~\ref{fig:match}.
\begin{figure}[tb]
  \centering
<<fig=TRUE,height=5.5,width=9.5>>=
matchExpSpec(allSamples.msp[[1]][[4]], DB.treated, 
             DB.treated = TRUE, plotIt = TRUE)
@ 
\caption{Best match between an experimental pattern (in red) and a
  database entry (in blue).}
\label{fig:match}
\end{figure}

Samples may contain compounds that are not of any interest, such as
plasticizers, internal standards, column material etcetera. These can
be filtered out before doing an annotation: \pkg{metaMS} allows
certain categories of database entries (defined in slot
\code{matchIrrelevants} of the settings object) to be removed before
further annotation. If the spectra of these compounds are very
specific (and they often are), the retention criterion may be bypassed
by setting the maximal retention time difference to very high values,
which leads to the removal of such spectra wherever they occur in the
chromatogram.

\subsubsection{Unknowns}
The most important aspect of untargeted metabolomics is the definition
of unknowns, patterns that occur repeatedly in several samples, but
for which no annotation has been found. In \pkg{metaMS} these unknowns
are found by comparing all patterns within a certain retention time
(or retention index) difference on their spectral characteristics. The
same match function is used, but the threshold may be different from
the threshold used to match with the database of standards. Likewise,
the maximum retention time (index) difference may be different,
too. In defining unknowns we have so far used settings that are more
strict than when comparing to a database: since all samples are
typically measured in one single run, expected retention time
differences are rather small. In addition, one would expect
reproducible spectra for a single compound. A true unknown, or at
least an interesting one, is also present in a significant fraction of
the samples. All these parameters are gathered in the
\code{betweenSamples} element of the settings object. 

Since the
matching is done using scaled patterns, we need to created a scaled
version of the experimental pseudospectra first:
<<>>=
allSamples.msp.scaled <- lapply(allSamples.msp, treat.DB, 
                                isMSP = FALSE)
allSam.matches <- 
    matchSamples2Samples(allSamples.msp.scaled, 
                         allSamples.msp, 
                         annotations = allSam.matches$annotations, 
                         settings = metaSetting(TSQXLS.GC, "betweenSamples"))
names(allSam.matches)
@
For large numbers of samples, this process can take quite some time
(it scales quadratically), especially if the allowed difference in
retention time is large.
The result now is a list of two elements: the first is the annotation
table that we also saw after the comparison with the database, and the
second is a list of pseudospectra corresponding to unknowns. In the
annotation table, negative indices correspond to the pseudospectra in
this list.
<<>>=
allSam.matches$annotations[[1]]
@ 
In the example above we see that pattern 10 in the first sample
corresponds to the first unknown.

\subsubsection{Output}
At this stage, all elements are complete: we have the list of
pseudospectra with an annotation, either as a chemical standard from
the database, or an unknown occurring in a sizeable fraction of the
injections. The only things left to do is to calculate relative
intensities for the pseudospectra, and to put the results in an
easy-to-use table. This table consists of two parts. The first part is
the information on the ``features'', which here are the pseudospectra:
<<>>=
features.df <- getFeatureInfo(stdDB = DB, allMatches = allSam.matches, 
                              sampleList = allSamples.msp)
features.df[, c(1:3, ncol(features.df) - 2:0)]
@ 
The first three lines are the standards, and the next two are the two
unknowns that are identified by the pipeline. The second part of the
table contains the intensities of these features in the individual
injections.

In manual interpretation of this kind of data, the intensities
of one or two ``highly specific'' features are often used to achieve
relative quantitation. In an automatic pipeline, this is a risky
strategy: not only can the intensity of a peak vary quite dramatically
(relative standard deviations of up to 30\% are assumed acceptable in
GC-MS, e.g. when SPME is applied), but these errors are all the more
pronounced in high-intensity peaks (hence the common use of a relative
standard deviation). In addition, one is ignoring the information in
the other peaks of the pseudospectrum. In \pkg{metaMS}, pseudospectrum
intensity is expressed as a multiple of the corresponding reference
pattern (either a database pattern or an unknown), where the intensity
ratio is determined using robust regression to avoid one deviating
feature to influence the results too much~\cite{Wehrens2014}.
First, we define an object containing all relevant pseudospectra, and
next the intensities are generated:
<<>>=
PseudoSpectra <- constructExpPseudoSpectra(allMatches = allSam.matches, 
                                           standardsDB = DB)
ann.df <- getAnnotationMat(exp.msp = allSamples.msp, pspectra = PseudoSpectra, 
                           allMatches = allSam.matches)
ann.df
@ 
Since relative intensities are hard to interpret for mass
spectrometrists, these are converted into numbers corresponding to
peak heights or peak areas. This is done by multiplication by the
highest intensity in the reference spectrum:
<<>>=
ann.df2 <- sweep(ann.df, 1, sapply(PseudoSpectra, 
                                   function(x) max(x$pspectrum[, 2])), 
                 FUN = "*")
ann.df2
@ 
The three standards (the first three lines) have been identified in
all four samples; the two unknowns in three and two cases, respectively.
The final result is obtained by simply concatenating the two tables
column-wise.

\subsection{Building a database of standards}
From the previous discussion it should be clear how important an
in-house database of standards, measured on the same system as the
samples, really is. The point is that the retention behaviour of
chemical compounds can differ substantially across systems -- an
in-house database is the best way to avoid many false negative and
false positive hits.

Fortunately, the pipeline as discussed so far can be used easily to
also process injections of standards. These may be injected as
mixtures, provided that their retention 
times are not completely overlapping. Additional information is
obtained from a user-provided \code{csv} file containing information like
CAS number, retention time, and molecular weight. Such a file is
processed with the function \code{readStdInfo}. For the three chemical
standards in the \pkg{metaMSdata} package, this leads to the following
information:
<<>>=
library(metaMSdata)
stddir <- system.file("extdata", package = "metaMSdata")
input.file <- list.files(stddir, pattern = "csv", full.names = TRUE)
threeStdsInfo <- readStdInfo(input.file, stddir, sep = ";", dec = ",")
threeStdsInfo[,"stdFile"] <- file.path(stddir, "STDmix_GC_03.CDF")
threeStdsInfo[,c(1:4, 8)]
@ 
The system gives a warning that some \code{CDF} files in the data
directory are not used, which can be useful feedback -- in this case,
it is so by design. The result is a \code{data.frame} object containing
all information about the chemical standards: where to look for them,
but also it provides identifiers such as a CAS number that can be used
to compare the data to other databases. This is an essential step,
since many patterns will be identified in the raw data, even when the
samples consist of clean mixtures of chemical standards: for automatic
DB construction, a validation step of some kind has to be part of the
pipeline. The main benefit of setting up one's own database is the exact
retention time information, something that will be essential in the
annotation phase lateron. Continuing the example for the three
standards, the in-house database can simply be created by issuing
<<eval = FALSE, echo = TRUE>>=
data(threeStdsNIST)                       ## provides smallDB
DB <- createSTDdbGC(threeStdsInfo, TSQXLS.GC, extDB = smallDB,
                    nSlaves = 2)
@ 
The system returns some feedback about the process, which for large
numbers of files can take some time. If parallel processing is
supported (\code{Rmpi} or \code{snow}), this is shown, too.
If no validation by comparing to an external database of spectra is
possible, \pkg{metaMS} allows to add manually validated spectra to the
data base using the \code{manualDB} argument to the
\code{createSTDdbGC} function.
<<>>=
names(DB[[1]])
@ 
The database contains all information from the input file, as well as
information on the match with the external database, and
the validated spectrum. 

\section{Alternative annotation strategies}
Instead of the strategy outlined above, one could also use the
building blocks provided by \pkg{metaMS} in different ways.
Instead of first comparing all pseudospectra in the injections with
the database patterns, one could also first identify all
unknowns. Then the pseudospectra corresponding to the unknowns could
be compared with the database to see if any of them matches known
standards. This strategy would get rid of ``single hits'',
i.e. chemical compounds that are identified in only one or very few
injections, and would make full use of the fact that all injections
have been done in a single run, so would lead to very similar
retention time behaviour and very similar spectra. One could
hypothesize that over the course of several months or even years, a
database of spectra of standards could show bigger and bigger
deviations with actual measurements, and this alternative strategy
could possibly lead to more easily interpretable, or at least
easier-to-correct results.

There are also downsides to this strategy, as can be imagined: first
of all, it is slower, especially with large numbers of samples. Since
the comparison with a database scales linearly with the number of
injections, and the defintion of unknowns quadratically, this can be
quite a big issue. In addition, the definition of what is an unknown
not only depends on spectral and chromatographic similarities, but
also on the fraction of injections in which this pattern is found: an
additional parameter that can make quite a big difference in the
outcome. Finally, it is easy to remove annotations from the
``standard'' strategy that occur in only very few samples: one can
even assess whether alternative annotations are present that are more
in line with what is found in the other samples.

Whichever strategy is most useful depends on the data and the
scientific questions at hand. Given the building blocks provided by
\pkg{xcms} and \pkg{CAMERA}, and on a more abstract level by
\pkg{metaMS}, it is now quite easy to implement different strategies
for different purposes.

\clearpage

\bibliographystyle{unsrt}
\bibliography{GC} 

\end{document}

\name{readStdInfo}
\alias{readStdInfo}
\title{Read information of GC injections of standards from a csv file}
\description{
  The csv contains all information necessary to process a series of
  injections of standards (GC-MS). Required fields: \code{Name}, \code{RTman},
  \code{monoMW}, \code{stdFile}, and an identifier such as \code{CAS} or
  \code{ChemspiderID}. At the moment, the system is completely based on
  \code{CAS}, although this may change in the future.}
\usage{
readStdInfo(stdInfo, InputDir, sep = "", dec = ".", ...)
}
\arguments{
  \item{stdInfo}{Input file in csv format, containing information on
    standards.}
  \item{InputDir}{Location of input files.}
  \item{sep, dec, \dots}{optional arguments to \code{read.table}.}
}
\details{In addition to reading all information on the chemical
  standards (whcih will eventually be transferred into an in-house
  database), the function checks whether some input files are
  unavailable, and whether some data files are not used. In the first
  case, an error is returned, in the second case a warning.}
\value{
    A data.frame  
}
\examples{
if (require(metaMSdata)) {
  ## this will lead to the completed version of the R object that is also
  ## available by typing "data(threeStdsInfo)", now containing the
  ## directory information that is not available in the RData object.

  input.file <- list.files(system.file("extdata", package = "metaMSdata"),
                           pattern = "csv", full.names = TRUE)
  threeStdsInfo <- readStdInfo(input.file,
                               system.file("extdata", package = "metaMSdata"),
                               sep = ";", dec = ",")
  ## only one of the files is used to set up the database, the others
  ## are for testing annotation
}
}
\author{Ron Wehrens}
\keyword{manip}

\name{match2ExtDB}
\alias{match2ExtDB}
\title{Match GC-MS spectra to an external reference DB}
\description{
  When building an in-house database, it is imperative that
  pseudospectra are validated. This function provides the possibility of
  automatic validation by comparing the spectra to an external reference
  database, such as the NIST. Not meant to be called directly by the user.
}
\usage{
match2ExtDB(xsetList, extDB, settings)
}
\arguments{
  \item{xsetList}{A list of xcmsSet objects.}
  \item{extDB}{External database in msp format.}
  \item{settings}{Settings for the comparison, including as the most
    important the minimal number of features required in a valid
    pseudospectrum (\code{minfeat}), and the minimal agreement to speak
    of a match (\code{DBthreshold}).
  }
}
\value{An msp object containing validated pseudospectra.}
\author{Ron Wehrens}
\keyword{manip}

\name{printString}
\alias{printString}
\alias{printWarning}
\alias{printInfo}
\title{Functions for metaMS-formatted text output}
\description{
  Functions to present progress output, warnings or information, in a
  consistent way in the console window. Not meant to be called by the user.
}
\usage{
printString(..., screenwidth = 72)
printWarning(...)
printInfo(...)
}
\arguments{
  \item{\dots}{Text strings. These will be concatenated inside the function.}
  \item{screenwidth}{Width of the text field.}
}
\value{
    A string to print.
}
\author{Ron Wehrens and Pietro Franceschi}
\keyword{print}

\name{matchExpSpec}
\alias{matchExpSpec}
\title{Match a GC-MS pseudospectrum to a database with a weighted
  crossproduct criterion.}
\description{
  Function \code{matchExpSpec} calculates match factors for a
  pseudospectrum with all entries in the database. A plot of the best
  match can be provided.}
\usage{
matchExpSpec(pspec, DB, DB.treated, plotIt = FALSE,
             scale.p = c("sqrt", "none"), mass.weight = TRUE, ...)
}
\arguments{
  \item{pspec}{The pseudospectrum, a two- or three-column matrix where
    the third column (the retention time) will be ignored.}
  \item{DB}{Database of standards.}
  \item{DB.treated}{Logical, indicating whether the database has already
    been scaled (TRUE) or not.}
  \item{plotIt}{Logical: show best match?}
  \item{scale.p}{indicates whether \code{"sqrt"} scaling or no scaling
    (\code{"none"}) is to be applied. This should usually be \code{"sqrt"}.}
  \item{mass.weight}{Logical, indicating whether heavier masses receive
    higher weight. Should usually be TRUE.}
  \item{\dots}{Further arguments for the pseudospectrum plot (if
    shown).}
}
\value{A vector of match factors.}
\author{Ron Wehrens}
\examples{
data(threeStdsNIST) ## gives smallDB, containing 78 patterns
data(threeStdsDB)   ## gives DB, containing 3 patterns :-D

matchExpSpec(DB[[1]]$pspectrum, smallDB, DB.treated = FALSE, plotIt = TRUE)
}
\keyword{manip}

\name{LCDBtest}
\alias{LCDBtest}
\docType{data}
\title{Sample DB for LC-MS annotation}
\description{
  This database has been generated using the \code{exptable} dataset to
  process the data included in the \code{metaMSdata} package.}
\usage{data(LCDBtest)}
\format{
  \describe{
    \code{LCDBtest} is a list with three elements: \cr
    \item{Reftable}{The initial table used to generate the DB.}
    \item{Info}{Some info on the DB: date of creation, and settings used.}
    \item{DB}{A \code{data.frame} containing the actual information. See the
      details section.} 
  }
}
\details{
  The \code{DB} \code{data.frame} contains the following fields:
  \describe{
    \item{ChemSpiderID}{The Chem spider identifier for the compound.}
    \item{compound}{A human-readable name for the compound.}
    \item{adduct}{The output of the CAMERA annotation of the standard file.}
    \item{isotopes}{The output of the CAMERA annotation of the standard file.}
    \item{mz, rt}{the mz and rt values.}
    \item{maxo}{the \code{maxo} intensity value for a given feature in
      the injection.} 
    \item{validated}{a string which defines the origin of a specific feature.}
}
}
\seealso{\code{\link{createSTDdbLC}}, \code{\link{exptable}},
  \code{\link{FEMsettings}}}
\author{Pietro Franceschi}
\keyword{datasets}

\name{createSTDdbGC}
\alias{createSTDdbGC}
\alias{generateStdDBGC}
\title{Create an in-house database for GC-MS annotation}
\description{
  For creating an in-house instrument-specific annotation database,
  injections of pure standards need to be processed. All patterns in the
  vicinity of the retention time of the standard (to be provided by the
  user) will be compared to an external database - in case of a sufficient
  match, they will be retained in the database. The
  \code{generateStdDBGC} is not meant to be called directly by the user.}
\usage{
createSTDdbGC(stdInfo, settings, extDB = NULL, manualDB = NULL,
              RIstandards = NULL, nSlaves = 0)
generateStdDBGC(totalXset, settings, extDB = NULL, manualDB = NULL,
                RIstandards = NULL)
}
\arguments{
  \item{stdInfo}{Information of the standards, given in the form of a
    \code{data.frame}. Minimal information: \code{stdFile}, \code{Name},
    \code{CAS}, monoisotopic mass (\code{monoMW}), and retention time
    (\code{rt}). The filenames in slot \code{stdFile} should include
    path information. If this argument is NULL, this function can be
    used to process a manually curated DB. Arguments \code{stdInfo} and
    \code{manualDB} cannot be both NULL.}
  \item{settings}{A list of settings, to be used in peak picking and
    pattern comparison.}
  \item{extDB}{The external database containing spectra, with which to
    compare the patterns found in the standards files.}
  \item{manualDB}{A database of manually curated spectra, that will be
    incorporated in the final DB without any further checks.}
  \item{totalXset}{A list of xset objects, as generated by
    \code{peakDetection}.}
  \item{RIstandards}{A two-column matrix containing for the standards
    defining the RI scale both retention times and retention indices. If
    not given, no RI values will be calculated and retention times will
    be used instead.}
  \item{nSlaves}{Number of cores to be used in peak picking.}
}
\details{Function \code{createSTDdbGC} creates a database object
  containing validated pseudospectra for a number of compounds. The
  injections of the standards, described in the input object
  \code{stdInfo}, are processed using function \code{processStandards};
  comparison with the external database, inclusion of manual compounds
  and final formatting are done in function
  \code{generateStdDBGC}. Several situations can be envisaged:

  A: a series of injections of standards needs to be compared with a
  standard library, such as the NIST. In this case, both \code{stdInfo}
  and \code{extDB} need to be non-null, and the result will be a
  database in which the entries have a sufficient match with the
  external DB. If \code{manualDB} is also non-null, these entries will
  be added too (without checking).

  B: for a series of injections no standard library information is
  available (\code{extDB} is NULL, and \code{stdInfo} is not), and the
  function simply returns all patterns eluting around 
  the indicated retention time. This allows for subsequent manual
  validation and pruning. If \code{manualDB} is non-null, these
  entries will be added, but since this is a somewhat unusual thing to
  do, a warning will be given.

  C: a manual database needs to be processed to be useable as a real
  database. This basically entails renaming the \code{rt} and
  \code{rt.sd} fields into \code{std.rt} and \code{std.rt.sd}, and
  a similar action for any \code{RI} field.
}
\value{The output of \code{createSTDdbGC} (and \code{generateStdDBGC},
  which is the last function called in \code{createSTDdbGC}) is
  a list, where every entry describes one compound/spectrum
  combination. For use in annotation, the following fields are
  mandatory: \code{Name}, \code{std.rt}, \code{pspectrum} and
  \code{monoMW}.
}
\author{Ron Wehrens}
\seealso{\code{\link{processStandards}}, \code{\link{generateStdDBGC}}}
\examples{
  data(threeStdsNIST)  ## provides object smallDB, excerpt from NIST DB
  \dontrun{
if (require(metaMSdata)) {
  ## Sitation A: create a DB of standards.
  ## first tell the system where to look
  data(threeStdsInfo)
  all.files <- list.files(system.file("extdata", package = "metaMSdata"),
                          pattern = "_GC_", full.names = TRUE)
  stdInfo[,"stdFile"] <- rep(all.files[3], 3)

  data(FEMsettings)    ## provides a.o. TSQXLS.GC, the GC settings file
  data(threeStdsNIST)  ## provides object smallDB, excerpt from NIST DB

  DB <- createSTDdbGC(stdInfo, TSQXLS.GC, extDB = smallDB)
  }
  ## saved in "threeStdsDB.RData" in the data directory of the metaMS
  ## package

  ## Situation B: do not check the data with an external database. Now
  ## the fields bestDBmatch and validation will be absent.
  DB <- createSTDdbGC(stdInfo, TSQXLS.GC, extDB = NULL)

  ## Situation C: create a DB directly from an msp file (manual DB)
  manual.fname <- list.files(system.file("extdata", package = "metaMSdata"),
                             pattern = "msp", full.names = TRUE)
  manual <- read.msp(manual.fname)
  DB <- createSTDdbGC(stdInfo = NULL, settings = TSQXLS.GC,
                      manualDB = manual)
}
}
\keyword{manip}

\name{metaMS-package}
\alias{metaMS-package}
\alias{metaMS}
\docType{package}
\title{Analysis pipeline for MS-based metabolomics data}
\description{
  Analysis pipeline for MS-based metabolomics data: basic peak picking
  and grouping is done using functions from packages xcms and
  CAMERA. The main output is a table of feature intensities in all
  samples, which can immediately be analysed with multivariate methdos.
  The package supports the creation of in-house databases of mass
  spectra (including retention information) of pure chemical
  compounds. Such databases can then be used for annotation purposes.
}
\details{
Index:
\preformatted{
AnnotateFeature         Feature Wise Annotation
AnnotateTable           AnnotateTable
FEMsettings             FEM Settings for 'metaMS'
LCDBtest                Sample DB for LC-MS annotation
alignmentLC             LC alignment
construct.msp           Functions to handle msp-type objects (GC-MS)
constructExpPseudoSpectra
                        Create a list of all pseudospectra found in a
                        GC-MS experiment of several samples.
createSTDdbGC           Create an in-house database for GC-MS
                        annotation
createSTDdbLC           Create an in-house database for LC-MS
                        annotation
exptable                Sample table for DB generation (LC)
generateStdDBGC         Convert an msp object into a GC database object
getAnnotationLC         get LC annotation
getAnnotationMat        Subfunction GC-MS processing
getFeatureInfo          Construct an object containing all
                        meta-information of the annotated pseudospectra
                        (GC-MS).
getPeakTable            get peak table
matchExpSpec            Match a GC-MS pseudospectrum to a database with
                        a weighted crossproduct criterion.
matchSamples2DB         Match pseudospectra from several samples to an
                        in-house DB (GC-MS)
matchSamples2Samples    Compare pseudospectra across samples (GC-MS)
peakDetection           Wrapper for XCMS peak detection, to be used for
                        both GC-MS and LC-MS data.
plotPseudoSpectrum      Plot a pseudospectrum.
processStandards        Process input files containing raw data for
                        pure standards.
readStdInfo             Read information of injections of standards
                        from a csv file.
runCAMERA               Run CAMERA
runGC                   Wrapper for processing of GC-MS data files
runLC                   Wrapper for processing of LC-MS data files
treat.DB                Scaling of pseudospectra in an msp object.
}

The most important functions for running the pipeline are \code{runGC}
and \code{runLC} - in-house databases are created by functions
\code{createSTDdbGC} and \code{createSTDdbLC}.
}
\author{Ron Wehrens [aut, cre] (author of GC-MS part), Pietro Franceschi [aut] (author of LC-MS part), Nir Shahaf [ctb], Matthias Scholz [ctb], Georg Weingart [ctb] (development of GC-MS approach), Elisabete Carvalho [ctb] (testing and feedback of GC-MS pipeline)

Maintainer: Ron Wehrens <ron.wehrens@fmach.it>
}
\keyword{ package }

\name{threeStdsDB}
\alias{threeStdsInfo}
\alias{stdInfo}
\alias{threeStdsDB}
\alias{DB}
\alias{threeStdsNIST}
\alias{smallDB}
\docType{data}
\title{Information on three chemical standards measured in GC-MS (liquid
  injection)}
\description{User information needed to build up an in-house database,
  the external database for cross-checking mass spectra, and the final
  database obtained with \code{createSTDdbGC} for three chemical standards.}
\usage{
data(threeStdsDB)
data(threeStdsInfo)
data(threeStdsNIST)
}
\details{
  Raw GC-MS data for the three standards, linalool, methyl salicylate
  and ethyl hexanoate, are available in package metaMSdata. Manual
  information required to build up an in-house database should be
  presented in the form of a data.frame, an example of which is
  \code{stdInfo}. Presenting this information to \code{createSTDdbGC}
  leads to processing of the raw data, and cross-checking with an
  external database containing mass spectra. An excerpt of the NIST
  database, containing only spectra for these three compounds, is
  available in \code{smallDB}. The final database that is then obtained
  can be inspected in object \code{DB}, which is a simple list of tags
  and values. For use as a reference database, several of these fields
  are mandatory. Currently these are \code{Name}, \code{monoMW},
  \code{pspectrum} and \code{std.rt}. 
}
\source{Georg Weingart}
\examples{
data(threeStdsNIST)
length(smallDB)

data(threeStdsInfo)
stdInfo

data(threeStdsDB)
par(mfrow = c(3,1))
sapply(DB, function(x) plotPseudoSpectrum(x$pspectrum, main = x$Name))
}
\keyword{datasets}

\name{metaMSsettings-class}
\Rdversion{1.1}
\docType{class}
\alias{metaMSsettings-class}
\alias{metaMSsettings}
%\alias{metaSetting<-,metaMSsettings}
%\alias{metaSetting,metaMSsettings}
\alias{show,metaMSsettings-method}

\title{Class \code{"metaMSsettings"}}
\description{
  This class contains all settings needed to run the metaMS pipelines
  for LC-MS (\code{runLC}) and GC-MS (\code{runGC}). Slots
  \code{PeakPicking}, \code{Alignment} and \code{CAMERA} are simply
  handed over to the appropriate \pkg{xcms} and \pkg{CAMERA} functions;
  all other slots contain settings for \pkg{metaMS} functions.
}
\section{Objects from the Class}{
  Objects can be created by calls of the form
  \code{metaMSsettings(...)}. See the example below.
}
\section{Slots}{
  Note: all slots describing retention times or retention time differences use
  minutes and not seconds. If a slot is only relevant for either GCMS or
  LCMS, this is indicated explicitly.
  \describe{
    \item{\code{protocolName}:}{Object of class \code{"character"}: the name
    of the instrumental protocol, a unique identifier.}
    \item{\code{chrom}:}{Object of class \code{"character"}:
      chromatography. Either "LC" or "GC".}
    \item{\code{PeakPicking}:}{Object of class \code{"list"}: The
      parameters used for \pkg{xcms} peakpicking. See the arguments of
      \code{\link{findPeaks}}.}
    \item{\code{Alignment}:}{Object of class \code{"list"}: The
      parameters used for grouping and
      alignment. \code{min.class.fraction} and \code{min.class.size} are
      used to calculate the \code{minsample} xcms parameter. \code{bws}
      is a vector of the two bandwidths used for grouping before and
      after retention time alignent. \code{missingratio} and
      \code{extraratio} are used to set the values for \code{missing}
      and \code{extra} as a function of the number of samples. LC only.}
    \item{\code{CAMERA}:}{Object of class \code{"list"}: The parameters
      for CAMERA.} 
    \item{\code{match2DB.rtdiff}:}{Object of class \code{"numeric"}: the
      maximal difference in retention time to match each feature with the entry
      in the DB.} 
    \item{\code{match2DB.minfeat}:}{Object of class \code{"numeric"}:
      for LC, the minimal number of matching features within a retention time
      interval of width \code{rtval} before we speak of a hit. For GC,
      the minimal number of common masses for calculating a match factor.}
    \item{\code{match2DB.rtval}:}{Object of class \code{"numeric"}: the
      tolerance in retention time for features used in annotation. LC only.}
    \item{\code{match2DB.mzdiff}:}{Object of class \code{"numeric"}:
      the mass accuracy which is used if no error surface is
      provided. LC only.} 
    \item{\code{match2DB.ppm}:}{Object of class \code{"numeric"}: the
      minimum mass tolerance allowed when the error surface is used. LC
      only.}
    \item{\code{match2DB.simthresh}:}{Object of class \code{"numeric"}:
      the minimal match factor to speak of a hit. GC only.}
    \item{\code{match2DB.timeComparison}:}{Object of class
      \code{"character"}: either "rt" or "RI". GC only.}
    \item{\code{match2DB.RIdiff}:}{Object of class \code{"numeric"}:
      maximal retention index difference with DB entry (GC only). }
    \item{\code{DBconstruction.minfeat}:}{Object of class
      \code{"numeric"}: the minimum number of
      features necessary to include a compound in the DB.
    }
    \item{\code{DBconstruction.rttol}:}{Object of class
      \code{"numeric"}: the tolerance in retention
      time to match experimental features with the reference table.}
    \item{\code{DBconstruction.mztol}:}{Object of class
      \code{"numeric"}: the tolerance in m/z (in dalton) to match
      experimental features with the reference table. LC only.}
    \item{\code{DBconstruction.minintens}:}{Object of class
      \code{"numeric"}: the minimum intensity for a feature to
      be included in the list. GC only.}
    \item{\code{DBconstruction.intensityMeasure}:}{Object of class
      \code{"character"}: either \code{"into"} or \code{"maxo"}. GC only.}
    \item{\code{DBconstruction.DBthreshold}:}{Object of class
      \code{"numeric"}: minimal match factor with an external
      DB for a pseudospectrum to be included in the DB of standards. GC
      only.}
    \item{\code{matchIrrelevants.irrelevantClasses}:}{Object of class
      \code{"character"}: classes of compounds are
      considered as irrelevant (a vector of string constants, which
      should exactly match the \code{Class} element in the DB entries). GC
      only.}
    \item{\code{matchIrrelevants.simthresh}:}{Object of class
      \code{"numeric"}: the minimal match factor to speak of a
      hit. GC only.}
    \item{\code{matchIrrelevants.timeComparison}:}{Object of class
      \code{"character"}: either "rt" or "RI". GC only.}
    \item{\code{matchIrrelevants.rtdiff}:}{Object of class
      \code{"numeric"}: maximal retention time difference between two
      unknowns - this can be set to a very high value if a 
      pattern is to be removed whatever the retention time. GC only.}
    \item{\code{matchIrrelevants.RIdiff}:}{Object of class \code{"numeric"}:
      maximal retention index difference between two unknowns - this can
      be set to a very high value if a pattern is to be removed whatever
      the Retention Index. GC only.}
    \item{\code{betweenSamples.min.class.fraction}:}{Object of class
      \code{"numeric"}: fraction of samples in which a pseudospectrum is
      present before it is regarded as an unknown. GC only.}
    \item{\code{betweenSamples.min.class.size}:}{Object of class
      \code{"numeric"}: absolute number of samples in which a pseudospectrum is
      present before it is regarded as an unknown. GC only.}
    \item{\code{betweenSamples.timeComparison}:}{Object of class
      \code{"character"}: either "rt" or "RI". GC only.}
    \item{\code{betweenSamples.rtdiff}:}{Object of class
      \code{"numeric"}: max retention time difference between
      pseudospectra in different samples. GC only.}
    \item{\code{betweenSamples.RIdiff}:}{Object of class
      \code{"numeric"}: max retention index difference between
      pseudospectra in different samples. GC only.}
    \item{\code{betweenSamples.simthresh}:}{Object of class
      \code{"numeric"}: similarity threshold fo comparing pseudospectra
      in different samples. GC only.}
  }
}
\section{Methods}{
  \describe{
    \item{metaSetting<-}{\code{signature(object = "metaMSsettings")}:
      change values in a metaMSsettings object.}
    \item{metaSetting}{\code{signature(object = "metaMSsettings")}: get
      values from a metaMSsettings object. }
    \item{show}{\code{signature(object = "metaMSsettings")}: show a
      metaMSsettings object.}
  }
}
\author{Ron Wehrens}
\seealso{\code{\link{FEMsettings}}}
\examples{
showClass("metaMSsettings")

\dontrun{
## The three sets of settings are created as follows:
Synapt.NP <- metaMSsettings(protocolName = "Synapt.QTOF.NP",
                            chrom = "LC",
                            PeakPicking = list(
                              method = "matchedFilter",
                              step = 0.05,
                              fwhm = 20,
                              snthresh = 4,
                              max = 50),
                            Alignment = list(
                              min.class.fraction = .3,
                              min.class.size = 3,
                              mzwid = 0.1,
                              bws = c(130, 10),
                              missingratio = 0.2,
                              extraratio = 0.1,
                              retcormethod = "linear",
                              retcorfamily = "symmetric",            
                              fillPeaks = TRUE),
                            CAMERA = list(
                              perfwhm = 0.6,
                              cor_eic_th = 0.7,
                              ppm= 5))
metaSetting(Synapt.NP, "match2DB") <- list(
            rtdiff = 1.5,
            rtval = .1,
            mzdiff = 0.005,
            ppm = 5,
            minfeat = 2)
metaSetting(Synapt.NP, "DBconstruction") <- list(
            minfeat = 3,
            rttol = .3,
            mztol = .01)
}
}
\keyword{classes}

\name{matchSamples2Samples}
\alias{matchSamples2Samples}
\alias{match.unannot.patterns}
\title{Compare pseudospectra across samples (GC-MS)}
\description{
  Function \code{matchSamples2Samples} matches pseudospectra across all
  samples - if a pseudospectrum is present at more or less the same
  retention time in several samples, it can get the status of
  \dQuote{unknown}. Exactly how much difference there may be between the
  pseudospectra and retention times, and how often it should be present,
  is determined by the settings. The auxiliary function
  \code{match.unannot.patterns} compares two msp objects, representing
  experimental samples. Both are not meant to be called directly by the
  user.}
\usage{
matchSamples2Samples(xset.msp.scaled, xset.msp, annotations, settings)
match.unannot.patterns(msp1, msp2, settings)
}
\arguments{
  \item{xset.msp.scaled}{Scaled version of all pseudospectra in the
    experimental patterns - a nested list, with one entry for each
    sample, and within every entry an element for each pseudospectrum.}
  \item{xset.msp}{Unscaled version of the first argument: both arguments
    are provided for efficiency reasons.}
  \item{annotations}{Annotations of all pseudospectra: only patterns
    without annotations will be considered.}
  \item{settings}{Settings determining what a valid \dQuote{unknown} is. For an
    example, see the man page of \code{FEMsettings},
    field \code{matchIrrelevants}.}
  \item{msp1, msp2}{lists of pseudospectra}
}
\value{Function \code{matchSamples2Samples} returns an updated
  annotation object such as the one 
  returned by \code{matchSamples2DB}, but now with an additional
  \code{unknowns} element, containing the pseudospectra that are
  recognized as \dQuote{unknowns}.

  Function \code{match.unannot.patterns} returns a list of combinations
  of pseudospectra IDs, retention times (or retention indices) and match
  factors (only for those combinations that satisfy the criteria on
  retention time (index) and match factor).}
\author{Ron Wehrens}
\examples{
## Example of settings
  data(FEMsettings)
  metaSetting(object = TSQXLS.GC, field= "betweenSamples")
}
\keyword{manip}

\name{removeDoubleMasses}
\alias{removeDoubleMasses}
\title{Remove double m/z entries in a pseudospectrum}
\description{
  Since in nominal-mass GC data m/z values are rounded to whole numbers, in
  some cases an m/z value may occur multiple times - in that case the
  mean of the intensities is kept (and the retention times are averaged). 
  removeDoubleMasses takes a list of spectra in the form of a
  three-column matrix, (mz, I, rt), summing the intensities and
  averaging the retention times for multiple identical masses. Not meant
  to be called directly by the user.
}
\usage{removeDoubleMasses(spclist)}
\arguments{
  \item{spclist}{A list of spectra, each one consisting of a
    three-column matrix (mz, I, rt).}
}
\value{The function returns a list of spectra, where all "double" peaks
  have been averaged.}
\author{Ron Wehrens}
\keyword{manip}

\name{runLC}
\alias{runLC}
\title{Wrapper for processing of LC-MS data files}
\description{
  Main function of the pipeline for LC-MS data processing. It includes
  XCMS peak detection, grouping and alignment, CAMERA and feature
  annotation by comparison to a database of standards. The function also
  calculates the mass tolerance on the bases of the ion intensity and ion
  mass.
}
\usage{
runLC(files, xset, settings, rtrange = NULL, mzrange = NULL, DB = NULL,
      polarity = "positive", errf = NULL, returnXset = FALSE,
      intensity = "into", nSlaves = 0)
}

\arguments{
  \item{files}{input files, given as a vector of strings containing the
    complete paths. All formats supported by XCMS can be used.}
  \item{xset}{alternatively, one can present an object of class
    \code{xsAnnotate}, instead of the input files. In that case all of the
    XCMS and CAMERA tools: peak picking, CAMERA grouping, retention time
    correction and filling of missing peaks will be considered already
    done, and only annotation will be performed. This can be useful if one
    wants to compare different settings for annotation. If both
    \code{files} and \code{xset} are given, the former takes precedence.}
  \item{settings}{nested list of settings, to be used at individual
    steps of the pipeline. See the help of \code{FEMsettings} for details.}
  \item{rtrange}{An optional vector to slice the retention time range
    (in minutes).}
  \item{mzrange}{An optional vector to slice the mass spectrum}
  \item{DB}{database containing the spectra of the pure standards. For
    the description refer to the \code{LCDBtest} help.}
  \item{polarity}{The polarity of the analysis used for CAMERA
    annotation. Either "positive" or "negative".}
  \item{errf}{A model used to calculate the mass tolerance in ppm
    for each features on the bases of its mass, retention time and intensity.
    For further details refer to the help of \code{AnnotateTable}.}
  \item{returnXset}{logical: should the XCMS output be returned? If yes,
    this is a a list of \code{xcmsSet} objects, one element for each
    input file.}
  \item{intensity}{The intensity measure used in the output
    peaktable. The available intensities are the ones provided by
    \code{xcms}. The default one is the total intensity (integral) of the
    feature on the detected chromatographic peak.}
  \item{nSlaves}{Number of cores to be used in peak picking.}
}
\details{The \code{mzrange} and \code{rtrange} parameters are used to
  subset the mass and retention times considered in the analysis,
  reducing possible alignment problems at the extremes. \cr
  The error function calculates the expected m/z tolerance for feature
  annotation based on the mz and I values of each feature. To have a
  more complete description of the process refer to the help of
  \code{AnnotateTable} and the literature reference. An example is
  provided as well. Note that the use of "lm" is only one of the
  possible choices, but all kind of functional approximations working
  with the \code{predict} function could be used. If the error function
  is not provided the mass tolerance will be fixed to the value defined
  in the \code{settings} list.}
\value{
  A list with three elements:
  \item{PeakTable}{data.frame containing annotation information. Every
    line is a feature. The first columns are used to give information
    about these features, annotation, CAMERA, Chemspider IDs,
    etcetera. The last of these meta-information columns is always the one
    giving the retention time: "rt". After that, columns correspond to
    input files, and give measures of intensities for every single one of
    the features.}
  \item{Annoation}{The complete output of the \code{AnnotateTable} function.}
  \item{Settings}{The settings used in the pipeline.}
  \item{xset}{optionally, the xcmsSet/CAMERA object is returned, which can be
    useful for more detailed inspection of the results.}
  \item{sessionInfo}{The output of \code{sessionInfo()} to keep track of the sw
  version used for the processing}
}
\references{
  N. Shahaf, P. Franceschi, P. Arapitsas, I. Rogachev, U. Vrhovsek and
  R. Wehrens: "Constructing a mass measurement error surface to improve
  automatic annotations in liquid chromatography/mass spectrometry based
  metabolomics". Rapid Communications in Mass Spectrometry, 27(21), 2425
  (2013). 
}
\author{Pietro Franceschi}
\examples{
data(LCresults)
names(LCresults)

\dontrun{
## load the settings for the analysis
data(FEMsettings)
  
## load the annotation DB
data(LCDBtest)

## load the Synapt Q-TOF error function
data(errf)

results.xset  <- runLC(xset = LCresults$xset, settings = Synapt.RP, 
                       DB = LCDBtest$DB)

## to start directly from the CDF files and include peak picking in the
## pipeline, simply provide the "files" argument rather than the "xset" argument

if (require(metaMSdata)) {
  ## get the path 
  cdfpath <- system.file("extdata", package = "metaMSdata")
  
  ## files 
  files <- list.files(cdfpath, "_RP_", full.names=TRUE)
    
  ## <-------------    Use the Synapt Q-TOF error function     -------------- >
  result.adaptive <- runLC(files, settings = Synapt.RP, 
                           DB = LCDBtest$DB, errf = errf)
  
  ## <--------    Run the analysis with a fixed mass tolerance      --------- >
  result.fixed <- runLC(files, settings = Synapt.RP, 
                        DB = LCDBtest$DB)
}            
}
}
\keyword{manip}

\name{errf}
\alias{errf}
\docType{data}
\title{Mass error surface for Waters Synapt Q-TOF spectrometers}
\description{This function can be used to calculate the optimal mz
  tolerance (in ppm) for annotation. The surface has been developed for
  a Waters Synapt QTOF spectrometer.} 
\usage{data(errf)}
\format{
  \code{errf} is a linear model of the form \code{M + logI + M * logI}:
  \describe{
    \item{M}{The mz of the ion} 
    \item{logI}{Logarithm of the intensity of the ion.} 
  }
}
\details{
  The function is a linear approaximation of the complete error function
  (see Reference). The latter has been calculated by comparing the
  measured and nominal mass of several hundreds of standards. The
  experiments were performed by using a Waters Synapt Q-TOF spectrometer
  so this specific surface is valid only for this model of spectrometers. 
}


\references{
N. Shahaf, P. Franceschi, P. Arapitsas, I. Rogachev, U. Vrhovsek and
R. Wehrens: "Constructing a mass measurement error surface to improve
automatic annotations in liquid chromatography/mass spectrometry based
metabolomics". Rapid Communications in Mass Spectrometry, 27(21), 2425
(2013).}

\author{Pietro Franceschi}
\examples{
## <--------------    direct use of the error function     -------------- >
## load the Synapt-QTOF error function
data(errf)

## predict the mass error in ppm
newdata <- data.frame(M = c(105, 131, 157), logI = c(1, .5, 1.4))
predict(errf, newdata) ## mass error in ppm


## <--------------    create a dummy error function     -------------- >
## dataset to evaluate it: 
## "M" is the mz, 
## "logI" is the log of the intensity
## "err" is the mass error in ppm. The error is the difference between the 
## actual m/z of a known ion, and the one measured with the spectrometer
  
MErr.data <- data.frame("M" = seq(1,500,2), 
                        "logI" = rnorm(250, mean = 5, sd = 1), 
                        "err" = rnorm(250, mean = 40, sd = 5))
  
## create the linear model
dummy.model <- lm(err~M+logI, data = MErr.data)

\dontrun{
## <--------------    Use this for the annotation     -------------- >
## load the example xcmsSet
data(LCresults)
data(FEMsettings)

## Run the analysis with an adaptive mass tolerance 
result.adaptive.dummy <- runLC(xset = LCresults$xset,
                               settings = Synapt.RP, 
                               DB = LCDBtest$DB,
                               errf = dummy.model)

## <-----------    Use the Synapt Q-TOF error function     ----------- >
## load the Synapt-QTOF error function
data(errf)

result.adaptive  <- runLC(xset = LCresults$xset,
                          settings = Synapt.RP, 
                          DB = LCDBtest$DB,
                          errf = errf)
}
}
\keyword{datasets}

\name{AnnotateTable}
\alias{AnnotateTable}
\alias{AnnotateFeature}
\title{Annotate a Peaktable}
\description{Functions which annotate a peaktable on the bases af a
  database of standards. Not meant to be called directly by the user.}
\usage{

## Annotate one feature
AnnotateFeature(input, DB, settings, errf)

## Annotate a full table of features
AnnotateTable(peaktable, errf, DB, settings)
}
\arguments{
  \item{input}{A vector with three elements in the form \code{(mz,rt,I)}.}
  \item{peaktable}{A peaktable (matrix) with three column corresponding
    to mz,rt and I values for a series of features.}
  \item{errf}{The file containing the error function used to predict the
    tolerance on the \code{m/z} value used for the matching against the
    DB.}
  \item{DB}{A dataframe used for the annotation. See the help of
    \code{LCDBtest} for a description of the DB.}
  \item{settings}{The subset of settings contained into the "match2DB"
    element of the XCMSsettings list.}
}

\details{The annotation of each feature is performed by comparing its
  m/z value and its retention time to a database provided by the
  user. To account for shifts in retention time and mass occurring
  during data acquisition, the matching of a specific feature against
  the DB is done with a specific tolerance in mass and in retention
  time.
  
  \emph{Retention time tolerance} \cr 
  The retention time tolerance is specified (in minutes) in the settings list
  (field \code{rttol}). This value is instrument- and
  chromatography-dependent. 
  
   \emph{m/z tolerance} \cr 
  The tolerance on the mass scale mainly depends on the characteristics
  of the spectrometer used for the acquisition. For Q-TOF instruments it
  has been recently shown (see references) that the optimal mass
  tolerance can be expressed as a function of the \code{m/z} value and
  of the logarithm of the ion intensity \code{log10(I)}. As a trend, the
  mass drift will be bigger for smaller ions and for low intensity
  signals. \cr 
  In the present implementation the tolerance in mass can be either
  fixed over the complete mass range or calculated as a function of the
  mz and I values of each feature. In the simplest case, the fixed mass
  tolerance is provided in the \code{mzwindow} (in Dalton!) element of
  the list of settings.\cr 
  Alternatively, one can provide (supplying the \code{errf} argument) a
  function used to calculate the mz tolerance (in ppm!) as a function of
  the fields of the input vector (\code{(mz,rt,I))}. \cr 
  As discussed in the publication, for a Waters Synapt Q-TOF the
  function is a linear model taking as inputs \code{M = input["mz"],
  logI = log10(input["I"])}. This error function can be calculated by
  analyzing the results of the injections of the chemical standards. To
  avoid unreasonable small errors where data for mz and I are not
  available, the minimum value for the mass tolerance is explicitly set
  in the settings (\code{ppm}). This value should match the technical
  characteristics of the spectrometer.  
  
  To reduce the number of false positives and make the annotation more
  reliable, a match is retained only if more than one feature
  associated to a specific compound is found in the list of
  features. How many "validation" features are required is defined in the
  list of settings in the \code{minfeat} element. At this validation
  level, another retention time tolerance is introduced:
  two or more features validate one specific annotation if their retention
  time are not very much different. This rt tolerance is also defined in
  the settings (the \code{rtval} field). As a general suggestion,
  \code{rtval} should be kept smaller than \code{rttol}. The latter,
  indeed, refers to the matching of a peaktable with a database which
  has been created from the injections of the chemical standards during
  different instrumental runs (maybe also with different columns). On
  the other hand, \code{rtval} accounts for smaller retention time
  shifts, occurring within the same LC run. 

  For the description of the structure of the DB, refer to the help of the
  \code{LCDBtest} dataset.   
}
\value{
  A list with the following elements
  \item{annotation.table}{A \code{data.frame} withe the results of the
    annotation and the reference to the DB} 
  \item{compounds}{The names of the annotated compounds}
  \item{IDs}{The IDs of the annotated compounds}
  \item{multiple.annotations}{The features with multiple annotations}
  \item{ann.features}{The features with annotation}
}
\references{
N. Shahaf, P. Franceschi, P. Arapitsas, I. Rogachev, U. Vrhovsek and
R. Wehrens: "Constructing a mass measurement error surface to improve
automatic annotations in liquid chromatography/mass spectrometry based
metabolomics". Rapid Communications in Mass Spectrometry, 27(21), 2425
(2013).}
\author{Pietro Franceschi}
\examples{
## Example of results
  data(GCresults) ## pre-compiled results
  GCresults$PeakTable
}
\keyword{manip}

\name{runCAMERA}
\alias{runCAMERA}
\title{The CAMERA element in the metaMS pipeline}
\description{
  Run CAMERA package with settings from the settings list (see
  \code{FEMsettings}). Works both for LC and GC. Not meant to be called
  directly by the user.
}
\usage{
runCAMERA(xset, chrom = c("LC", "GC"), settings, polarity, quick = TRUE)
}
\arguments{
  \item{xset}{For LC, an \code{xcmsSet} object; for GC, a list of
    \code{xcmsSet} objects.}
  \item{chrom}{
    The type of chromatography. Either "LC" or "GC".}
  \item{settings}{
    The subset of settigs contained into the "CAMERA" element of the
    settings list.}
  \item{polarity}{
    The polarity of the injection, used by CAMERA to look for common
    adducts.}
  \item{quick}{Only relevant for LC data.
    If \code{TRUE}, CAMERA runs only \code{groupFWHM} and
    \code{findIsotopes}. If \code{FALSE}, correlations between EICs are
    calculated and used for grouping (which can take some time).
  }
}
\details{
  In the case of LC the function is used in data analysis and DB
  creation. In the first case, it increases the level of the annotation
  and it it, by default, run with \code{quick} = \code{TRUE}. For DB
  creation, the grouping of the features into "pcgroups" (features with
  similar retention time) is used to choose the features to be included
  into the database. In this case camera is run with \code{quick} =
  \code{FALSE}: \code{quick} determines whether or not the correlation
  among the extracted ion chromatograms should be used to "validate" the
  pcgroups.

  For GC data, only the grouping done by \code{groupFWHM} is performed:
  basically this clusters peaks with a similar retention time.
}
\value{
  An annotated xcmsSet object (an object of class CAMERA).}
\seealso{\code{\link{annotate}}, \code{\link{groupFWHM}}}
\author{Ron Wehrens and Pietro Franceschi}
\examples{
## Example of results
  data(LCresults) ## pre-compiled results
  LCresults$PeakTable
}
\keyword{manip}

\name{processStandards}
\alias{processStandards}
\title{Process input files containing raw data for pure standards.}
\description{Peak picking and further processing for raw data of pure
  standards, including CAMERA processing. This function is not meant to be
  called directly - use \code{createSTDdbLC} or \code{createSTDdbGC}
  instead.}
\usage{processStandards(stdInfo, settings, polarity = NULL, nSlaves)}
\arguments{
  \item{stdInfo}{Object describing the pure standards: a data.frame
    containing, e.g., the name of the file, the name of the standard,
    descriptors like CAS or Chemspider IDs, etcetera.}
  \item{settings}{Settings list, containing sublists for peak picking
    and CAMERA grouping (GC-MS) or annotation (LC-MS).}
  \item{polarity}{Polarity of the analysis (used for CAMERA). Possible
    values are \dQuote{positive} or \dQuote{negative}. Ignored for GC-MS.}
  \item{nSlaves}{Number of cores to be used in peak picking.}
}
\value{
  A list of CAMERA objects resulting from the analysis of the
  standard injections listed in the \code{stdInfo} table.
}
\author{Ron Wehrens and Pietro Franceschi}
\seealso{\code{\link{xcmsSet}}, \code{\link{runCAMERA}}}
\examples{
## Example of results
  data(GCresults) ## pre-compiled results
  GCresults$PeakTable
}
\keyword{manip}

\name{alignmentLC}
\alias{alignmentLC}
\title{LC alignment}
\description{
Performs grouping and retention time correction via \code{xcms}. The
settings are specified as a list with a form similar to the one
discussed in the help of \code{FEMsettings}. The sequence of actions depends on the 
type of retention time correction, which is specified inside the \code{Retcor} list inside the 
\code{Alignment} slot (see details). 
Integration of areas of missing peaks is performed depending on the \code{fillPeaks} setting.
}
\usage{alignmentLC(xset, settings)}
\arguments{
  \item{xset}{
    The \code{xcmsSet} object resulting from peak detection
  }
  \item{settings}{
    The subset of settings contained into the "Alignment" element of the
    XCMSsettings list.
  }
}
\details{
  The sequence of actions depends on the algorithm used by \code{xcms} for retention
  time correction. For the density-based approach the sequence is: 1) across sample grouping, 
  2) retention time correction, 3) second across sample grouping, 4) optional fill-peaks. 
  For "obiwarp", instead, the sequence of actions is: 1) retention time correction, 
  2) across sample grouping, 3) optional fill-peaks.
  For across-sample grouping in \code{xcms}, the \code{minsamp} parameter can be
  specified in the settings either as a minimum number of samples
  (\code{min.class.size}) or as the fraction of samples per class
  (\code{min.class.fraction}). If both are given the smallest number is
  used. 
  If the retention time correction is performed by the density-based approach, 
  the settings allow to express the \code{xcms} parameters \code{missing} and \code{extra} as fractions. 
  When "obiwarp" is used for retention time correction, the sample with the bigger
  number of features is automatically selected as the "reference" sample.  
  The \code{xcms} parameters for the \code{retcor} \code{xcms} function can be specified
  in the Retcor list included in the Alignment slot of \code{FEMsettings}. 
}
\seealso{\code{\link{FEMsettings}}}
\value{A grouped and rt-aligned \code{xcmsSet} object.}
\author{Ron Wehrens and Pietro Franceschi}
\examples{
## Example of results
  data(LCresults) ## pre-compiled results
  LCresults$PeakTable
}
\keyword{manip}

\name{getFeatureInfo}
\alias{getFeatureInfo}
\title{
  Construct an object containing all meta-information of the annotated
  pseudospectra (GC-MS).
}
\description{
  Function getFeatureInfo yields a data.frame with meta-information
  on all features detected in the samples. Features are rows;
  information is in the columns. Not meant to be called directly by the
  user.
}
\usage{getFeatureInfo(stdDB, allMatches, sampleList)}
\arguments{
  \item{stdDB}{In-house database of standards.}
  \item{allMatches}{Object containing annotation information, generated
    by functions like \code{matchSamples2DB} and
    \code{matchSamples2Samples}.}
  \item{sampleList}{Object containing pseudospectra of samples.}
}
\value{A \code{data.frame} summarizing all meta-information of the
  pseudospectra found in the samples. Exactly what columns are included
  depends on the information contained in the in-house database. The
  last column is always "rt". 
}
\author{Ron Wehrens}
\examples{
## Example of results
  data(GCresults) ## pre-compiled results
  GCresults$PeakTable
}
\keyword{manip}

\name{FEMsettings}
\alias{FEMsettings}
\alias{Synapt.RP}
\alias{Synapt.NP}
\alias{TSQXLS.GC}
\alias{Orbitrap.RP}
\docType{data}
\title{Example settings for \code{metaMS}}
\description{Examples of settings needed for functions \code{runLC} and
  \code{runGC}: Synapt.RP, Synapt.NP, TSQXLS.GC and Orbitrap.RP. These four
  particular settings are fine-tuned for the analysis of LC-MS runs,
  both normal-phase and reverse-phase chromatography (Waters Synapt
  G1-Thermo Orbitrap)and GC-MS experiments (ThermoXLS TQQ).
}
\usage{data(FEMsettings)}
\format{Four objects of class \code{metaMSsettings}.}
\seealso{\code{\link{findPeaks}}, \code{\link{annotate}}}
\author{Ron Wehrens and Pietro Franceschi}
\examples{
\dontrun{
## The three sets of settings are created as follows:
Synapt.NP <- metaMSsettings(protocolName = "Synapt.QTOF.NP",
                            chrom = "LC",
                            PeakPicking = list(
                              method = "matchedFilter",
                              step = 0.05,
                              fwhm = 20,
                              snthresh = 4,
                              max = 50),
                            Alignment = list(
                              min.class.fraction = .3,
                              min.class.size = 3,
                              mzwid = 0.1,
                              bws = c(130, 10),
                              missingratio = 0.2,
                              extraratio = 0.1,
                              Retcor = list(
                                method = "linear",
                                family = "symmetric"),            
                              fillPeaks = TRUE),
                            CAMERA = list(
                              perfwhm = 0.6,
                              cor_eic_th = 0.7,
                              ppm= 5))
metaSetting(Synapt.NP, "match2DB") <- list(
            rtdiff = 1.5,
            rtval = .1,
            mzdiff = 0.005,
            ppm = 5,
            minfeat = 2)
metaSetting(Synapt.NP, "DBconstruction") <- list(
            minfeat = 3,
            rttol = .3,
            mztol = .01)

## For reverse-phase LC, settings are very similar: the only difference
## is in the alignment settings
Synapt.RP <- Synapt.NP
metaSetting(Synapt.RP, "protocolName") <- "Synapt.QTOF.RP"
metaSetting(Synapt.RP, "Alignment") <- list(
            min.class.fraction = .3,
            min.class.size = 3,
            mzwid = 0.1,
            bws = c(30, 10),
            missingratio = 0.2,
            extraratio = 0.1,
            Retcor = list(
              method = "linear",
              family = "symmetric"),           
            fillPeaks = TRUE)


## For the orbitrap.RP
Orbitrap.RP <- metaMSsettings(protocolName = "Orbitrap",
                              chrom = "LC",
                               PeakPicking = list(
                                 method = "centWave",
                                 ppm = 5,
                                 prefilter = c(3,10000),
                                 peakwidth = c(15,40)),
                             Alignment = list(
                                 bws = 30,
                                 min.class.fraction = 0.3,
                                 min.class.size = 3,
                                 mzwid = 0.01,
                                 Retcor = list(
                                  method = "obiwarp",
                                  profStep = 0.2),
                                 fillPeaks = TRUE),
                             CAMERA = list(
                                 perfwhm = 0.6,
                                 cor_eic_th = 0.7,
                                 ppm = 5))
metaSetting(Orbitrap.RP, "match2DB") <- list(
            rtdiff = 1.5,
            rtval = .1,
            mzdiff = 0.005,
            ppm = 5,
            minfeat = 2)
metaSetting(Orbitrap.RP, "DBconstruction") <- list(
            minfeat = 3,
            rttol = .3,
            mztol = .01)

## For the thermo TQ

TSQXLS.GC <- metaMSsettings("protocolName" = "TSQXLS.QQQ.GC",
                            "chrom" = "GC",
                            PeakPicking = list(
                              method = "matchedFilter",
                              step = 0.5,
                              steps = 2,
                              mzdiff = .5,
                              fwhm = 5,
                              snthresh = 2,
                              max = 500),
                           CAMERA = list(perfwhm = 1))
metaSetting(TSQXLS.GC, "DBconstruction") <- list(
            minintens = 0.0,
            rttol = .1,
            intensityMeasure = "maxo",
            DBthreshold = .80, 
            minfeat = 5)
metaSetting(TSQXLS.GC, "match2DB") <- list(
            simthresh = 0.80,
            timeComparison = "rt",
            rtdiff = .5,
            RIdiff = 5,
            minfeat = 2)
metaSetting(TSQXLS.GC, "matchIrrelevants") <- list(
            irrelevantClasses = c("Bleeding", "Plasticizers"),
            timeComparison = "rt",
            RIdiff = 2,    
            rtdiff = .05,
            simthresh = 0.70)
metaSetting(TSQXLS.GC, "betweenSamples") <- list(
            min.class.fraction = .5,
            min.class.size = 5,
            timeComparison = "rt",
            rtdiff = .05,
            RIdiff = 2,    
            simthresh = .95)              
}
}
\keyword{datasets}

\name{msp}
\alias{msp}
\alias{construct.msp}
\alias{write.msp}
\alias{read.msp}
\alias{filter.msp}
\alias{xset2msp}
\alias{to.msp}
\alias{SearchNIST}
\title{Functions to handle msp-type objects (GC-MS)}
\description{
  Functions to construct, read, write and filter so-called msp
  objects, collections of spectra with additional information. This
  other information is of free format, but typically
  contains fields like \dQuote{Name}, \dQuote{CAS},
  \dQuote{ChemspiderID}, and \dQuote{rt}. 
}
\usage{
construct.msp(spectra, extra.info)
read.msp(file, only.org = FALSE,
         org.set = c("C", "H", "D", "N", "O", "P", "S"), noNumbers = NULL)
filter.msp(msp, rtrange = NULL, mzrange = NULL, minintens = 0, minPeaks = 0)
write.msp(msp, file, newFile = TRUE)
xset2msp(xsetList, settings)
to.msp(object, file = NULL, settings = NULL, ndigit = 0, 
       minfeat, minintens, intensity = c("maxo", "into"),
       secs2mins = TRUE)
SearchNIST(mspfile=NULL, savepath=NULL)
}
\arguments{
  \item{spectra}{a list of two-column or three-column numerical
    matrices. Two-column matrices only contain mz and intensity
    information, three-column matrices have a third column that gives
    retention times for the individual peaks.}
  \item{extra.info}{a nested list containing all other slots that should be
    included in the msp object. The length of this list should be equal
    to the number of spectra in the first argument.}
  \item{file}{name of input or output file containing data in msp
    format. If NULL in function \code{to.msp}, the input object is
    returned as an msp object. If non-null, the information will be
    written to the file with this name.} 
  \item{only.org}{logical: if TRUE this will skip all entries that have
    non-organical elements in the \dQuote{Formula} field.}
  \item{org.set}{List of elements to be considered as organic.}
  \item{noNumbers}{Optional argument, indicating which fields are not to
    be converted into numeric entries. If not given, this currently
    defaults to the following fields: \code{Name}, \code{CAS},
    \code{stdFile}, \code{date}, \code{validated},
    \code{ChemspiderID}, \code{SMILES}, \code{InChI},
    \code{Class}, \code{comment}, \code{csLinks}.}
  \item{msp}{msp object.}
  \item{rtrange, mzrange, minfeat, minintens, minPeaks}{restrictions to
    what constitutes genuine pseudospectra in terms of minimal numbers
    of features, minimum feature intensity, and the intensity measure
    used (peak area or peak height).}
  \item{intensity}{the measure to use for the intensity of a peak:
    either the peak height ("maxo") or area ("into").}
  \item{ndigit}{number of digits for the mz values - use 0 for nominal
    mass data.}
  \item{newFile}{logical: if TRUE starts a new file, otherwise appends.}
  \item{xsetList}{a list of xcmsSet objects.}
  \item{settings}{list containing settings.}
  \item{object}{either an object of class "xsAnnotate" or a peaktable
    containing mz, rt and I information. Function \code{to.msp} will
    convert this object into a list that can be written as an msp file.}
  \item{secs2mins}{logical: if TRUE converts retention times to minutes
    (otherwise seconds).}
  \item{mspfile}{a msp file generated by \code{to.msp} function}
  \item{savepath}{Path to the directory were NIST MSsearch program results will be saved}
}
\details{
  Even though the msp format handled by these functions is quite
  flexible, there are a couple of requirements that are not always
  satisfied by msp files generated by other software, the most important
  one being that one line may only contain one keyword. If more than one
  keyword is present, the second will likely not be read. Furthermore,
  the current implementation assumes that peaks in pseudospectra are
  represented in the form mz1, I1; mz2, I2;, etcetera - in other cases
  these are in brackets. To solve such issues, the most easy fix for the
  moment is to edit the msp file and change things globally.

  Other issues may arise with the keywords. While read.msp will be able
  to read msp files with non-standard keywords, the metaMS package
  expects at least the following list to be present (case-sensitive):
  \dQuote{Name}, \dQuote{validated}, \dQuote{CAS}, \dQuote{rt},
  \dQuote{monoMW}, and \dQuote{Class}. The final 
  keyword is always \dQuote{Num Peaks}, and should be followed by the list of
  mz-I combinations.
}
\value{
    Most of the functions here create msp files.
}
\author{Ron Wehrens}
\examples{
data("threeStdsDB")
\dontrun{
write.msp(DB, file = "huhn.msp")
DB2 <- read.msp("huhn.msp")
}
}
\keyword{manip}

\name{metaSetting-methods}
\docType{methods}
%\alias{metaSetting-methods}
\alias{metaSetting}
\alias{metaSetting<-}
\alias{metaSetting,metaMSsettings-method}
\alias{metaSetting<-,metaMSsettings-method}
\title{Get or set values in metaMSsettings objects}
\description{
  Accessor function for \code{metaMSsettings} objects, allowing to get
  or set values from individual slots.
}
\section{Methods}{
  \describe{
\item{\code{signature(object = "metaMSsettings")}}{
  Get or set values from individual slots in a \code{metaMSsettings} objects.
}
}}
\seealso{\code{\link{FEMsettings}}}
\examples{
\dontrun{
## The three sets of settings are created as follows:
Synapt.NP <- metaMSsettings(protocolName = "Synapt.QTOF.NP",
                            chrom = "LC",
                            PeakPicking = list(
                              method = "matchedFilter",
                              step = 0.05,
                              fwhm = 20,
                              snthresh = 4,
                              max = 50),
                            Alignment = list(
                              min.class.fraction = .3,
                              min.class.size = 3,
                              mzwid = 0.1,
                              bws = c(130, 10),
                              missingratio = 0.2,
                              extraratio = 0.1,
                              retcormethod = "linear",
                              retcorfamily = "symmetric",            
                              fillPeaks = TRUE),
                            CAMERA = list(
                              perfwhm = 0.6,
                              cor_eic_th = 0.7,
                              ppm= 5))
metaSetting(Synapt.NP, "match2DB") <- list(
            rtdiff = 1.5,
            rtval = .1,
            mzdiff = 0.005,
            ppm = 5,
            minfeat = 2)
metaSetting(Synapt.NP, "DBconstruction") <- list(
            minfeat = 3,
            rttol = .3,
            mztol = .01)
}
}
\keyword{methods}

\name{plotPseudoSpectrum}
\alias{plotPseudoSpectrum}
\title{Plot a pseudospectrum.}
\description{
Auxiliary function for plotting a particular pseudospectrum. M/z
values are in the first column of the matrix, and an intensity
measure (either maxo, into or something else) in the second. The third
column is disregarded, usually contains retention time information
}
\usage{
plotPseudoSpectrum(psspc, ...)
}
\arguments{
  \item{psspc}{Pseudospectrum, consisting of a two- or three-column
    matrix. The first column contains the m/z values, the second the
    intensities. A third column containing retention time information
    may be present, but is not used in this function.}
  \item{\dots}{Additional graphical parameters.}
}
\details{A stick spectrum is shown on the graphical device.}
\value{
    A three column matrix m/z and Intensity and Retention time.
}
\author{Ron Wehrens}
\examples{
data("threeStdsDB")
plotPseudoSpectrum(DB[[1]]$pspectrum)
}
\keyword{manip}

\name{getPeakTable}
\alias{getPeakTable}
\title{Extract a peak table from an xcms or CAMERA object}
\description{
  Extracts the peak table (a \code{data.frame}) from an xcms (or CAMERA)
  object (without compound annotation). The peak table contains the mass
  and retention time for all the features and their intensities across
  the samples.  This function is not meant to be called directly, but it
  is internally used by \code{runLC}, \code{getAnnotationLC},
  \code{createSTDdbLC}.
}
\usage{
getPeakTable(xs, intval = "into")
}

\arguments{
  \item{xs}{
    The xcmsSet (or CAMERA) object}
  \item{intval}{
    The intensity measure extracted form \code{xs}.}
}
\details{
  The function process an \code{xs} object and returns for it a
  PeakTable which associates intensities to features and samples. The
  default measure for the intensity is \code{into} (the chromatographic
  peak area for a feature), but in the case of annotation, \code{maxo}
  (value for the intensity of the ion over the chromatographic peak) is
  used to measure the intensity. For a more detailed description of the
  possible intensity measures refer to the documentation of \code{xcms]}.
}
\value{
  A data frame with the intensity for each feature (rows) in all the
  samples (columns). Each feature is identified by its m/z value and
  retention time (in minutes). If the \code{xs} object is of class
  CAMERA, the results of the camera annotation (isotope, adduct,
  pcgroup) are included in the table.  
}
\author{Pietro Franceschi}
\examples{
## Example of results
  data(LCresults) ## pre-compiled results
  LCresults$PeakTable
}
\keyword{manip}

\name{annotations2tab}
\alias{annotations2tab}
\alias{makeAnnotation}
\title{Conversion of a list of annotation results into a table}
\description{
  Function \code{annotations2tab} converts the output of
  \code{matchSamples2DB} into a table, in the case of multiple DB hits
  for one pseudospectrum distinguishing the \dQuote{best} hit from the
  \dQuote{alternative} hits. Function \code{makeAnnotation} prepares a
  \code{data.frame} object with the correct number of rows. Both functions are
  not meant to be called directly by the user.
}
\usage{
annotations2tab(annlist, matches)
makeAnnotation(n)
}
\arguments{
  \item{annlist}{Annotation list, output of \code{matchSamples2DB}.}
  \item{matches}{Object containing all match factors - needed to
    distinguish the best match from the rest in the case of a double
    annotation.}
  \item{n}{Number of rows in the annotation \code{data.frame} (possibly zero).}
}
\value{A three-column \code{data.frame}, containing the numbers of the
  pseudospectrum in the experimental data, the numbers of the
  best hits in the DB, and finally the alternative hits ain the DB}
\author{Ron Wehrens}
\keyword{manip}

\name{treat.DB}
\alias{treat.DB}
\title{Scaling of pseudospectra in an msp object}
\description{
  This function transforms the \dQuote{raw} data in an msp DB object into
  preprocessed data. Even if no scale and no mass.weight is applied,
  the intensities are still changed: scaled to unit length.}
\usage{
treat.DB(DB, scale.p = c("sqrt", "none"), mass.weight = TRUE, isMSP = TRUE)
}
\arguments{
  \item{DB}{A database of spectra in the original intensity units.}
  \item{scale.p}{scale intensities with a square-root function, or leave
    them as they are. Default is to use scaling.}
  \item{mass.weight}{Logical: if TRUE, higher masses are given more
    weight.}
  \item{isMSP}{Logical: if TRUE, then the spectra are stored in slot
    \code{pspectrum}; otherwise the spectra are simply the list
    elements of \code{DB}.}
}
\value{
  The function returns the database, where intensities are scaled.
}
\author{Ron Wehrens}
\examples{
data(threeStdsNIST)  ## provides object smallDB, excerpt from NIST DB
smallDB.scaled <- treat.DB(smallDB)
}
\keyword{manip}

\name{peakDetection}
\alias{peakDetection}
\title{Wrapper for XCMS peak detection, to be used for both GC-MS and
  LC-MS data.}
\description{XCMS peak detection using settings, defined for individual
  laboratories and depending on the chromatographic and
  mass-spectrometric characteristics of the instruments at hand.}
\usage{
peakDetection(files, settings, rtrange = NULL, mzrange= NULL,
              convert2list = FALSE, nSlaves = 0) 
}
\arguments{
  \item{files}{input files (including path names) that will be processed
    by xcms.}
  \item{settings}{a list of settings that will be passed on to the
    xcmsSet function. See the help of \code{FEMsettings} for a detailed
    description of the fields in this list.} 
  \item{rtrange}{If non-NULL, a vector to subset the region of the
    chromatography retained for further analysis (given in minutes).}
  \item{mzrange}{If non-NULL, a vector indicating the subset of the
    mass spectrum retained for the analysis.}
  \item{convert2list}{logical. If \code{TRUE}, the xcmsSet object will
    be split into a list of one-sample objects which will be treated
    separately. This is useful not only in GC-MS data, where peak
    alignment is avoided, but also in setting up databases of standards,
    where no common peaks between injections are expected to occur.}
  \item{nSlaves}{Number of cores to be used in the peak picking.}
}
\value{Either an xcmsSet object, or a list of one-sample xcmsSet objects.}
\author{Ron Wehrens and Pietro Franceschi}
\examples{
## Example of settings
  data(FEMsettings)
  metaSetting(object = TSQXLS.GC, field= "PeakPicking")
}
\keyword{manip}

\name{matchSamples2DB}
\alias{matchSamples2DB}
\title{Match pseudospectra from several samples to an in-house DB (GC-MS)}
\description{Compare experimental results to a database of
  pseudospectra. The result is a nested list, containing for every
  pseudospectrum in every sample either an index of a corresponding
  pattern in the DB (if a hit is found) or nothing (if no hit is
  found). Not meant to be called directly by the user.}
\usage{matchSamples2DB(xset.msp, DB, settings, quick)}
\arguments{
  \item{xset.msp}{An object containing a list of pseudospectra.}
  \item{DB}{The in-house database.}
  \item{settings}{The settings, in the form of a list.}
  \item{quick}{Logical. If TRUE, scaling of the pseudospectra (which is
    necessary for comparing to the database) will be done once using all
    masses in the pseudospectrum. This mode is routinely applied when
    comparing with a database of artefacts such as bleeding patterns or
    plasticizers. When comparing with a database of chemical standards,
    however, only peaks smaller than the molecular weight (+ 4, to allow
    for isotopes) should be taken into account in the scaling, and hence
    the scaling needs to be re-done for every comparison. This is _not_
    so quick...}
}
\value{A list object, with one element for each experimental
  sample. Every element again is a list with an entry for each
  pseudospectrum from that sample: if the element is empty, there is no
  match with the DB - a number points to the DB entry that gives a
  hit. Elements can contain more than one number; these will be split
  into one \dQuote{best} annotation and \dQuote{alternative} annotations
  in function \code{annotations2tab}.
}
\author{Ron Wehrens}
\examples{
## Example of settings
  data(FEMsettings)
  metaSetting(object = TSQXLS.GC, field= "match2DB")
}
\keyword{manip}

\name{getAnnotationMat}
\alias{getAnnotationMat}
\alias{relInt}
\title{Obtain relative quantitative annotation results for GC-MS}
\description{
Function \code{getAnnotationMat} obtains relative intensities for features
in individual samples. A robust linear regression is performed
when the number of common features is five or larger; for 2-4 peaks
a weighted linear regression is used, and if only one peak is in
common the intensity ratio for this peak is used. Reference patterns are
the patterns in the database of standards or the patterns in the
\dQuote{unknowns} element of the \code{allMatches} object. Not meant to
be called directly by the user.
}
\usage{
getAnnotationMat(exp.msp, pspectra, allMatches)
relInt(pat, refpat)
}
\arguments{
  \item{exp.msp}{List of experimental pseudospectra.}
  \item{pspectra}{Spectra from the in-house database.}
  \item{allMatches}{Match information in the form of a list.}
  \item{pat, refpat}{Both pseudospectra.}
}
\value{Function \code{getAnnotationMat} returns a matrix containing all
  patterns (standards as well as unknowns) in the rows, and numeric
  values signifying relative intensities in all samples in the
  columns. These relative intensities are the quantities calculated by
  \code{relInt}, which simply returns one number.
}
\author{Ron Wehrens}
\examples{
## Example of results
  data(GCresults) ## pre-compiled results
  GCresults$PeakTable
}
\keyword{manip}

\name{constructExpPseudoSpectra}
\alias{constructExpPseudoSpectra}
\title{
  Create a list of all pseudospectra found in a GC-MS experiment of
  several samples.}
\description{
  Function constructExpPseudoSpectra creates an msp object containing all
  the patterns referenced to in the annotation. The first argument is
  the output of function matchSamples2Samples and contains the full
  annotation matrix and the pseudospectra of the known unknowns; the
  second is the msp object containing the standards that are actually found.
  Not meant to be called directly by the user.}
\usage{constructExpPseudoSpectra(allMatches, standardsDB)}
\arguments{
  \item{allMatches}{Result of a call to \code{matchSamples2DB} or
    \code{matchSamples2Samples}: a list containing the element
    \code{annotation}.}
  \item{standardsDB}{Database of standard spectra, in msp format.}
}
\value{A list of spectra. All spectra from the database that are
  referenced to in the annotation slot will be present, and will be
  followed by all unknown spectra. In order to be able to see which
  patterns in the experimental data are pointing to which spectra, an
  extra slot \code{DB.id} is added, containing the position of the
  reference spectrum in the original database (which is what the numbers
  of the annotation object are referring to). Renumbering this is
  impractical since some patterns may be seen as alternative
  annotations, but may have no hits of their own - including them would
  lead to rows containing only zeros.
}
\author{Ron Wehrens}
\seealso{\code{\link{matchSamples2DB}}, \code{\link{matchSamples2Samples}}}
\examples{
## Example of results
  data(GCresults) ## pre-compiled results
  GCresults$PseudoSpectra
}
\keyword{manip}

\name{getAnnotationLC}
\alias{getAnnotationLC}
\title{Get LC annotation}
\description{Main function for the annotation of an xcmsSet or CAMERA
  object. This function is not meant to be called directly. Use
  \code{runLC} instead.}
\usage{
getAnnotationLC(xs, settings, DB, errf)
}
\arguments{
  \item{xs}{
    The xcmsSet (or CAMERA) object to be annotated.}
  \item{settings}{
    The subset of settings contained into the match2DB elements of the
    settings list. See the help of \code{FEMsettings} for details.}
  \item{DB}{
    The database used within \code{AnnotateTable} for the annotation of
    the peaklist. See the help of \code{FLCDBtest} for details.}
  \item{errf}{
    The file containing the error function used to predict the m/z
    tolerance. See the help of \code{AnnotateTable} for details.}
}
\details{
  The function extracts from the \code{xs} object a Peaktable with the
  intensities of the features across all the samples. Since this
  Peaktable is meant to be used only for annotation (and not for
  subsequent statistical analysis), the intensities are expressed
  as\code{maxo} - the absolute maximum of the signal over the detected
  chromatographic peak (see the documentation of xcms for more
  details). Within the function the peaktable is converted into a matrix
  in the form \code{(mz,rt,I)} used by \code{AnnotateTable}. If
  \code{xs} contains more than one  sample, the intensity is the maximum
  intensity of each feature across all the samples.
}
\value{
  A list with two elements. \code{raw} is the complete output of
  \code{AnnotateTable}. \code{for_table} is a \code{data.frame} which
  summarizes the outputs of the annotation (see \code{AnnotateTable})
  and it is included in the output of the \code{runLC} main function. 
}
\references{
  N. Shahaf, P. Franceschi, P. Arapitsas, I. Rogachev, U. Vrhovsek and
  R. Wehrens: "Constructing a mass measurement error surface to improve
  automatic annotations in liquid chromatography/mass spectrometry based
  metabolomics". Rapid Communications in Mass Spectrometry, 27(21), 2425
  (2013). 
}
\author{
  Pietro Franceschi
}
\seealso{
  \code{\link{AnnotateTable}}, \code{\link{LCDBtest}}, \code{\link{FEMsettings}}
}
\examples{
## Example of results
  data(LCresults) ## pre-compiled results
  LCresults$PeakTable
}
\keyword{manip}

\name{runGC}
\alias{runGC}
\title{Wrapper for processing of GC-MS data files}
\description{
  Main function of the pipeline for GC-MS data processing. It includes
  XCMS peak detection, definition of pseudospectra, and compound
  identification by comparison to a database of standards. The function
  also takes care of removal of artefacts like column bleeding and
  plasticizers, and definition of unknowns, consistently present across
  samples.}
\usage{
runGC(files, xset, settings, rtrange = NULL, DB = NULL,
      removeArtefacts = TRUE, findUnknowns = nexp >= mcs,
      returnXset = FALSE, RIstandards = NULL, nSlaves = 0)
      
}
\arguments{
  \item{files}{input files, given as a vector of strings containing the
    complete paths. All formats supported by XCMS can be used.}
  \item{xset}{alternatively, one can present a list of xcmsSet objects
    for whom CAMERA grouping has been done. In this case, only the
    annotation process will be done. If both \code{files} and
    \code{xset} are given, the former takes precedence.}
  \item{settings}{a nested list of settings, to be used at individual
    steps of the pipeline.}
  \item{rtrange}{part of the chromatograms that is to be analysed. If
    given, it should be a vector of two numbers indicating minimal and
    maximal retention time (in minutes).}
  \item{DB}{database containing the spectra of the pure standards. At
    least the following fields should be present: \code{Name},
    \code{std.rt}, \code{pspectrum} and \code{monoMW}.}
  \item{removeArtefacts}{logical, whether or not to remove patterns
    identified as (e.g.) column bleeding. Only performed if a database
    containing such patterns is available.}
  \item{findUnknowns}{logical, whether to find patterns without
    identification that are present consistently in several samples. The
    default is to use TRUE if the number of samples is larger than the
    min.class.size setting in the 'betweenSamples' metaSetting.}
  \item{returnXset}{logical: should the XCMS output be returned? If yes,
    this is a a list of \code{xcmsSet} objects, one element for each
    input file.}
  \item{RIstandards}{A two-column matrix containing for the standards
    defining the RI scale both retention times and retention indices. If
    not given, no RI values will be calculated and retention times will
    be used instead.}
  \item{nSlaves}{Number of cores to be used in peak picking.}
}

\value{
A list with the following elements:
\item{PeakTable}{data.frame containing annotation information. Every
  line is a feature, i.e. a pseudospectrum. The first columns are used
  to give information about these features, a.o. compound name, CAS and
  Chemspider IDs, etcetera. The last of these meta-information columns
  is always the one giving the retention time: \dQuote{rt}. After that,
  columns 
  correspond to input files, and give measures of intensities for every
  single one of the features. If a feature is not detected in a sample,
  this is indicated with \dQuote{0} (zero).} 
\item{PseudoSpecra}{A list of pseudospectra in msp format, in the
  same order as the rows in the PeakTable.}
\item{xset}{optionally, the xcmsSet object is returned, which can be
  useful for more detailed inspection of the results. It can also be
  used as an input for \code{runGC}, e.g., to test different annotation
  settings independently of the xcms/CAMERA part.}
\item{sessionInfo}{The output of \code{sessionInfo()} to keep track of the sw
  version used for the processing}
}
\references{
  R. Wehrens, G. Weingart and F. Mattivi: "An open-source pipeline for
  GC-MS-based untargeted metabolomics". Submitted.
}
\author{Ron Wehrens}
\seealso{\code{\link{msp}}, \code{\link{treat.DB}},
  \code{\link{runCAMERA}},
  \code{\link{peakDetection}}, \code{\link{matchSamples2DB}},
  \code{\link{matchSamples2Samples}},
  \code{\link{getAnnotationMat}}, \code{\link{addRI}}}
\examples{
## analysis of an xset object
data(threeStdsDB) 
data(FEMsettings)

data(GCresults) ## pre-compiled results
names(GCresults)

\dontrun{
if (require(metaMSdata)) {
  ## object GCresults is created by
  cdfdir <- system.file("extdata", package = "metaMSdata")
  cdffiles <- list.files(cdfdir, pattern = "_GC_",
                         full.names = TRUE, ignore.case = TRUE)
  GCresults <- runGC(files = cdffiles, settings = TSQXLS.GC, DB = DB,
                     returnXset = TRUE)

  ## to start directly from the XCMS/CAMERA results and not include
  ## peak picking in the pipeline, simply provide the "xset" argument
  ## rather than the "files" argument.

  ## no annotation database
  result.noannot <- runGC(xset = GCresults$xset, settings = TSQXLS.GC)
  }
}
}
\keyword{manip}

\name{LCresults}
\alias{LCresults}
\alias{LCxset}
\docType{data}
\title{Result metaMS for a small LC-MS data set}
\description{This data file contains the result of
  applying the metaMS pipeline to a small LC-MS data set consisting of
  repeated injections of a set of chemical standards. Its aim is to
  demonstrate the structure of the outcomes without
  having to do the slightly time-consuming calculations.
}
\usage{data(LCresults)}
\details{Data object \code{LCresult} contains the output list of
  \code{runLC}.}
\keyword{datasets}

\name{GCresults}
\alias{GCresults}
\docType{data}
\title{Results of metaMS for a small GC-MS data set}
\description{This data file contains the results of
  applying the metaMS pipeline to a small GC-MS data set consisting of
  repeated injections of a set of chemical standards. Its aim is to
  demonstrate the structure of the (intermediate) outcomes without
  having to do the slightly time-consuming calculations.
}
\usage{data(GCresults)}
\details{Data object GCresults is the result of a complete execution of
  \code{runGC}, using the example database for annotation purposes.}
\seealso{\code{\link{runGC}}}
\keyword{datasets}

\name{exptable}
\alias{exptable}
\docType{data}
\title{Sample table for the generation of a database of standards (LCMS)}
\description{An example of a table used to construct a database of
  standards. This particular table is used to obtain object \code{LCDBtest}.}
\usage{data(exptable)}
\format{
  \code{exptable} is a \code{data.frame} summarizing information on the
  chemical standards used for creating a database.
  
  Column description:
  \describe{
    \item{ChemSpiderID}{The Chemspider ID of a specific compound.}
    \item{compound}{A string containing the (human) readable name of the
      compound.} 
    \item{formula}{The formula of the compound.}
    \item{M.ref}{The theoretical value for the observed m/z reference
      ion. This can be, for example, the protonated (de-protonated) molecular
      ion, a known adduct or a characteristic fragment.}
    \item{mz.observed}{The manually validated m/z value of the reference
      ion.} 
    \item{RTman}{The manually validated retention time value for the standard.}
    \item{stdFile}{The name (including the path) of the raw data file of the
      standard.} 
  }
}

\details{
  Mandatory fields are: \code{ChemSpiderID}, \code{mz.observed},
  \code{RTman}, and \code{stdFile}.

  In the current implementation the \code{M.ref} value is not used in the
  creation of the DB. The difference between \code{M.ref} and
  \code{m.observed}, however, could be used to construct the mass error
  surface used during feature annotation. 
 
  The sample table is also an element (\code{Reftable}) of the LCDB list
  generated by \code{createSTDdbLC}.
}
\seealso{\code{\link{createSTDdbLC}}}
\author{Pietro Franceschi}
\keyword{datasets}

\name{addRI}
\alias{addRI}
\title{Add retention index information to an msp object}
\description{
Given an msp object and the retention times and indices of a series of
reference compounds, the function adds an RI field to every entry of the
msp object. This will only be done if there is not already an RI field:
existing information will not be overwritten.
}
\usage{
addRI(mspobj, RIstandards, isMSP = TRUE)
}
\arguments{
  \item{mspobj}{An msp object.}
  \item{RIstandards}{A two-column matrix containing for the standards
    defining the RI scale both retention times and retention indices.}
  \item{isMSP}{Logical: if TRUE, then the spectra are stored in slot
    \code{pspectrum}; otherwise the spectra are simply the list
    elements of \code{DB} - matrices with three columns.}
}
\value{An msp object, now also containing an RI slot.}
\author{Ron Wehrens}
\note{If the retention time of a compound is outside the range of the RI
  standards, NA will be used as RI value.
}
\examples{
if (require(metaMSdata)) {
  manual.fname <- list.files(system.file("extdata", package = "metaMSdata"),
                             pattern = "msp", full.names = TRUE)
  manual <- read.msp(manual.fname)
  RIstandards <- cbind("rt" = c(1.54, 1.68, 1.99, 2.7, 4.36, 6.81, 9.43,
                                11.88, 14.17, 16.34, 18.39, 20.33, 22.18,
                                23.93, 25.5, 27.18, 28.72, 30.26, 31.75,
                                33.19, 34.58, 35.95),
                       "RI" = (6:27)*100)

  manualRI <- addRI(manual, RIstandards)
}
}
\keyword{manip}

\name{createSTDdbLC}
\alias{createSTDdbLC}
\alias{generateStdDBLC}
\title{Create an in-house database for LC-MS annotation}
\description{
For creating an in-house instrument-specific annotation database,
injections of pure standards need to be processed. For each standard the
analyst provides a validated reference value for retention time and m/z,
generally corresponding to the major ionic signal for this compound. On
the bases of this data, the database is constructed by automatically
extracting the features identified in the vicinity of the retention time
of the standard. \cr
The function \code{generateSTDdbLC} is not meant to be
  called directly - use \code{createSTDdbLC} instead.}
\usage{
createSTDdbLC(stdInfo, settings, polarity, Ithr = 10, nSlaves = 0)
generateStdDBLC(stdxsets, settings, Ithr) 
}
\arguments{
  \item{stdInfo}{Information of the standards, given in the form of a
    data.frame. Minimal information: \code{stdFile}, \code{compound},
    \code{ChemSpiderID}, observed m/z (\code{mz.observed}), and
    retention time in miutes (\code{RTman}). The filenames in slot
    \code{stdFile} should include path information.}
  \item{settings}{A list of settings, to be used in peak picking and
    pattern comparison (see details).}
  \item{polarity}{The polarity of the injection: "positive" or "negative"}
  \item{Ithr}{The intensity threshold used to decide weather or not a
    feature should be included in the DB. Typically acting on the
    \code{maxo} value.}
  \item{stdxsets}{A list of CAMERA objects resulting from the analysis
    (performed by \code{processStandards}) of the standard injections
    listed in the \code{stdInfo} table.}
  \item{nSlaves}{Number of cores to be used in peak picking.}
}
\details{
 The DB is created with the following workflow. Peak picking is
 performed on each standard file by using the settings specified in the
 settings list. CAMERA is used to group together the different features
 by considering their retention time and the correlation among the  
 extracted ion traces. The list of features is searched looking for the
 values for mz and Rt included in the \code{stdInfo} table (see the help
 of \code{exptable} for more details), with the mass and retention time
 tolerances specified in the "DBconstruction" element of the settings
 list. In presence of positive match for the feature \code{f}, a
 spectral fingerprint is constructed by using all the features with an
 intensity bigger than \code{Ithr} which are in the same pcgroup of
 \code{f}. A match is retained only if the spectral fingerprint is
 composed of more than \code{minfeat} elements. This parameter is also
 included in the list of settings.
}
\value{A list with three elements. 
  \item{Reftable}{the original table used for the creation of the DB.} 
  \item{Info}{a list with the settings used for the DB generation and
    the date.}
  \item{DB}{the DB which can be used in \code{runLC} for annotation.}
} 
\author{Pietro Franceschi}
\examples{
if (require(metaMSdata)) {
  ##  load the manually curated table for the standards
  data(exptable)
  ## add location of cdf file from which the standards DB is going to be
  ## built - this depends on your platform and requires the metaMSdata package
  cdfpath <- system.file("extdata", package = "metaMSdata")
  
  ## files 
  files <- list.files(cdfpath, "_RP_", full.names=TRUE)
  
  ## get the complete names for the files
  exptable$stdFile <-
    sapply(exptable$stdFile,
           function(x)
           files[grep(x,files)])
  
  \dontrun{
  ## load the settings for the analysis
  data(FEMsettings)
  
  ## set the minimum number of features to 2
  metaSetting(Synapt.RP, "DBconstruction")$minfeat  <- 2
  
  ## create the DB
  LCDBtest <- createSTDdbLC(stdInfo=exptable, 
                            settings = Synapt.RP,
                            polarity = "positive",
                            Ithr = 20)
  }                 
  ## saved in "LCDBtest.RData" in the data directory of the metaMS
  ## package
}

  
}
\keyword{manip}
